/*!
 * Copyright (c) 2014 ENEO Tecnología S.L.
 * This file is part of redBorder.
 * redBorder is free software: you can redistribute it and/or modify
 * it under the terms of the GNU Affero General Public License as published by
 * the Free Software Foundation, either version 3 of the License, or
 * (at your option) any later version.
 * redBorder is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU Affero General Public License for more details.
 * You should have received a copy of the GNU Affero General Public License
 * along with redBorder. If not, see <http://www.gnu.org/licenses/>.
 */

$(document).ready(function () {
  $('#user-email-selector').each(function () {
    $(this).chosen();
    $("#user_email_selector_chosen > a > span").text("");
  });
  $('#alarm-form-selector').trigger('change');
  $('#monitor-tab-selector').trigger('change');
  $('#alarm-form input.boolean').trigger('change');
  $('#email-checkbox').trigger('change');
  add_extra_time_window();
  set_extended_time();
  set_druid_granularity();
  check_outliers_alarm_settings();
  hook_outliers_checkbox($("input[name='alarm[outliers_enabled]']"), true)
  $("input[name='alarm[outliers_enabled]']").on('change', function(){
    hook_outliers_checkbox($(this), false)
  })
});

$(document).on('change', '#alarms input.toggle_enabled', function () {
  var csrf = $('meta[name="csrf-token"]').attr('content');
  var alarm_id = $(this).parent('td').attr('data-alarm');
  $.ajax({
    url: "/alarms/"+ alarm_id,
    type: "PATCH",
    dataType: "json",
    data: {alarm: {enabled: $(this).is(':checked') === true},
           authenticity_token: csrf}
  });
});

$(document).on('change', '#email-checkbox', function () {
  var status = $(this).is(":checked");
  if (status) {
    $("div[data-notifier=email] input").removeAttr("disabled");
    $("div[data-notifier=email] select").removeAttr("disabled").trigger("liszt:updated");
    $("div[data-notifier=email] #user_email_selector_chosen .chosen-results").removeClass('hidden');
    $("#user_email_selector_chosen > a > span").text("Select an Option");
  } else {
    $("div[data-notifier=email] input").attr("disabled", true);
    $("div[data-notifier=email] select").attr("disabled", true).trigger("liszt:updated");
    $("div[data-notifier=email] #user_email_selector_chosen .chosen-results").addClass('hidden');
    $("#user_email_selector_chosen > a > span").text("");
  }
});

$(document).on('change', '#slack-checkbox', function() {
  var status = $(this).is(":checked");
  if (status) {
    $("div[data-notifier=slack] input").removeAttr("disabled");
  } else {
    $("div[data-notifier=slack] input").attr("disabled", true);
  }
});
$(document).on('change', '#alarm-form input.boolean', function () {
  var checked = $(this).is(":checked"),
      id = $(this).attr("id"),
      which = id.substr(0, id.length - 8),
      intInput = $('#' + which);

    if (checked) {
      intInput.removeAttr("disabled");
      $('#' + which + '_units').removeAttr("disabled");
    } else {
      intInput.attr("disabled", true);
      $('#' + which + '_units').attr("disabled", true);
    }
});

$(document).on('change', '#user-email-selector', function () {
  var select = $('#user-email-selector'),
      value = select.find(":selected").val();

  if(value !== "") {
    // Check if the email is already added
    if($('#alarm_email_list, #report_email_list').val().indexOf(value) == -1){

      if($('#alarm_email_list, #report_email_list').val() !== "") {
        $('#alarm_email_list, #report_email_list').val($('#alarm_email_list, #report_email_list').val() + "," + value);
      } else {
        $('#alarm_email_list, #report_email_list').val(value);
      }
    }
  }

  $("#user_email_selector_chosen>a>span").text("");
});

$(document).on('change', '#alarm-form-selector', function () {
  window['alarm_product_type_' + $(this).val()]($(this));

  if ($(this).val() === 'undefined') {
    $('#widget-filters').hide();
  }
});

function updateUnitOptions(unit) {
  const notSiUnits = new Set(["%", "ms", "°"]);
  const options = notSiUnits.has(unit)
    ? { "0": unit }
    : {
        "0": unit,
        "3": "K" + unit,
        "6": "M" + unit,
        "9": "G" + unit
      };

  var select = $('select.unit-selector');
  var selected_upper = $('select.unit-selector#alarm_upper_limit_units option[selected]').val();
  var selected_bottom = $('select.unit-selector#alarm_bottom_limit_units option[selected]').val();

  $('option', select).remove();

  $.each(options, function(key, value) {
    select.append($("<option></option>").attr("value", key).text(value));
  });

  $('select.unit-selector#alarm_upper_limit_units option[value=' + selected_upper + ']').attr('selected', 'selected');
  $('select.unit-selector#alarm_bottom_limit_units option[value=' + selected_bottom + ']').attr('selected', 'selected');
}

$(document).on('change', '#alarm_aggregation', function () {
  var unitsValue = $(this).val(),
      product = $('option:selected', '#alarm-form-selector').val(),
      unit;
  if (product === "monitor") {
    unit = redBorder.modules.monitor.tabs[unitsValue].units;
  } else {
    unit = redBorder.modules[product].aggregations[unitsValue].unit;
  }
  updateUnitOptions(unit);
});

function sendNewAlarm() {
  //Re-enable the options for the post request
  $('input[name="alarm[outliers_enabled]"]').eq(1)[0].checked ? disableOptions(false, true) : void 0 ;
  $('#alarm_condition').val(JSON.stringify(rule.pack().items));
}

// TODO i18n: check how to translate values from below. Backticks can not be used, since rake assets fails in production
$(document).ready(function () {
  $('#severity-slider').ionRangeSlider({
    values: [I18n.t('javascript.very_low'),I18n.t('javascript.low'),I18n.t('javascript.medium'),I18n.t('javascript.high'),I18n.t('javascript.very_high'), I18n.t('javascript.critical')],
    onLoad: function(obj) {
      change_colour_based_severity(obj.fromNumber)
    },
    onChange: function (obj) {      // callback is called on every slider change
      change_colour_based_severity(obj.fromNumber)
      }
  });
});

$(document).on('click', '.reactivate_alarm_button', function(event){
  $(this).parent().html('<i class="fa fa-repeat fa-spin"></i> Reactivating');
});

// Change the colour of the slider based on the severity
function change_colour_based_severity(severity) {
  switch(severity){
    case 0:
      // Very low
      $('.irs-single').css("background-color", "#30BF93")
      $('.irs-line-left, .irs-line-right, .irs-line-mid').css('background-color','#30BF93')
      break;
    case 1:
      // low
      $('.irs-single').css("background-color", "#89a54e")
      $('.irs-line-left, .irs-line-right, .irs-line-mid').css('background-color','#89a54e')
      break;
    case 2:
      // medium
      $('.irs-single').css("background-color", "#d9c03e")
      $('.irs-line-left, .irs-line-right, .irs-line-mid').css('background-color','#d9c03e')
          break;
    case 3:
      // high
      $('.irs-single').css("background-color", "#aa4643")
      $('.irs-line-left, .irs-line-right, .irs-line-mid').css('background-color','#aa4643')
      break;
    case 4:
      // very high
      $('.irs-single').css("background-color", "#d24643")
      $('.irs-line-left, .irs-line-right, .irs-line-mid').css('background-color','#d24643')
      break;
    case 5:
      // critical
      $('.irs-single').css("background-color", "#ff4643")
      $('.irs-line-left, .irs-line-right, .irs-line-mid').css('background-color','#ff4643')
      break;
  }
}

//Disable options of upper limit and bottom limit (Outliers)
function disableOptions(disabled, sending, is_hook) {
  $("#alarm_bottom_limit_enabled, #alarm_upper_limit_enabled").prop("disabled", is_hook ? false : disabled);
  $("#alarm_bottom_limit, #alarm_upper_limit, #alarm_upper_limit_units, #alarm_bottom_limit_units").prop("disabled", is_hook ? true : disabled);
  $("#alarm_bottom_limit_enabled, #alarm_upper_limit_enabled").prop("checked", sending ? true : disabled);
}

//Set options for upper and bottom limits
function setOptionValues(value) {
  $("#alarm_upper_limit, #alarm_bottom_limit").val(value);
}

//For sherlock outliers set default values to 0 and 0 since we are not going to use them.
function hook_outliers_checkbox(element, load){

    if (element.is(":checked")) {
      !load ? show_alert("warning", "Outliers have been enabled. Options like upper limit and bottom limit will be overridden.") : false;
      disableOptions(true, false);
      setOptionValues(0);
    } else {
      if(!load){
        show_alert("success", "Outliers have been disabled. Options like upper limit and bottom limit are available.")
        disableOptions(false, false, true)
        setOptionValues("")
      }
    }

}

function extend_time_window_range(){
  var checkbox = $('input[name="alarm[outliers_enabled]"]').eq(1);
  var timeWindowSelect = $('#alarm_time_window');

  var additionalOptions = [
    { value: "3600", text: "Last 1 hour" },
    { value: "7200", text: "Last 2 hours" },
    { value: "28800", text:  "Last 8 hours" },
    { value: "86400", text: "Last 1 day" },
    { value: "172800", text: "Last 2 days" },
    { value: "259200", text: "Last 3 days" },
    { value: "345600", text: "Last 4 days" },
    { value: "432000", text: "Last 5 days" },
    { value: "518400", text: "Last 6 days" },
    { value: "604800", text: "Last week" }
  ];

  if (checkbox.is(':checked')) {
    $.each(additionalOptions, function(index, optionData) {
      var option = $('<option>', {
        value: optionData.value,
        text: optionData.text
      });
      timeWindowSelect.append(option);
    });
  } else {
    timeWindowSelect.find('option:gt(3)').remove();
  }
}

function slow_granularity_list(time) {
  if(time < 1 * 24 * 60 * 60) return []
  if(time <= 1 * 24 * 60 * 60) return ['PT1M', 'PT2M']
  if (time <= 2 * 24 * 60 * 60) {
    return ['PT2M', 'PT5M'];
  } else if (time < 7 * 24 * 60 * 60) {
    return ['PT2M', 'PT5M'];
  } else if (time == 7 * 24 * 60 * 60) {
    return ['PT15M', 'PT30M'];
  }
  return []
}

function check_outliers_alarm_settings(recall) {
  $("#granularity_dropdown, #alarm_time_window").on("change", function() {
    const timeWindow = parseInt($('#alarm_time_window').val());
    if(/Slow/.test($('#granularity_dropdown option:selected').text())) {
      $('#slow_query_outliers_warning').show();
    } else {
      $('#slow_query_outliers_warning').hide();
    }
    $('#granularity_dropdown option').each(function() {
        $(this).text($(this).text().replace(/\(.+\)/g, '').trim());
    });
    var slowQueryFound = false
    var text = "(Slow Query)"
    $('#granularity_dropdown option').each(function() {
      const optionValue = $(this).val();
      const isOptionSlowQuery = slow_granularity_list(timeWindow)
      if (isOptionSlowQuery.indexOf(optionValue) != -1) {
        slowQueryFound = true
        if (!$(this).text().includes(text)) {
          $(this).text($(this).text() + ' ' + text);
        }
     }
    });
    $('#granularity_dropdown option').each(function() {
      const optionValue = $(this).text();
      if(optionValue.match(/Query/)) slowQueryFound = false;
      if(slowQueryFound) $(this).text($(this).text() + ' (Very Slow Query)');
    })
  });
  $("#granularity_dropdown, #alarm_time_window").trigger("change");
  if(typeof recall === 'undefined') check_outliers_alarm_settings(0)
}

function set_druid_granularity(){
  if(window.alarm_druid_granularity != "all" && window.alarm_druid_granularity != "" && window.alarm_druid_granularity != undefined){
    $("#granularity_dropdown").val(window.alarm_druid_granularity)
  }
}

function set_extended_time(){
  if(window.alarm_extended_time != "" && window.alarm_is_outliers_enabled == "true"){
    extend_time_window_range();
    $("#alarm_time_window").val(alarm_extended_time);
    $("#granularity_dropdown").trigger("change");
  }
}

function add_extra_time_window(){
  $('input[name="alarm[outliers_enabled]"]').eq(1).on('click', function() {
    extend_time_window_range();
  });
}
