/*!
 * Copyright (c) 2014 ENEO Tecnología S.L.
 * This file is part of redBorder.
 * redBorder is free software: you can redistribute it and/or modify
 * it under the terms of the GNU Affero General Public License as published by
 * the Free Software Foundation, either version 3 of the License, or
 * (at your option) any later version.
 * redBorder is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU Affero General Public License for more details.
 * You should have received a copy of the GNU Affero General Public License
 * along with redBorder. If not, see <http://www.gnu.org/licenses/>.
 */

/*
 * Domains SearchBox
 */

redBorder = redBorder || {};

redBorder.domainsSearchBox = function(input, root, callback) {
  var $input = $(input),
    $list = $("<ul id='domains-search-box' class='dropdown-menu'></ul>").css({
      "left" : "0",
      "width" : $input.outerWidth() + "px",
      "overflow" : "hidden"
    });

  $input.after($list);

  $input.keypress(function() {
    if (event.keyCode !== 13) return;

    var text = $input.val();

    if (text.trim().length > 0) {
      $.get("/sensors/" + root + "/search", { search: text }, function(html) {
        if (html === "") {
          html = "<li class='dropdown-header'>" + I18n.t('no_results') + "</li>";
        }
        $list.html(html);
        $list.show();
      }, "html");
    } else {
      $list.hide();
    }
  });

  $input.focusout(function(){
    // TODO: Hide Dropdown
    //$list.hide();
  });

  $(document).off("click", "#domains-search-box a.domain");
  $(document).on("click", "#domains-search-box a.domain", function() {
    event.preventDefault();
    var id = $(this).data("sensor-id");
    callback(id);
  });

  return {
    hide: function() {
      $list.hide();
      $input.off();
    }
  };
};
