/*!
 * Copyright (c) 2014 ENEO Tecnología S.L.
 * This file is part of redBorder.
 * redBorder is free software: you can redistribute it and/or modify
 * it under the terms of the GNU Affero General Public License as published by
 * the Free Software Foundation, either version 3 of the License, or
 * (at your option) any later version.
 * redBorder is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU Affero General Public License for more details.
 * You should have received a copy of the GNU Affero General Public License
 * along with redBorder. If not, see <http://www.gnu.org/licenses/>.
 */
function clean_dns_table_update(table_sorter, instance){
  if (typeof table_sorter === 'function' && typeof instance !== 'undefined') table_sorter(instance);
}

function resolve_dns(table_sorter, instance){
  var elements     = $(".auto-resolv");
  var ips          = new Array();
  var hashElements = {};

  for (var i = 0, l = elements.length; i < l; i++) {
    var ip = $.trim($(elements[i]).text());
    $(elements[i]).removeClass("auto-resolv").addClass("resolved");

    //Search if this ip is already resolved
    if (hashElements[ip] == undefined) {
      var cached;
      if($(elements[i]).hasClass('long')){
        cached = $(".resolved.cached.long[data-address='" +ip  +"']")[0]
      } else {
        cached = $(".resolved.cached.short[data-address='" +ip  +"']")[0]
      }

      if (cached == undefined ) {
        ips.push(ip);
        hashElements[ip] = [$(elements[i])]
      } else {
        $(elements[i]).html($(cached).html())
        $(elements[i]).addClass('cached')
      }
    } else {
      hashElements[ip].push($(elements[i]))
    }
  }

  if (ips.length > 0) {
    $.ajax({
      url: "/lookups/getaddrinfo",
      global: false,
      type: "GET",
      dataType: "json",
      cache: true,
      data: {
        ips: ips
      },
      success: function(data) {
        for (var n in data["names"]) {
          if (!data["names"].hasOwnProperty(n)) continue;
          name = data["names"][n]
          for (var i = 0, l = hashElements[n].length; i < l; i++) {
            element = hashElements[n][i]
            element.html("<span title='" +data["names"][n] +" ("  +n +")' class='resolved-ip' >" +data["names"][n] +"</span>")
            element.addClass('cached')
          }
        }
        clean_dns_table_update(table_sorter, instance);
      }
    });
  }
  //Always re-call table sorter update
  clean_dns_table_update(table_sorter, instance);
}
