/*!
 * Copyright (c) 2014 ENEO Tecnología S.L.
 * This file is part of redBorder.
 * redBorder is free software: you can redistribute it and/or modify
 * it under the terms of the GNU Affero General Public License as published by
 * the Free Software Foundation, either version 3 of the License, or
 * (at your option) any later version.
 * redBorder is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU Affero General Public License for more details.
 * You should have received a copy of the GNU Affero General Public License
 * along with redBorder. If not, see <http://www.gnu.org/licenses/>.
 */

/*
 * Generation of modals
 */

redBorder.modals = {
  /*
   * Hide all showed modals
   */
  hideModals: function(){
    $('.modal.fade.in').modal('toggle');
  },

  /*
   * Create a modal and display it in the UI
   *
   * @param [String] title : title of the modal
   * @param [String] message : text to show
   * @param [String] footer : code to place on footer
   * @param [String] modal : CSS selector of the modal to add the content
   */
  showModalWith: function(title, message, footer, modal) {
    var html = '<div class="modal-header"> \
                <button type="button" class="close" data-dismiss="modal"> \
                <span aria-hidden="true">&times;</span> \
                <span class="sr-only">' + I18n.t('javascript.close') + '</span></button> \
                <h3 class="modal-title">'+ title +'</h3> \
              </div> \
              <div class="modal-body"> \
                '+ message +' \
              </div> \
              <div class="modal-footer"> \
                ' + footer+ '\
              </div>';
    $(modal + ' .modal-content').html(html);
    $(modal).modal('toggle');
  },

  /*
   *  Create HTML for a dismiss button
   *
   * @param [String] text : text of the button
   * @return [String] HTML with the code of button
   */
  dismissButton: function(text) {
    return '<a class="btn btn-secondary" data-dismiss="modal">' + text + '</a>';
  }
}
