redBorder.widgets.graphs.ball = function (container, widget) {
  var graph, wtype, $container = $('#' + container);

  graph = new RB.Ball({
    container: container,
    max: widget.property.ball_max,
    alwaysShowQuantity: widget.property.always_show_quantity,
    invertColors: widget.property.invert_colors === "1" ? true : false,
  });

  // Entry point for the graph
  function init(_wtype) {
    wtype = _wtype;
  }

  function render(){
    wtype.queryTotal().then(draw, function () {
      redBorder.widgets.util.reloadFail($container.parents('.widget'));
    });
  }

  // Draws the widget. This data comes directly from the widget
  // type selected. You should prepare the data to be used if needed.
  function draw(total) {
    var result = total;

    if ( !isNaN(parseFloat(widget.property.reference)) ) {
      var offset = parseFloat(widget.property.offset || 0);
      var reference = parseFloat(widget.property.reference);

      result = 100 * (total - offset) / (reference - offset);

      if(result < 0){
        result = 0;
      }
    }

    graph.setValue(result);
    resize();
    redBorder.widgets.util.reloadDone($container.parents('.widget'));
  }

  function reload() {
    render();
  }

  function resize() {
    var height = 0;
    if(widget.name.length !== 0){
      height = 43;
    }

    $container.css('width', $container.parents('.widget').width() + 'px');
    $container.css('height', ($container.parents('.widget').height() - height) + 'px');
    graph.resize();
  }

  // Hide the main element when resizing
  function hide() {
    $container.find('svg').fadeOut(100);
  }

  // Show the main element
  function show() {
    $container.find('svg').fadeIn(100);
  }

  // Returns the graph object for debug purposes
  function getGraph() {
    return graph;
  }

    // Returns the widget
  function getWidget() {
    return widget;
  }

  return {
    init: init,
    resize: resize,
    getGraph: getGraph,
    getWidget: getWidget,
    hide: hide,
    show: show,
    reload: reload,
    render: render
  }
}
