redBorder.widgets.graphs.cluster_table = function (container, widget) {
  var $container = $('#' + container);

  // Entry point for the graph
  function init(wtype) {
  }

  function render(){
    getData();
  }

  function getData(){
    var url;

    if (widget.property.size == 'small') {
      url = "/managers/cluster_status_small?w=true";
    } else {
      url = "/managers/cluster_status?w=true";
    }

    $.ajax({
      url: url,
      type: 'GET',
      dataType: 'html'
    }).done(function (datos) {
      $container.html(datos);
    }).fail(function (datos) {
      // Forbidden!
      $container.html(datos.responseText);
      var margin = ($container.height()/2) - 20;
      $container.find('.manager-no-privileges').css('margin-top', margin + 'px');
    }).always(function () {
      redBorder.widgets.util.reloadDone($container.parents('.widget'));
    });
  }

  function reload() {
    getData();
  }

  function resize() { }

  // Hide the main element when resizing
  function hide() {

  }

  // Show the main element
  function show() {

  }

  // Returns the graph object for debug purposes
  function getGraph() {
    return undefined;
  }

  // Returns the widget
  function getWidget() {
    return widget;
  }

  return {
    init: init,
    resize: resize,
    getGraph: getGraph,
    getWidget: getWidget,
    hide: hide,
    show: show,
    reload: reload,
    render: render
  }
}