redBorder.widgets.graphs.combination_ball = function (container, widget) {
  var wtype, $container = $('#' + container);
  var total = 0;

  var graph = new RB.Ball({
    container: container,
    max: widget.property.ball_max,
    alwaysShowQuantity: widget.property.always_show_quantity,
    invertColors: widget.property.invert_colors === "1" ? true : false,
  });

  // Entry point for the graph
  function init(_wtype) {
    wtype = _wtype;
  }

  function render() {
    total = 0;
    wtype.queryList().then(function (data) {
      process(data);
    }, function () {
      redBorder.widgets.util.reloadDone($container.parents('.widget'))
    });
  }

  function process(list) {
    var serie = [],
        n = list.length;

    list.forEach(function (element) {
      wtype
        .queryTotal(element)
        .then(function (total) {
          var n = total;
          var offset = parseFloat(element.offset || 0);
          var reference = parseFloat(element.reference);

          if ( !isNaN(reference) ) {
            n = RB.util.transform(total, offset, reference);
          }
          add(n);
        });
    });
  }

  function add(num) {
    total += num;
    draw(total);
  }

  // Draws the widget. This data comes directly from the widget
  // type selected. You should prepare the data to be used if needed.
  function draw(total) {
    graph.setValue(total);

    redBorder.widgets.util.reloadDone($container.parents('.widget'));
  }

  function reload() {
    render();
  }

  function resize() {
    var height = 0;
    if(widget.name.length !== 0){
      height = 43;
    }

    $container.css('width', $container.parents('.widget').width() + 'px');
    $container.css('height', ($container.parents('.widget').height() - height) + 'px');
    graph.resize();
  }

  // Hide the main element when resizing
  function hide() {
    $container.find('svg').fadeOut(100);
  }

  // Show the main element
  function show() {
    $container.find('svg').fadeIn(100);
  }

  // Returns the graph object for debug purposes
  function getGraph() {
    return graph;
  }

    // Returns the widget
  function getWidget() {
    return widget;
  }

  return {
    init: init,
    resize: resize,
    getGraph: getGraph,
    getWidget: getWidget,
    hide: hide,
    show: show,
    reload: reload,
    render: render
  }
}
