redBorder.widgets.graphs.heatmap = function (container, widget) {
  var graph,
      wtype,
      $container = $('#' + container),
      grid_heatmap = false,
      force_max;

  force_max = parseInt(widget.property.force_max);

  if(widget.property.aggregation === "quality"){
    grid_heatmap = true;
  }

  if(isNaN(force_max)){
    force_max = undefined;
  }

  // Entry point for the graph
  function init(_wtype) {
    wtype = _wtype;
  }

  function render(){
    wtype.queryList().then( draw, function () {
      redBorder.widgets.util.reloadFail($container.parents('.widget'))
    });
  }

  // Draws the widget. This data comes directly from the widget
  // type selected. You should prepare the data to be used if needed.
  function draw(data) {
    try {
      graph = redBorder.heatMap({
        container: container,
        data: data,
        aggregation: widget.property.aggregation,
        scrollwheel: false,
        searchBox: false,
        type: widget.property.map_type,
        force_max: force_max,
        grid_heatmap: grid_heatmap,
        mirrorControls: true
      });
    } catch (err) {
      console.error("Couldn't load widget " + widget.id + ". " + err);
    }
    redBorder.widgets.util.reloadDone($container.parents('.widget'));
  }

  function reload() {
    wtype.queryList().then(function(data){
      graph.reloadData(data, true);
      redBorder.widgets.util.reloadDone($container.parents('.widget'));
    }, function () {
      redBorder.widgets.util.reloadFail($container.parents('.widget'));
    });
  }

  function resize() {
    var height = 0;
    if(widget.name.length !== 0){
      height = 43;
    }

    $container.css('height', ($container.parents('.widget').height() - height) + 'px');

    graph.resize();
  }

  // Hide the main element when resizing
  function hide() {
    $container.css('opacity', 0);
  }

  // Show the main element
  function show() {
    $container.css('opacity', 1);
  }

  // Returns the graph object for debug purposes
  function getGraph() {
    return graph;
  }

  // Returns the widget
  function getWidget() {
    return widget;
  }

  return {
    init: init,
    resize: resize,
    getGraph: getGraph,
    getWidget: getWidget,
    hide: hide,
    show: show,
    reload: reload,
    render: render
  }
}
