redBorder.widgets.graphs.performance_index = function (container, widget) {
  // Initialize variables
  var graph,
      wtype,
      $container = $('#' + container);
  // Initialize the widget with it's widget type.
  function init(_wtype) {
    wtype = _wtype;
  }
  // Get the data and call draw method
  function render(){
    wtype.queryPerformance().then(draw, function () {
      redBorder.widgets.util.reloadFail($container.parents('.widget'));
    });
  }
  // Draws the widget. This data comes directly from the widget
  // type selected. You should prepare the data to be used if needed.
  function draw(intervals) {
    ['low', 'medium', 'high'].forEach(function (level) {
      var $block = $container.find('[data-container="' + level + '"]');
      var value = (intervals[level] / intervals.total * 100).toFixed(2);

      $block.css('color', widget.property[level + '_color']);
      $block.find('.' + level + '-percenge').text(isNaN(value) ? '---' : value + '%');
      $block.find('.' + level + '-tag').text(widget.property[level + '_tag']);
      $block.find('.owidget-fquality-fill').css({
        'width': value + '%',
        'background-color': widget.property[level + '_color']
      });
    });
    redBorder.widgets.util.reloadDone($container.parents('.widget'));
  }
  // Initialize listeners
  function bindEvents(){
  }
  // Remove listeners
  function unbindEvents(){
  }
  // Reload this widget.
  function reload(){
    render();
  }
  // An user resize the widget (gridster callback)
  function resize() {
    var height = 0;
    if(widget.name.length !== 0){
      height = 43;
    }

    $container.css('height', ($container.parents('.widget').height() - height) + 'px');
    $container.css('width', ($container.parents('.widget').width()) + 'px');
  }
  // Hide the main element when resizing
  function hide() {
    $container.fadeOut(100);
  }
  // Show the main element
  function show() {
    $container.fadeIn(100);
  }
  // Returns the graph object for debug purposes
  function getGraph() {
    return graph;
  }
  // Returns the widget
  function getWidget() {
    return widget;
  }
  // Return all functions
  return {
    init: init,
    resize: resize,
    getGraph: getGraph,
    getWidget: getWidget,
    hide: hide,
    show: show,
    draw: draw,
    reload: reload,
    render: render
  }
}