redBorder.widgets.graphs.sensor_tree = function (container, widget) {
  var $container = $('#' + container);

  // Entry point for the graph
  function init(wtype) {
  }

  function render(){
    getData();
  }

  function getData(){
    $.ajax({
      url: "/sensors/tree",
      type: 'GET',
      dataType: 'html'
    }).done(function (datos) {
      $container.html(datos);
      $('td.last, td[data-label="Enabled"], th.fit-width.row-center, .navbar', $container).remove();
      $container.parents('.widget-body').css('overflow', 'auto');
      var table = $('#tree', $container);
      table.removeClass('table-condensed');

      table.treetable({
        expandable: true,
        onNodeExpand: function() {
          var sensor = this;
          var rows = table.find('tr[data-tt-parent-id='+ sensor.id +']')

          if (rows.length > 0) {
            rows.show();
            return true;
          }

          $.ajax({
            async: false, // Must be false, otherwise loadBranch happens after showChildren?
            url: "/sensors/" + sensor.id + "/children"
          }).done(function(html) {
            var rows = $(html).filter("tr");
            $('td.last, td[data-label="Enabled"], th.fit-width.row-center', rows).remove();
            table.treetable("loadBranch", sensor, rows);
          });
        }
      });

      // Expand root nodes
      if (table.find('tbody tr[data-tt-parent-id=""]').length < 3){
        table.find("tbody > tr[data-type=domain]").each(function(){
          table.treetable("reveal", $(this).data("ttId"));
        });
      }
      //table.treetable("expandAll");
    }).always(function () {
      redBorder.widgets.util.reloadDone($container.parents('.widget'));
    });
  }

  function reload() {
    getData();
  }

  function resize() {
    var height = (widget.name.length !== 0) ? 43 : 0;
    $container.css('height', ($container.parents('.widget').height() - height) + 'px');
  }

  // Hide the main element when resizing
  function hide() {
    $container.css('opacity', 0);
  }

  // Show the main element
  function show() {
    $container.css('opacity', 1);
  }

  // Returns the graph object for debug purposes
  function getGraph() {
    return undefined;
  }

  // Returns the widget
  function getWidget() {
    return widget;
  }

  return {
    init: init,
    resize: resize,
    getGraph: getGraph,
    getWidget: getWidget,
    hide: hide,
    show: show,
    reload: reload,
    render: render
  }
}