redBorder.widgets.graphs.stream = function (container, widget) {
  var graph,
      columns,
      wtype,
      $container = $('#' + container);

  columns = widget.property.stream_columns.filter(function (column) {
    return column !== "";
  });

  // Entry point for the graph
  function init(_wtype) {
    wtype = _wtype;
  }

  function render(){
    wtype.queryTable(columns).then(draw, function () {
      redBorder.widgets.util.reloadFail($container.parents('.widget'));
    });
  }

  // Draws the widget. This data comes directly from the widget
  // type selected. You should prepare the data to be used if needed.
  function draw(table) {
    if (graph === undefined){
      graph = new RB.Sankey({
        container: container,
        value: widget.property.aggregation,
        linksName: widget.property.aggregation
      });
    }
    graph.add(table, columns);
    resize(); //this fits stream widget inside the container
    redBorder.widgets.util.reloadDone($container.parents('.widget'));
  }

  function reload() {
    graph.restart();
    wtype.queryTable(columns).then(draw, function () {
      redBorder.widgets.util.reloadFail($container.parents('.widget'));
    });
  }

  function resize() {
    var height = 0;
    if(widget.name.length !== 0){
      height = 43;
    }

    $container.css('width', $container.parents('.widget').width() + 'px');
    $container.css('height', ($container.parents('.widget').height() - height) + 'px');
    graph.resize($container.parents('.widget').width(), ($container.parents('.widget').height() - height));
  }

  // Hide the main element when resizing
  function hide() {
    $container.find('svg').fadeOut(100);
  }

  // Show the main element
  function show() {
    $container.find('svg').fadeIn(100);
  }

  // Returns the graph object for debug purposes
  function getGraph() {
    return graph;
  }

  // Returns the widget
  function getWidget() {
    return widget;
  }

  return {
    init: init,
    resize: resize,
    getGraph: getGraph,
    getWidget: getWidget,
    hide: hide,
    show: show,
    reload: reload,
    render: render
  }
}
