redBorder.widgets.graphs.text = function (container, widget) {
  var $container = $('#' + container),
      ALIGNMENT_LEFT = "1",
      ALIGNMENT_CENTER = "2",
      ALIGNMENT_RIGHT = "3",
      ALIGNMENT_JUSTIFY = "4";

  // Entry point for the graph
  function init(wtype) {
    draw();
  }

  function render() {
    redBorder.widgets.util.reloadDone($container.parents('.widget'));
    $container.css('width', '');
  }

  // Draws the widget. This data comes directly from the widget
  // type selected. You should prepare the data to be used if needed.
  function draw(total) {
    var font_size = widget.property.font_size,
        alignment = widget.property.text_alignment;
    var title = $container.find('h4');

    title.css('font-size', font_size);
    title.css('line-height', $container.height() - 1 + 'px');

    switch(alignment){
      case ALIGNMENT_LEFT:
        title.css('text-align', 'left');
        break;
      case ALIGNMENT_CENTER:
        title.css('text-align', 'center');
        break;
      case ALIGNMENT_RIGHT:
        title.css('text-align', 'right');
        break;
      case ALIGNMENT_JUSTIFY:
        title.css('text-align', 'justify');
        break;
    }
  }

  function reload() {
    redBorder.widgets.util.reloadDone($container.parents('.widget'));
  }

  function resize() {
    $container.css('height', $container.parents('.widget').height() + 'px');
    $container.find('h4').css('line-height', $container.height() + 'px');
  }

  // Hide the main element when resizing
  function hide() {
    $container.fadeOut(100);
  }

  // Show the main element
  function show() {
    $container.fadeIn(100);
  }

  // Returns the graph object for debug purposes
  function getGraph() {
    return undefined;
  }

  // Returns the widget
  function getWidget() {
    return widget;
  }

  return {
    init: init,
    resize: resize,
    getGraph: getGraph,
    getWidget: getWidget,
    hide: hide,
    show: show,
    reload: reload,
    render: render
  }
}
