redBorder.widgets.graphs.value = function (container, widget) {
  var $container = $('#' + container),
      wtype;

  // Entry point for the graph
  function init(_wtype) {
    wtype = _wtype;
  }

  function render(){
    wtype.queryTotal().then(draw, function () {
      redBorder.widgets.util.reloadFail($container.parents('.widget'));
    });
  }

  // Draws the widget. This data comes directly from the widget
  // type selected. You should prepare the data to be used if needed.
  function draw(total) {
    var product_type = widget.property.product_type,
        aggregation = widget.property.aggregation,
        aggregationData, unit, aggregation_name,
        reference = parseFloat(widget.property.reference),
        offset = parseFloat(widget.property.offset) || 0;
    var multiplier = redBorder.widgets.util.getMultiplier(total);

    $container.html("")

    if (isNaN(reference)) {
      $container.append('<div class="widget-value-reference"><div><p>' + (Math.round(total * multiplier.num * 100) / 100) + " " + multiplier.prefix + '</p></div></div>');
    } else {
      var agg = product_type === 'monitor' ? 'value' : aggregation;
      $container.addClass('with-reference');
      var multiplier_ref = redBorder.widgets.util.getMultiplier(total - reference);
      // relativeValue is calculated as the function that goes though (offset, 0) and (reference, 100)
      // http://www.vitutor.com/geo/rec/d_7.html
      var relativeValue = Math.round(100 * (total - offset) / (reference - offset));

      $container.append('<div class="widget-value-reference"><div><h5>' +
              (Math.round((total - reference) * multiplier.num * 100) / 100) + " " + multiplier.prefix + ' from reference</h5><p>' +
              relativeValue + ' %</p></div></div>');
      $container.append('<div class="widget-value-events"><div><h5>' + agg +
              '</h5><p>' + (Math.round(total * multiplier.num * 100) / 100) + " " +
              multiplier.prefix + '</p></div></div>');
    }

    redBorder.widgets.util.reloadDone($container.parents('.widget'));
  }

  function reload() {
    wtype.queryTotal().then(draw, function () {
      redBorder.widgets.util.reloadFail($container.parents('.widget'));
    });
  }

  function resize() {
    var height = 0;
    if(widget.name.length !== 0){
      height = 43;
    }

    $container.css('width', $container.parents('.widget').width() + 'px');
    $container.css('height', ($container.parents('.widget').height() - height) + 'px');
  }

  // Hide the main element when resizing
  function hide() {
    $container.fadeOut(100);
  }

  // Show the main element
  function show() {
    $container.fadeIn(100);
  }

  // Returns the graph object for debug purposes
  function getGraph() {
    return undefined;
  }

  // Returns the widget
  function getWidget() {
    return widget;
  }

  return {
    init: init,
    resize: resize,
    getGraph: getGraph,
    getWidget: getWidget,
    hide: hide,
    show: show,
    reload: reload,
    render: render
  }
}
