redBorder.widgets.types.combination = function (widget, data) {

  // Gets the series from filters data from that interval
  //
  function queryTimeserie(element) {
    if (data === undefined && element['mod'] === 'monitor') {

      return redBorder.widgets.util.query({
        widget: widget,
        url: '/' + element['mod'] + '/get_serie/' + element['category'],
        typeOpts: {
          aggregation: element['agg'],
          monitor_tab: element['category'],
          range: widget.property.range,
          granularity: widget.property.granularity,
          filters: JSON.stringify(element['filters'])
        }
      });

    } else if (data === undefined) {

      return redBorder.widgets.util.query({
        widget: widget,
        url: '/' + element['mod'] + '/tops/get_serie/raw',
        typeOpts: {
          aggregation: element['agg'],
          granularity: widget.property.granularity,
          range: widget.property.range,
          filters: JSON.stringify(element['filters'])
        }
      });

    } else {
      return $.Deferred().resolve(data.timeserie[element['mod'] + '_' + element['agg']]);
    }
  }

  function queryList(opts) {
    var list = [];

    $.each(widget.property.series, function(index, serie) {
      content = {
        weight: serie['weight'],
        offset: serie['offset'],
        reference: serie['reference'],
        mod: serie['mod'],
        agg: serie['agg'],
        filters: serie['filters']
      }

      if(serie['mod'] === 'monitor'){
        content['category'] = serie['category']
      }

      list.push(content)
    });

    return $.Deferred().resolve(list);
  }

  function queryTotal(elem) {
    if (data === undefined || data.total === undefined) {
      return redBorder.widgets.util.query({
        widget: widget,
        url: '/' + elem['mod'] + '/tops/get_serie/raw',
        typeOpts: {
          aggregation: elem['agg'],
          granularity: 'all'
        }
      }).then(function (data) {
        var time = widget.wtype.end_time_secs - widget.wtype.start_time_secs;
        data = redBorder.widgets.util.checkPerSecondAggregationTotal(data, widget.property.aggregation, time);
        if (data[0] === undefined) {
          return 0;
        } else {
          return data[0].event.events * elem['weight'];
        }
      });   // End query promise
    } else {
      var _data = data.total[elem['mod'] + '_' + elem['agg']];
      if (_data.length === 0){
        return $.Deferred().resolve(0);
      }

      // Check the aggregation
      var time = widget.wtype.end_time_secs - widget.wtype.start_time_secs;
      var data_tmp = 0;
      if (_data[0] !== undefined){
        data_tmp = _data[0].event.events * parseFloat(elem['weight']);
      }

      return $.Deferred().resolve(data_tmp);
    }
  }

  return {
    queryTimeserie: queryTimeserie,
    queryList: queryList,
    queryTotal: queryTotal,
  }
}
