redBorder.widgets.types.performance = function (widget, data) {
  var category = widget.property.category,
      product_type = widget.property.product_type,
      elements = widget.property.elements;

  function queryPerformance(value) {
    if (data === undefined) {
      var opts = {}
      var intervals = {
        low: 0,
        medium: 0,
        high: 0,
        total: 0
      };

      return redBorder.widgets.util.query({
        widget: widget,
        url: '/' + product_type + '/tops/get_serie/raw',
        typeOpts: {
          aggregation: widget.property.aggregation,
          timezone: widget.property.timezone,
          monitor_tab: widget.property.category,
          monitor_sensor: value,
          granularity: widget.property.granularity
        },
        graphOpts: opts
      }).then(function (data) {
        intervals.total = data.length;
        data.forEach(function (e) {
          if (e.event.events < parseFloat(widget.property.low_limit)) {
            intervals.low++;
          } else if (e.event.events < parseFloat(widget.property.medium_limit)) {
            intervals.medium++;
          } else {
            intervals.high++;
          }
        });
        return intervals;
      });
    } else if (data.timeserie !== undefined) {
      return $.Deferred().resolve(data);
    } else {
      return $.Deferred().resolve(data);
    }
  }

  return {
    queryPerformance: queryPerformance
  }
}