redBorder.widgets.types.priority = function (widget, data) {
  function queryList(opts) {
    if (data === undefined || data.list === undefined) {
      return redBorder.widgets.util.query({
        widget: widget,
        url: '/incidents/get_incidents_widget_data/?type=priority',
        graphOpts: {
          opts: opts,
          range: widget.property.range,
          status : widget.property.status,
          domains : widget.property.domains,
          users : widget.property.users,
          sources : widget.property.sources
        }
      }).then(function (data) {
        return data;
      });
    }
  }

  // It queries the web app if it should get the colors from priorities
  // or darklist scores. Returns a deferred object.
  function getColors() {
    if (data === undefined || data.colors === undefined) {
      var d = new $.Deferred();
      return d.resolve([]);
    } else {
      if (widget.property.column === "priority" ||
        widget.property.column === "darklist_score_name" ||
        widget.property.column === "influence" ||
        widget.property.column === "client_rssi" ||
        widget.property.column === "action") {
        var d = new $.Deferred();
        return d.resolve([]);
      } else {
        return $.Deferred().resolve(data.colors);
      }
    }
  }

  return {
    queryList: queryList,
    queryTotal: queryList,
    getColors: getColors
  }
}
