redBorder.widgets.types.subtechniques = function (widget, data) {

  function queryList(opts) {
    if (data === undefined || data.list === undefined) {
      return redBorder.widgets.util.query({
        widget: widget,
        url: '/mitre/get_mitre_widget_data/?type=subtechniques',
        graphOpts: opts
      }).then(function (data) {
        return data;
      });
    }
  }

  // It queries the web app if it should get the colors from priorities
  // or darklist scores. Returns a deferred object.
  function getColors() {
    if (data === undefined || data.colors === undefined) {
      var d = new $.Deferred();
      return d.resolve([]);
    } else {
      if (widget.property.column === "priority" ||
        widget.property.column === "darklist_score_name" ||
        widget.property.column === "influence" ||
        widget.property.column === "client_rssi" ||
        widget.property.column === "action") {
        var d = new $.Deferred();
        return d.resolve([]);
      } else {
        return $.Deferred().resolve(data.colors);
      }
    }
  }
  return {
    queryList: queryList,
    queryTotal: queryList,
    getColors: getColors
  }
}
