
$(document).ready(function () {
 $('.toggle-task-template').on('click', function(event) {
    event.preventDefault();

    var taskId = $(this).data('task-id');
    var $task = $('.task[data-id="' + taskId + '"]');

    $task.find('#taskFull' + taskId).slideToggle();

    var $shortSummary = $task.find('.task-template-short-summary');
    if ($shortSummary.is(':visible')) {
      $shortSummary.hide();
      $(this).text(i18nTranslations.collapse);
    } else {
      $shortSummary.show();
      $(this).text(i18nTranslations.view);
    }
  });
});

//Show include task options in new task modal
$(document).on('click', '#new-task-template-modal .show_include_task', function (e) {
  var self = $(this).parent();

  if(self.hasClass("on")) {
    self.removeClass("on");
    $("#task_template_execution").val(false);
    $(".include-task").fadeOut('fast');
  } else {
    self.addClass("on");
    $("#task_template_execution").val(true);
    $(".include-task").fadeIn('fast');
  }
});

$(document).on('click', '#edit-task-template-modal .show_include_task', function (e) {
  var self = $(this).parent();

  if(self.hasClass("on")) {
    self.removeClass("on");
    $("#task_template_execution").val(false);
    $(".include-task").fadeOut('fast');
  } else {
    self.addClass("on");
    $("#task_template_execution").val(true);
    $(".include-task").fadeIn('fast');
  }
});

// Adapt actions select for each integration
$(document).on("change", "#task_template_integration_service", function(event) {
  var integrationService = $(this).val();
  if (integrationService) { 
    $.ajax({
         url: '/playbook_templates/integration_service_actions/' + integrationService,
         dataType: 'json',
         success: function(data) {
          
           // Limpiar las opciones actuales del select de acciones
           var $actionSelect = $("#task_template_action");
           $actionSelect.empty();
 
           // Función para humanizar el texto
           function humanizeText(str) {
             return str
               .split('_')
               .map(function(word) {
                 return word.charAt(0).toUpperCase() + word.slice(1);
               })
               .join(' ');
           }
           
           // Popular el select con las nuevas opciones
           $.each(data, function(index, value) {
               $actionSelect.append($('<option>', {
                   value: value,
                   text: humanizeText(value)
               }));
           });
         }
     });
   } else {
     var $actionSelect = $("#task_template_action");
     $actionSelect.empty();
   }
 });