/*!
 * Copyright (c) 2014 ENEO Tecnología S.L.
 * This file is part of redBorder.
 * redBorder is free software: you can redistribute it and/or modify
 * it under the terms of the GNU Affero General Public License as published by
 * the Free Software Foundation, either version 3 of the License, or
 * (at your option) any later version.
 * redBorder is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU Affero General Public License for more details.
 * You should have received a copy of the GNU Affero General Public License
 * along with redBorder. If not, see <http://www.gnu.org/licenses/>.
 */

$(document).on('click', '#results table tbody tr.selectable', function(e) {
  var columns_selected = [];
  var values_selected = [];
  var products_selected = [];
  var start_times_selected = [];

  var row = $(this);

  row.toggleClass('selected');

  var total = $('#results table tbody').find("tr.selected").length;

  if (total > 0) {
    $('#results div.filter-multiple').removeClass('filter-hide');
  } else {
    $('div.filter-multiple').addClass('filter-hide');
  }

  $('#results table tbody').find("tr.selected").each(function(index, element){
    columns_selected.push($(element).data('column'));
    values_selected.push($(element).data('value'));
    products_selected.push($(element).data('product'));
    start_times_selected.push($(element).data('start_time'));
  });

  var url = $("#results .filter-multiple a").data('link');

  var data = {
    columns: columns_selected,
    values: values_selected,
    products: products_selected,
    start_times: start_times_selected
  }

  url = url +"?" + decodeURIComponent($.param(data));
  $("#results .filter-multiple a").attr('href', url);

});

$(document).on('submit', '.navbar.navbar-inverse #fast_search_form', function(e){
  var input_val = $(this).find('input.search-query').val();

  if(input_val.length < 3){
    e.preventDefault();
  }
});

$(document).on('click', '.results-stop-search', function () {
  var running = $(this).data("running");

  if (running === true) {
    $('a', this).html("<i class='fa fa-play'></i>" + I18n.t('start_search'));
    $('div.results_offset').addClass("hidden");
    $(this).data("running", false);
  } else {
    $('a', this).html("<i class='fa fa-stop'></i>" + I18n.t('stop_search'));
    $('div.results_offset').removeClass("hidden");
    $(this).data("running", true);
  }

  return false;
});
