/*!
 * Copyright (c) 2014 ENEO Tecnología S.L.
 * This file is part of redBorder.
 * redBorder is free software: you can redistribute it and/or modify
 * it under the terms of the GNU Affero General Public License as published by
 * the Free Software Foundation, either version 3 of the License, or
 * (at your option) any later version.
 * redBorder is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU Affero General Public License for more details.
 * You should have received a copy of the GNU Affero General Public License
 * along with redBorder. If not, see <http://www.gnu.org/licenses/>.
 */

// Place all the behaviors and hooks related to the matching controller here.
// All this logic will automatically be available in application.js.
// You can use CoffeeScript in this file: http://coffeescript.org/

/* ======================================================================
 *  REPORT BLOCK FORM
 * ====================================================================== */

 $(document).ready(function () {
  product = $('#widget-form-selector').val();
  $('#widget-form-selector').trigger('change');
  $('.report_block_range select').trigger('change');
  $('.report_block-form[data-product="' + product + '"]  .report_block_report_block_type select').trigger('change');
  $('.report_block_graph_type select').trigger('change');
});

var widgetFields = ["widget_type", "report_block_type", "graph_type", "color", "column", "show_total", "category", "url",
  "sensor_table_type", "range", "compare_range", "granularity", "top_num", "height", "chart_options", "image",
  "aggregation", "cardinality_group_by", "timezone", "hide_axises", "ball_max", "reference", "map_column", "keep_aspect_ratio",
  "square_fill", "square_border_enabled", "square_border", "square_opacity", "map_type", "loop_video", "stream_columns", "cluster_type"];

function custom_stream_columns(product, list) {
  $('.chosen-select').chosen();
  $('div.chosen-container-multi, label.chosen-container').hide();
  if ($('.report_block_graph_type select').val() === "streams") {
    $('div.chosen-container-multi#widget_stream_columns_' + product + '_chosen, label.chosen-container-multi-' + product).show();
    if (list != null) {
      $('.widget_' + product + '.chosen-select').setSelectionOrder(list, true);
    }
  }
}

function enableField(elements, hide_others) {
  if (typeof elements === "string") elements = [elements];
  if (hide_others === undefined) hide_others = false;
  $('label.chosen-container').hide();
  elements.forEach(function (name) {
    $('.report_block_' + name + ', [id^=widget_' + name + '][id$=_chosen]').show();
    $('#report_block_' + name + ', [id^=widget_' + name + '][id$=_chosen]').attr("disabled", false);
  });

  if (hide_others === true) {
    widgetFields.forEach(function (name) {
      if (elements.indexOf(name) === -1) {
        $('.report_block_' + name + ', [id^=widget_' + name + '][id$=_chosen]').hide();
        $('#report_block_' + name + ', [id^=widget_' + name + '][id$=_chosen]').attr("disabled", true);
      }
    });
  }
}

function disableField(elements, show_others) {
  if (typeof elements === "string") elements = [elements];
  if (show_others === undefined) show_others = false;

  elements.forEach(function (name) {
    $('.report_block_' + name + ', [id^=widget_' + name + '][id$=_chosen]').hide();
    $('#report_block_' + name + ', [id^=widget_' + name + '][id$=_chosen]').attr("disabled", true);
  });

  if (show_others === true) {
    widgetFields.forEach(function (name) {
      if (elements.indexOf(name) === -1) {
        $('.report_block_' + name + ', [id^=widget_' + name + '][id$=_chosen]').show();
        $('#report_block_' + name + ', [id^=widget_' + name + '][id$=_chosen]').attr("disabled", false);
      }
    });
  }
}

function enableFieldColumn(product) {
  var select = $('.report_block_column select.widget_' + product);

  $('.report_block_column select').attr("disabled", true);
  select.attr("disabled", false);
    select.parents(".report_block_column").show();
}

function enableFieldGroupBy(product) {
  var select = $('.report_block_cardinality_group_by select.widget_' + product);

  $('.report_block_cardinality_group_by select').attr("disabled", true);
  select.attr("disabled", false);
  select.parents(".report_block_cardinality_group_by").show();
}

function enableFieldStreamColumns(product) {
  var select = $('.report_block_stream_columns select.widget_' + product);

  $('.report_block_stream_columns select').attr("disabled", true);
  select.attr("disabled", false);
  select.parents(".report_block_stream_columns").show();
  select.chosen();
  custom_stream_columns(product, null);
}

function enableFieldMapColumn(product) {
  var select = $('.report_block_map_column select.widget_' + product);

  $('.report_block_map_column select').attr("disabled", true);
  select.attr("disabled", false);
  select.parents(".report_block_map_column").show();
}

function formatTreeSensorTable(widgetId) {
  var table = $("#widget_placeholder_" + widgetId + " .tree");

  table.treetable({
    expandable: true,
    onNodeCollapse: function() {
      var sensor = this;
      grid();
    },
    onNodeExpand: function() {
      var sensor = this;
      var rows = table.find('tr[data-tt-parent-id='+ sensor.id +']')

      if(rows.length > 0){
        rows.show();
        return true;
      }

      $.ajax({
        async: false, // Must be false, otherwise loadBranch happens after showChildren?
        url: "/widgets/" + sensor.id + "/get_tree_children"
      }).done(function(html) {
        var rows = $(html).filter("tr");
        table.treetable("loadBranch", sensor, rows);
      });

      grid();
    }
  });

  // Expand root nodes
  table.treetable("expandAll");
}

function rangeOptions(extended) {
  var options = {
    last_1_minute: "Last 1 minute",
    last_2_minutes: "Last 2 minutes",
    last_5_minute: "Last 5 minutes",
    last_15_minute: "Last 15 minutes",
    last_30_minute: "Last 30 minutes",
    last_1_hour: "Last 1 hour",
    last_2_hour: "Last 2 hours",
    last_3_hour: "Last 3 hours",
    last_12_hour: "Last 12 hours",
    last_24: "Last 24 hours",
    last_week: "Last week",
    last_month: "Last month"
  }, optionSelected;

  if (extended === false) {
    delete options.last_1_minute;
    delete options.last_2_minutes;
    delete options.last_5_minute;
    delete options.last_15_minute;
    delete options.last_30_minute;
  }

  select = $('.report_block_range select');
  optionSelected = $('option:selected', select).val();
  $('option', select).remove();

  $.each(options, function(key, value) {
    select.append($("<option></option>")
      .attr("value", key).text(value));
  });

  if (options[optionSelected] !== undefined) {
    select.val(optionSelected);
  }
}

/* Update fields based on graph type selector */
$(document).on('change', '.report_block_graph_type select', function () {
  var value = $(this).val(),
      product = $("#widget-form-selector").val(),
      typeSelector = $('.report_block_report_block_type select'),
      type = typeSelector.val(),
      modules = Object.keys(redBorder.modules);

  if (modules.indexOf(product) === -1) return;

  if (type === "Aps") return;

  if (value === "pie" || value === "table" || value === "horbars" || value === "verbars") {
    disableField(["granularity", "timezone", "chart_options", "color", "show_total", "hide_axises", "reference", "ball_max", "map_column", "map_type", "stream_columns", "height"]);
    if (value === "horbars" || value === "verbars") enableField("color");
    enableField(["top_num"]);
    rangeOptions(true);

    if (value === "verbars") enableField("height");
    if ((value === "horbars" || value === "verbars") && type === "Cardinality") enableFieldGroupBy(product);

    if (type === "Top") {
      enableFieldColumn(product);
      enableField(["aggregation"]);
    }
  } else if (value === "ball") {
    disableField(["granularity", "timezone", "chart_options", "show_total", "hide_axises", "color", "top_num", "reference", "map_column", "map_type", "stream_columns", "height"]);
    enableField(["ball_max"]);
    rangeOptions(true);
    if (type === "Cardinality") {
      disableField(["cardinality_group_by"]);
    }
  } else if (value === "value") {
    rangeOptions(true);
    disableField(["timezone", "color", "hide_axises", "chart_options", "top_num", "ball_max", "cardinality_group_by", "granularity", "map_column", "map_type", "stream_columns", "height"]);
    enableField(["reference"]);
  } else if (value === "map") {
    disableField(["timezone", "color", "hide_axises", "chart_options", "ball_max", "cardinality_group_by", "granularity", "column", "aggregation", "stream_columns"]);
    enableFieldMapColumn(product);
    if (typeof window['enable_field_' + product] == 'function') { window['enable_field_' + product](); }
  } else if (value === "streams") {
    enableField(["widget_type", "graph_type", "range", "aggregation", "granularity", "report_block_type", "height"], true);
    enableFieldStreamColumns(product);
  } else {
    enableField(["granularity", "timezone", "aggregation", "height"]);
    disableField(["reference", "ball_max", "map_column", "map_type", "stream_columns"]);
    rangeOptions(false);

    if (window['enable_fields_' + product] !== undefined) {
      window['enable_fields_' + product](product, disableField, enableField, enableFieldColumn);
    } else if (type === "Top") {
      enableField(["chart_options", "show_total", "hide_axises", "top_num"]);
      enableFieldColumn(product);
    } else if (type == "Cardinality") {
      disableField("aggregation");
      enableField(["chart_options", "show_total", "hide_axises", "top_num", "color"]);
      enableFieldGroupBy(product);
      $('.widget_cardinality_group_by select').trigger("change");
    } else if (type == "Raw") {
      enableField(["color", "chart_options", "hide_axises"]);
      disableField("ball_max");
    } else {
      disableField(["granularity", "timezone"]);
    }
  }
});

/* Update fields visibility and selectors options
based on product type and widget type */
$(document).on('change', '.report_block_report_block_type select', function () {
  var product = $("#widget-form-selector").val(),
      value = $(this).val(),
      options,
      optionSelected,
      select;

  options = {
    "stacked": "Stacked",
    "area": "Area",
    "line": "Line",
    "bars": "Bars",
    "sbars": "SBars",
    "pie": "Pie",
    "horbars": "Horizontal Bars",
    "verbars": "Vertical Bars",
    "map": "Map",
    "table": "Table",
    "ball": "Ball",
    "value": "Value",
    "streams": "Streams"
  };

  function removeOptions(names) {
    names.forEach(function (name) {
      delete options[name];
    })
  }

  if ($(this).is(":visible")) {
    switch(value) {
      case "Top":
        enableField(["widget_type", "report_block_type","graph_type", "top_num", "timezone", "aggregation",
          "chart_options", "hide_axises", "show_total", "granularity", "range"], true);
        enableFieldColumn(product);
        removeOptions(["ball", "value", "streams"]);
        break;
      case "Raw":
        enableField(["widget_type", "report_block_type", "graph_type", "color", "aggregation", "chart_options",
          "hide_axises", "timezone", "granularity", "range"], true);
        removeOptions(["stacked", "pie", "horbars", "verbars", "table", "map"]);
        break;
      case "Cardinality":
        enableField(["widget_type", "report_block_type", "graph_type", "top_num", "timezone", "chart_options",
          "hide_axises", "show_total", "granularity", "range"], true);
        enableFieldColumn(product);
        enableFieldGroupBy(product);
        removeOptions(["pie", "table", "map", "streams"]);
        break;
      case "Compare":
        enableField(["widget_type", "report_block_type", "graph_type", "aggregation", "chart_options", "hide_axises",
          "compare_range", "top_num"], true);
        removeOptions(["stacked", "sbars", "pie", "horbars", "verbars", "table", "ball", "value", "map", "streams"]);
        break;
      case "Aps":
        enableField(["widget_type", "report_block_type", "range"], true);
        break;
    }
  } else if (window['remove_options_' + product] !== undefined) {
    window['remove_options_' + product](options, removeOptions);
  }

  select = $('.report_block_graph_type select');
  optionSelected = $('option:selected', select).val();
  $('option', select).remove();

  $.each(options, function(key, value) {
    select.append($("<option></option>")
      .attr("value", key).text(value));
  });

  if (options[optionSelected] !== undefined) {
    select.val(optionSelected);
  }

  $('.report_block_graph_type select').trigger('change');
});

$(document).on('change', '#widget-form-selector', function () {
  var where = $(this).val(),
      data = $('#widget_filters, #report_block_filters').val(),
      type = $('.report_block_report_block_type select'),
      units = {},
      modules = Object.keys(redBorder.modules),
      optionSelected,
      filters;

  $('#widget-filters').show();
  $('#search .rules').html("");

  if (data !== "" && data !== undefined) {
    filters = JSON.stringify({
      match_all: true,
      items: JSON.parse(data)
    });
  }

  function configureRules(where) {
    where.searchUI({
      cssClass: "submit-search",
      buttonTitle: "Submit Filter"
    }, function() {
      if (filters === undefined) {
        rule.add();
        rule.add();
      } else {
        rule.build(filters);
        rule.add();rule.add();
      }
    });
  }

  // Set the units based on the product
  if (redBorder.modules[where] !== undefined &&
      redBorder.modules[where].aggregations !== undefined) {
    $.each(redBorder.modules[where].aggregations, function (key, data) {
      units[key] = data.name;
    });
  }

  // Remove APs table on non-flow in reports
  if (where != 'flow' && $('#report_block_report_block_type').length > 0) {
    $('#report_block_report_block_type option[value="Aps"]').remove();
  }

  switch (where) {
    case "sensors":
      enableField("sensor_table_type", true);
      break;
    case "cluster":
      enableField(['cluster_type'], true);
      break;
    case "text":
      enableField([], true);
      break;
    case "custom":
      enableField(["url", "height"], true);
      break;
    case "webcam":
      enableField([], true);
      break;
    case "image":
      enableField(["image", "keep_aspect_ratio"], true);
      break;
    case "video":
      enableField(["image", "loop_video"], true);
      break;
    case "square":
      enableField(["square_fill", "square_border_enabled", "square_border", "square_opacity"], true);
      break;
    case "date":
      enableField(["timezone"], true);
      break;
    case "alarms":
      enableField([], true);
      break;
    default:
      // Only on reports
      if (where == 'flow' && $('#report_block_report_block_type').length > 0 && $('#report_block_report_block_type option[value="Aps"]').length === 0) {
        $('#report_block_report_block_type').append('<option value="Aps">APs table</option>');
      }

      window['widget_product_type_' + where]($(this), units);
  }

  select = $('#widget_aggregation, #report_block_aggregation');
  optionSelected = $('option:selected', select).val();
  $('option', select).remove();

  $.each(units, function(key, value) {
    select.append($("<option></option>")
      .attr("value", key).text(value));
  });

  if (units[optionSelected] !== undefined) {
    select.val(optionSelected);
  }

  if (["cluster", "text"].indexOf(where) !== -1) $("#accordion-custom").hide();
  else $("#accordion-custom").show();

  if (modules.indexOf(where) !== -1) {
    configureRules(rule);
    type.trigger('change');
  } else $('#widget-filters').hide();
});

$(document).on('change', '.report_block_cardinality_group_by select', function () {
  var selected = $(this).val(),
    graph = $('#report_block_graph_type').val(),
    section = $('.report_block_report_block_type select').val();

  /* If Coordinates column is selected for Group By, Graph Type select is disabled. */
  /* For Coordinates, a map is showed by default */
  if($(this).is(":visible") && graph != "horbars" && graph != "verbars") {
    if (selected !== 'client_latlong') {
      if (selected === 'none') disableField("top_num");
      else enableField("top_num");
      enableField("color");
      if (section === 'Cardinality') {
        enableField("granularity");
        $('.report_block_graph_type').show();
      }
    } else {
      disableField("color");
      enableField("top_num");
      if (section === 'Cardinality') {
        disableField("granularity");
        $('.report_block_graph_type').hide();
      }
    }
  }
});

/* Update granularity options based on selected range */
$(document).on('change', '#report_block_range', function () {
  var product = $("#widget-form-selector").val(),
      select = $('+#report_block_granularity'),
      optionSelected = $('option:selected', select).val(),
      newValues;

  $('option', select).remove();
  newValues = get_granularity_list($(this).val());

  $.each(newValues, function(key, value) {
    select.append($("<option></option>")
       .attr("value", key).text(value));
   });

  if (newValues[optionSelected] !== undefined) {
    select.val(optionSelected);
  }
});

function sendReportBlock() {
  if (window.rule !== undefined) {
    $('#report_block_filters').val(JSON.stringify(rule.pack().items));
  }
  var product = $("#widget-form-selector").val();
  var order = $('.widget_' + product + '.chosen-select').getSelectionOrder();
  $('[id$=_stream_columns_]').val(order);
}

/* Defines the possible values of granularity based on the range */
function get_granularity_list(range) {
  var ret = [];

  var product = $("#widget-form-selector").val();
  var graph_type = $(".report_block_report_block_type select").val();

  if (window['get_granularity_list_' + product] !== undefined) {
    ret = window['get_granularity_list_' + product](graph_type, range);
  }

  return ret;
}

function get_granularity_list_cardinality(range) {
  switch(range) {
    case "last_1_minute":
      ret = {
        "minute": "1 Minute"
      }
      break;
    case "last_2_minutes":
      ret = {
        "minute": "1 Minutes",
        "pt2m": "2 Minutes"
      }
      break;
    case "last_5_minute":
      ret = {
        "minute": "1 Minute",
        "pt2m": "2 Minutes",
        "pt5m": "5 Minutes"
      }
      break;
    case "last_15_minute":
      ret = {
        "minute": "1 Minute",
        "pt2m": "2 Minutes",
        "pt5m": "5 Minutes",
        "fifteen_minute": "15 Minutes"
      }
      break;
    case "last_30_minute":
    case "last_1_hour":
      ret = {
        "minute": "1 Minute",
        "pt2m": "2 Minutes",
        "pt5m": "5 Minutes",
        "fifteen_minute": "15 Minutes",
        "thirty_minute": "30 Minutes"
      };
      break;
    case "last_2_hour":
      ret = {
        "minute": "1 Minute",
        "pt2m": "2 Minutes",
        "pt5m": "5 Minutes",
        "fifteen_minute": "15 Minutes",
        "thirty_minute":
        "30 Minutes",
        "hour": "1 Hour"
      };
      break;
    case "last_3_hour":
      ret = {
        "minute": "1 Minute",
        "pt2m": "2 Minutes",
        "pt5m": "5 Minutes",
        "fifteen_minute": "15 Minutes",
        "thirty_minute": "30 Minutes",
        "hour": "1 Hour"
      };
      break;
    case "last_12_hour":
      ret = {
        "minute": "1 Minute ?",
        "pt2m": "2 Minutes ?",
        "pt5m": "5 Minutes",
        "fifteen_minute": "15 Minutes",
        "thirty_minute": "30 Minutes",
        "hour": "1 Hour",
        "pt2h": "2 Hours"
      };
      break;
    case "last_24":
      ret = {
        "minute": "1 Minute ?",
        "pt2m": "2 Minutes ?",
        "pt5m": "5 Minutes",
        "fifteen_minute": "15 Minutes",
        "thirty_minute": "30 Minutes",
        "hour": "1 Hour",
        "pt2h": "2 Hours",
        "pt8h": "8 Hours"
      };
      break;
    case "last_week":
      ret = {
        "minute": "1 Minute ?",
        "pt2m": "2 Minutes ?",
        "pt5m": "5 Minutes ?",
        "fifteen_minute": "15 Minutes ?",
        "thirty_minute": "30 Minutes ?",
        "hour": "1 Hour",
        "pt2h": "2 Hours",
        "pt8h": "8 Hours",
        "pt24h": "1 Day"
      };
      break;
    case "last_month":
      ret = {
        "minute": "1 Minute ?",
        "pt2m": "2 Minutes ?",
        "pt5m": "5 Minutes ?",
        "fifteen_minute": "15 Minutes ?",
        "thirty_minute": "30 Minutes ?",
        "hour": "1 Hour ?",
        "pt2h": "2 Hours",
        "pt8h": "8 Hours",
        "pt24h": "1 Day",
        "pt120h": "5 Days",
        "pt168h": "1 Week"
      };
      break;
    default:
      ret = {
        "pt8h": "8 Hours",
        "pt24h": "1 Day",
        "pt120h": "5 Days",
        "pt168h": "1 Week",
        "pt720h": "1 Month"
      };
  }
  return ret;
}

function get_granularity_list_default(range) {
  switch(range) {
    case "last_1_minute":
      ret = {
        "minute": "1 Minute"
      }
      break;
    case "last_2_minutes":
      ret = {
        "minute": "1 Minutes",
        "pt2m": "2 Minutes"
      }
      break;
    case "last_5_minute":
      ret = {
        "minute": "1 Minute",
        "pt2m": "2 Minutes",
        "pt5m": "5 Minutes"
      }
      break;
    case "last_15_minute":
      ret = {
        "minute": "1 Minute",
        "pt2m": "2 Minutes",
        "pt5m": "5 Minutes",
        "fifteen_minute": "15 Minutes"
      }
      break;
    case "last_30_minute":
    case "last_1_hour":
      ret = {
        "minute": "1 Minute",
        "pt2m": "2 Minutes",
        "pt5m": "5 Minutes",
        "fifteen_minute": "15 Minutes",
        "thirty_minute": "30 Minutes"
      };
      break;
    case "last_2_hour":
      ret = {
        "minute": "1 Minute",
        "pt2m": "2 Minutes",
        "pt5m": "5 Minutes",
        "fifteen_minute": "15 Minutes",
        "thirty_minute":
        "30 Minutes",
        "hour": "1 Hour"
      };
      break;
    case "last_3_hour":
      ret = {
        "minute": "1 Minute",
        "pt2m": "2 Minutes",
        "pt5m": "5 Minutes",
        "fifteen_minute": "15 Minutes",
        "thirty_minute": "30 Minutes",
        "hour": "1 Hour"
      };
      break;
    case "last_12_hour":
      ret = {
        "pt5m": "5 Minutes",
        "fifteen_minute": "15 Minutes",
        "thirty_minute": "30 Minutes",
        "hour": "1 Hour",
        "pt2h": "2 Hours"
      };
      break;
    case "last_24":
      ret = {
        "pt5m": "5 Minutes",
        "fifteen_minute": "15 Minutes",
        "thirty_minute": "30 Minutes",
        "hour": "1 Hour",
        "pt2h": "2 Hours",
        "pt8h": "8 Hours"
      };
      break;
    case "last_week":
      ret = {
        "hour": "1 Hour",
        "pt2h": "2 Hours",
        "pt8h": "8 Hours",
        "pt24h": "1 Day"
      };
      break;
    case "last_month":
      ret = {
        "pt2h": "2 Hours",
        "pt8h": "8 Hours",
        "pt24h": "1 Day",
        "pt120h": "5 Days",
        "pt168h": "1 Week"
      };
      break;
    default:
      ret = {
        "pt8h": "8 Hours",
        "pt24h": "1 Day",
        "pt120h": "5 Days",
        "pt168h": "1 Week",
        "pt720h": "1 Month"
      };
  }
  return ret;
}
