/*!
 * Copyright (c) 2014 ENEO Tecnología S.L.
 * This file is part of redBorder.
 * redBorder is free software: you can redistribute it and/or modify
 * it under the terms of the GNU Affero General Public License as published by
 * the Free Software Foundation, either version 3 of the License, or
 * (at your option) any later version.
 * redBorder is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU Affero General Public License for more details.
 * You should have received a copy of the GNU Affero General Public License
 * along with redBorder. If not, see <http://www.gnu.org/licenses/>.
 */

/*---------------------------------------------------
* Validations!
* --------------------------------------------------- */

$(document).on('click', '#settings input#settings_autodrop', function(e) {
	if ($(this).is(':checked')) {
		$('select#settings_autodrop_count').prop('disabled', false);
	} else {
		$('select#settings_autodrop_count').prop('disabled', 'disabled');
	}
});

$(document).on('click', '#settings input#settings_autodrop_rollback', function(e) {
	if ($(this).is(':checked')) {
		$('select#settings_autodrop_rollback_count').prop('disabled', false);
	} else {
		$('select#settings_autodrop_rollback_count').prop('disabled', 'disabled');
	}
});

$(document).on('click', '#settings input#settings_proxy', function(e) {
	if ($(this).is(':checked')) {
		$('#proxy-settings').removeClass("hide");
	} else {
		$('#proxy-settings').addClass("hide");
	}
});

$(document).on('click', '#settings #mode_selector', function(e) {
	var selected = $("#mode_selector").find(":selected").val();

	if (selected === "basic") {
		$('#collapse-vips div[data-mode="advanced"]').hide();
		$('#collapse-vips div[data-mode="basic"]').show();
	} else {
		$('#collapse-vips div[data-mode="advanced"]').show();
		$('#collapse-vips div[data-mode="basic"]').hide();
	}
});

$(document).on('click', 'form.settings div.panel-actions input.btn-success', function(e) {

  // Remove errors
  $("#segments_s3 .panel-body .alert").remove();
  $("#segments_s3 .panel-body .form-group").removeClass('error');

  var errors = $('div#settings').find('input:invalid');

  // Check Backups S3
  var s3_backups = ['settings[[segments_s3][s3_host]]',
                    'settings[[segments_s3][s3_access_key_id]]',
                    'settings[[segments_s3][s3_bucket]]',
                    'settings[[segments_s3][s3_secret_key_id]]'];

  var s3_validation = redBorder.forms.checkAllFilled(s3_backups);

  // Try to save namespace rules
  if($('.namespace-rules').length > 0 && redBorder.namespace.rules !== undefined){
    // Send rules
    $('input#namespace_rules').val(redBorder.namespace.rules.getRulesJSON());
  }

  if (errors.length > 0) {
    $('html, body').animate({
  	  scrollTop: $("header").offset().top
  	}, 500);
		errors.addClass('form-error');
	} else if (!s3_validation) {
    // Don't send elements
    e.preventDefault();
    // Show an advice
    $("#segments_s3 .panel-body").prepend(
      '<div class="alert alert-danger"><p>' + I18n.t('fill_field') + '</p></div>'
    );
    // Expand menu
    if(!$('#segments_s3').hasClass('in')){
      $('#segments_s3').collapse('show');
    }
    // Go to the element
    $('html, body').animate({
      scrollTop: ($("#segments_s3 .panel-body").offset().top - 200)
    }, 1000);
  } else if (! $('form.settings')[0].checkValidity()) {
    return true;
  } else {
		$('form.settings').submit();
	};

  return false;
});

$(document).on('click', 'form.trap input.btn-success', function(e) {

  var errors = $('form.trap').find('input:invalid').parent();
  if (errors.length > 0) {
    errors.addClass('error');
	} else {
    $('form.trap').submit();
  };

  return false;
});

$(document).on('click', 'form.white_network input.btn-success', function(e) {

  var errors = $('form.white_network').find('input:invalid').parent();
  if (errors.length > 0) {
    errors.addClass('error');
	} else {
    $('form.white_network').submit();
  };

  return false;
});

$(document).on('click', 'form.black_network input.btn-success', function(e) {

  var errors = $('form.black_network').find('input:invalid').parent();
  if (errors.length > 0) {
    errors.addClass('error');
	} else {
    $('form.black_network').submit();
  };

  return false;
});

$(document).on('click', 'form.fixed_host input.btn-success', function(e) {

  var errors = $('form.fixed_host').find('input:invalid').parent();
  if (errors.length > 0) {
    errors.addClass('error');
  } else {
    $('form.fixed_host').submit();
  };

  return false;
});

$(document).on('click', 'body.settings .switch-selector.show_advanced_options', function (e) {

  // Simple Code
  var self = $(this).parent();

      if(self.hasClass("on")) {
        self.removeClass("on");
        $(".setting-advanced").fadeOut('fast');
      } else {
        self.addClass("on");
        $(".setting-advanced").fadeIn('fast');
      }
});


function toggleKsigma(){
  $('#settings\\[anomaly_model\\]').val() == 'KSigmaModel' ? $('#ksigma_value').show() : $('#ksigma_value').hide()
}

$(document).on('change', '#settings\\[anomaly_model\\], #collapseOutliers', function(){
  toggleKsigma()
})

$(document).on('change', '#ksigma_range', function() {
    $('#ksigma_label').text(": " + $('#ksigma_range').val())
})




