/*!
 * Copyright (c) 2024 ENEO Tecnología S.L.
 * This file is part of redBorder.
 * redBorder is free software: you can redistribute it and/or modify
 * it under the terms of the GNU Affero General Public License as published by
 * the Free Software Foundation, either version 3 of the License, or
 * (at your option) any later version.
 * redBorder is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU Affero General Public License for more details.
 * You should have received a copy of the GNU Affero General Public License
 * along with redBorder. If not, see <http://www.gnu.org/licenses/>.
 */

$(document).on('click', '#threat_intel_sources tr.threat_intel_source input.toggle_enable', function(e) {
  var threat_intel_source_id = $(this).parents('tr').data('threat-intel-source-id');

  if ($(this).is(':checked')) {
    $.ajax({
      url: "/threat_intel_sources/"+ threat_intel_source_id,
      type: "PATCH",
      dataType: "json",
      data: {threat_intel_source: {enable: 1},
            authenticity_token: csrf}
    });
  } else {
    $.ajax({
      url: "/threat_intel_sources/"+ threat_intel_source_id,
      type: "PATCH",
      dataType: "json",
      data: {threat_intel_source: {enable: 0},
            authenticity_token: csrf}
    });
  };
});

function hideCredentials(userField, passwordField, userPasswordFields) {
  userField.removeAttribute("required")
  userField.value = "";
  passwordField.removeAttribute("required")
  passwordField.value = "";
  userPasswordFields.style.display = "none";
}

function showCredentials(userField, passwordField, userPasswordFields) {
  userField.setAttribute("required", "");
  passwordField.setAttribute("required", "");
  userPasswordFields.style.display = "block";
}

function toggleCredentials() {
  var userPasswordFields = document.getElementById("user-password-fields");
  var userField = document.getElementById("source-user");
  var passwordField = document.getElementById("source-password");

  var connTypeField = document.getElementById("source-conn-type");
  var selectedOption = connTypeField.options[connTypeField.selectedIndex].text
  var isHTTP = selectedOption == 'HTTP' || selectedOption == 'HTTPS';

  if (!isHTTP) {
    if (document.getElementById('anonymous-input').checked) {
      hideCredentials(userField, passwordField, userPasswordFields);

    } else {
      showCredentials(userField, passwordField, userPasswordFields);
    }
  } else {
    if (document.getElementById("show-credentials-input").checked) {
      showCredentials(userField, passwordField, userPasswordFields);
    }
    else {
      hideCredentials(userField, passwordField, userPasswordFields);
    }
  }
}

function toggleSourceDetails() {
  var sourceDetailsFields = document.getElementById("source-details-fields");
  var connTypeFields = document.getElementById("conn-type-fields");
  var urlFields = document.getElementById("url-fields");

  var hostField = document.getElementById("source-host");
  var portField = document.getElementById("source-port");
  var connTypeField = document.getElementById("source-conn-type");
  var pathField = document.getElementById("source-path");
  var urlField = document.getElementById("source-url");
  
  var showCredentialsFields = document.getElementById('show-credentials-fields');
  var anonymousFields = document.getElementById('anonymous-fields');

  var selectedOption = connTypeField.options[connTypeField.selectedIndex].text

  if (selectedOption != 'HTTP' && selectedOption != 'HTTPS') {
    hostField.setAttribute("required", "")
    portField.setAttribute("required", "")
    pathField.setAttribute("required", "")
    sourceDetailsFields.style.display = "block";
    
    urlField.removeAttribute("required")
    urlFields.style.display = "none";

    showCredentialsFields.style.display = "none";
    anonymousFields.style.display = "block";

  } else {

    hostField.removeAttribute("required")
    hostField.value = "";
    portField.removeAttribute("required")
    portField.value = "";
    pathField.removeAttribute("required")
    pathField.value = "";

    sourceDetailsFields.style.display = "none";

    urlField.setAttribute("required", "");
    urlFields.style.display = "block";

    showCredentialsFields.style.display = "block";
    anonymousFields.style.display = "none";

  }
  toggleCredentials();

}

