/*!
 * Copyright (c) 2014 ENEO Tecnología S.L.
 * This file is part of redBorder.
 * redBorder is free software: you can redistribute it and/or modify
 * it under the terms of the GNU Affero General Public License as published by
 * the Free Software Foundation, either version 3 of the License, or
 * (at your option) any later version.
 * redBorder is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU Affero General Public License for more details.
 * You should have received a copy of the GNU Affero General Public License
 * along with redBorder. If not, see <http://www.gnu.org/licenses/>.
 */

var csrf = $('meta[name="csrf-token"]').attr('content');

// Alphabetical navigation used on users
$(document).on('click', 'body.dashboards #add_user_modal nav.alphabetical a, body.reports #add_user_modal nav.alphabetical a', function(event){

  event.preventDefault();

  var letter = $(event.target).text();
  var found = false;

  $(".users_advice").hide();
  $("#users_search_result").hide();

  if (letter == "All"){

    $(".letter").show();

  } else {
    // Iterate over the letters
    $(".letter").each(function(index){

      if(this.id != ("letter_" + letter)){
        $(this).hide();
      } else {
        $(this).show();
        found = true;
      }

    });

    // Check if we have a letter
    if(!found){

      $(".users_advice").html(I18n.t('no_users') + letter);
      $(".users_advice").show();

    }
  }

});

$(document).on("propertychange keyup input paste", "body.dashboards #add_user_modal #user-search, body.reports #add_user_modal #user-search", function(event){

  $("#users_search_result").html("");

  $target = $(event.target);

  var search_terms = $target.val().toLowerCase();

  if(search_terms === "" || search_terms.length <= 1){

    $("nav.alphabetical a:last").addClass("active");
    $("#users_search_result").hide();
    $(".users_advice").hide();
    $(".letter").show();

  } else if (search_terms.length > 1) {

    $("nav.alphabetical a.active").removeClass("active");
    $("#users_search_result").show();
    $(".letter").hide();
    $(".users_advice").hide();

    var counter = 0;

    $("#add_user_modal .user").each(function(index, element){

      var $this = $(element);
      var name = $this.find(".name").text().toLowerCase();

      if(name.lastIndexOf(search_terms) != -1){
        $this.clone().appendTo("#users_search_result");
        counter++;
      }

    });

    if(counter === 0){
      $(".users_advice").html(I18n.t('no_users2') + $target.val());
      $(".users_advice").show();
    }

  }
});

$(document).on('click', '#users input.toggle_admin', function(e) {
  var user_id = $(this).parent('td').attr('data-user');
  if ($(this).is(':checked')) {
    $.ajax({
    	url: "/users/"+ user_id,
    	type: "PATCH",
    	dataType: "json",
    	data: {user: {admin: "1"},
    				 authenticity_token: csrf}
    });
  } else {
    $.ajax({
    	url: "/users/"+ user_id,
    	type: "PATCH",
    	dataType: "json",
    	data: {user: {admin: "0"},
    				 authenticity_token: csrf}
    });
  };
});


$(document).on('click', '#users input.toggle_enabled', function(e) {
  var user_id = $(this).parent('td').attr('data-user');
  if ($(this).is(':checked')) {
    $.ajax({
    	url: "/users/"+ user_id,
    	type: "PATCH",
    	dataType: "json",
    	data: {user: {enabled: 1},
    				 authenticity_token: csrf}
    });
  } else {
    $.ajax({
    	url: "/users/"+ user_id,
    	type: "PATCH",
    	dataType: "json",
    	data: {user: {enabled: 0},
    				 authenticity_token: csrf}
    });
  };
});

$(document).on('click', '#users input.toggle_blocked', function(e) {
  
  var user_id = $(this).parent('td').attr('data-user');
  if ($(this).is(':checked')) {
    var current_date = new Date();
    $.ajax({
    	url: "/users/"+ user_id,
    	type: "PATCH",
    	dataType: "json",
      data: {user: {locked_at: current_date},
    				 authenticity_token: csrf}
    });
  } else {
    $.ajax({
    	url: "/users/"+ user_id,
    	type: "PATCH",
    	dataType: "json",
    	data: {user: {locked_at: null, failed_attempts: 0},
    				 authenticity_token: csrf}
    });
  };
});

function clearNavigation() {
  $('nav.alphabetical a.active').removeClass('active');
}

$(document).on('click', "article#users nav.alphabetical a", function(event){

  $('article#users table tbody').replaceWith("<tbody><tr><td style='padding: 40px 0; font-size: 1.5em; text-align: center; color: #999;' colspan='11'><i class='fa fa-refresh fa-spin' style='margin-right: 5px;'></i>" + I18n.t('loading') + "</td></tbody>");
  $('.users_offset').remove();

});

$(document).on('submit', "article#users form.navbar-search", function(event){

  $('article#users table tbody').replaceWith("<tbody><tr><td style='padding: 40px 0; font-size: 1.5em; text-align: center; color: #999;' colspan='9'><i class='fa fa-refresh fa-spin' style='margin-right: 5px;'></i>" + I18n.t('loading') + "</td></tbody>");
  $('.users_offset').remove();

});

$(document).on('click', '.edit_password_button', function(event){
  event.preventDefault();
  $(event.currentTarget).hide();
  $(".recreate_apk_button, .api_key_copy_clipboard, .another_actions").hide();

  $("#edit_password").fadeIn(200);
});

function cancel_edit_password(){

  $("#edit_password").hide();
  $(".recreate_apk_button, .api_key_copy_clipboard, .another_actions, .edit_password_button").fadeIn(200);
  $("#user_password").val("");
  $("#user_password_confirmation").val("");

}

$(document).on('click', '.recreate_apk_button', function(event){

   $(".recreate_apk_button").html('<i class="fa fa-repeat fa-spin"></i>' + I18n.t('recreating_api'))

});

$(document).on("propertychange keyup input paste", "#user_current_password", function(event){

  // Check if the length of the text is > 0
  if($(event.target).val().length > 0){
    $("input[type='submit'].password-required").removeAttr("disabled");
  } else {
    $("input[type='submit'].password-required").attr("disabled", "disabled");
  }

});

document.addEventListener('DOMContentLoaded', function() {
  const togglePassword = document.getElementById('toggle-password');
  const passwordField = document.getElementById('password');

  if (togglePassword && passwordField) {
    togglePassword.addEventListener('click', function() {
      const type = passwordField.getAttribute('type') === 'password' ? 'text' : 'password';
      passwordField.setAttribute('type', type);

      this.querySelector('i').classList.toggle('fa-eye');
      this.querySelector('i').classList.toggle('fa-eye-slash');
    });
  }
});
