/*!
 * Copyright (c) 2014 ENEO Tecnología S.L.
 * This file is part of redBorder.
 * redBorder is free software: you can redistribute it and/or modify
 * it under the terms of the GNU Affero General Public License as published by
 * the Free Software Foundation, either version 3 of the License, or
 * (at your option) any later version.
 * redBorder is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU Affero General Public License for more details.
 * You should have received a copy of the GNU Affero General Public License
 * along with redBorder. If not, see <http://www.gnu.org/licenses/>.
 */

redBorder.utils.map = {
  /*
   * Calculate the bounds of the given polygons
   *
   * @param polygons [Array] Array of polygons. Every polygon is an array
   * @return [google.maps.LatLngBounds] Bounds
   */
  getPolygonsBounds: function(polygons) {
    var bounds = new google.maps.LatLngBounds();
    for(var j = 0; j < polygons.length; j++){
      // Iterate over zone's bounds
      for(var z = 0; z < polygons[j].length; z++){
        var latlng = new google.maps.LatLng(
          polygons[j][z][0],
          polygons[j][z][1]
        );
        // Extend bounds
        bounds.extend(latlng);
      }
    }

    return bounds;
  }
}
