#######################################################################
# Copyright (c) 2014 ENEO Tecnologia S.L.
# This file is part of redBorder.
# redBorder is free software: you can redistribute it and/or modify
# it under the terms of the GNU Affero General Public License as published by
# the Free Software Foundation, either version 3 of the License, or
# (at your option) any later version.
# redBorder is distributed in the hope that it will be useful,
# but WITHOUT ANY WARRANTY; without even the implied warranty of
# MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
# GNU Affero General Public License for more details.
# You should have received a copy of the GNU Affero General Public License
# along with redBorder. If not, see <http://www.gnu.org/licenses/>.
#######################################################################

module ApplicationObjectsHelper
  #
  # Create the options to edit an object
  #
  # == Parameters:
  # object::
  #   RedBorder object to get buttons
  #
  # == Returns:
  # HTML code of buttons to edit and destroy
  #
  def app_object_options(object)
    content = content_tag(:td, class: 'last row-right') do
      links = link_to(content_tag(:i, nil, class: 'fa fa-gear'),
                      edit_application_object_path(object, page: params[:page]),
                      class: 'btn edit-object', 'data-toggle' => 'modal',
                      'data-target' => '#default_modal',
                      'data-backdrop' => 'static')

      links + link_to(content_tag(:i, nil, class: 'fa fa-trash'),
                      application_object_path(object, page: params[:page]), method: :delete,
                      data: { confirm: "#{I18n.t('confirm')}" },
                      class: 'btn destroy-object', remote: true)
    end
    # Return the td
    content
  end
end
