#######################################################################
# Copyright (c) 2014 ENEO Tecnologia S.L.
# This file is part of redBorder.
# redBorder is free software: you can redistribute it and/or modify
# it under the terms of the GNU Affero General Public License as published by
# the Free Software Foundation, either version 3 of the License, or
# (at your option) any later version.
# redBorder is distributed in the hope that it will be useful,
# but WITHOUT ANY WARRANTY; without even the implied warranty of
# MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
# GNU Affero General Public License for more details.
# You should have received a copy of the GNU Affero General Public License
# along with redBorder. If not, see <http://www.gnu.org/licenses/>.
#######################################################################

module AuditsHelper
  def audits_url(model, id)
    # Check if the model is defined
    if Object.const_defined?(model)
      object = model.constantize.where(id: id)
      url = '#'
      unless object.blank?
        url = case model.downcase.to_sym
              when :user
                edit_user_path(id)
              when :sensor
                edit_sensor_path(id)
              end
      end
    end
  end

  def audits_uniq_users(user = current_user)
    #uniq_users = Audited.audit_class.unscoped.uniq
    #uniq_users = uniq_users.where(user_id: user.id) unless user.super_user?
    #uniq_users_ids = uniq_users.pluck(:user_id).reject(&:blank?) || []
    #uniq_users_ids.map { |id| [User.find_by(id: id).try(:name), id] }

    sql = 'SELECT DISTINCT "users"."name", "audits"."user_id" FROM "audits" INNER JOIN "users" ON "audits"."user_id"="users"."id"'
    sql += " WHERE \"audits\".\"user_id\" = #{ActiveRecord::Base.sanitize(user.id)}" unless user.super_user?
    ActiveRecord::Base.connection.execute(sql).values
  end

  def audits_uniq_resources(user = current_user)
    uniq_users = Audited.audit_class.unscoped.uniq
    uniq_users = uniq_users.where(user_id: user.id) unless user.super_user?
    uniq_users.pluck(:auditable_type).reject(&:blank?) || []
  end
end
