#######################################################################
# Copyright (c) 2014 ENEO Tecnologia S.L.
# This file is part of redBorder.
# redBorder is free software: you can redistribute it and/or modify
# it under the terms of the GNU Affero General Public License as published by
# the Free Software Foundation, either version 3 of the License, or
# (at your option) any later version.
# redBorder is distributed in the hope that it will be useful,
# but WITHOUT ANY WARRANTY; without even the implied warranty of
# MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
# GNU Affero General Public License for more details.
# You should have received a copy of the GNU Affero General Public License
# along with redBorder. If not, see <http://www.gnu.org/licenses/>.
#######################################################################

#
# Methods to help the creation of multiples aspects in manager
#
module CommonHelper
  # -------------------------------------------------------------
  # Alphabetical search
  # -------------------------------------------------------------
  
  #
  # Return HTML code of a table letter if it's required. This method is
  # user with alphabetical search and tables.
  #
  # This method mutate letter variable!!
  #
  # == Parameters:
  # letter::
  #   Current letter
  # element::
  #   String with the value of next element to compare with current letter
  # empty_columns::
  #   Number of empty columns
  #
  # == Returns:
  # HTML safe string with the code or empty.
  #
  def letter_header(letter, element, empty_columns)
    # Current element has the same letter
    return nil if letter == element[0, 1].upcase
    # Mutate the letter
    letter.gsub!(letter, element[0, 1].upcase) if letter
    # Build the row
    content_tag :tr, class: 'time_header' do
      content_tag(:td, element[0, 1].upcase, class: 'time') +
        ('<td></td>' * empty_columns).html_safe
    end
  end
end
