#######################################################################
# Copyright (c) 2014 ENEO Tecnologia S.L.
# This file is part of redBorder.
# redBorder is free software: you can redistribute it and/or modify
# it under the terms of the GNU Affero General Public License as published by
# the Free Software Foundation, either version 3 of the License, or
# (at your option) any later version.
# redBorder is distributed in the hope that it will be useful,
# but WITHOUT ANY WARRANTY; without even the implied warranty of
# MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
# GNU Affero General Public License for more details.
# You should have received a copy of the GNU Affero General Public License
# along with redBorder. If not, see <http://www.gnu.org/licenses/>.
#######################################################################

#
# => Methods to help the creation of UI.
#
module GraphHelper
  #
  # Convert a hash with key -> value to an Array of elements to send to
  # RbCharts library.
  #
  # == Parameters:
  # elements::
  #   Hash with data. The format must be:
  #     { name: value, name2: value2, ... }
  #
  # == Returns::
  # String with a JSON of array of elements
  #
  def hash_to_graph(elements)
    # Iterate over the hash
    elements.inject([]) do |acc, el|
      acc << { name: el.first, events: el.last }
    end.to_json.html_safe
  end
end
