module IntegrationsHelper
  # Return the value or empty string if an integration does not exist.
  #
  # This method preloads all integrations.
  #
  # Parameters:
  # - integration: Symbol with the integration to check.
  # - column: Boolean indicating if the integration is a column. Defaults to false.
  #
  # Returns:
  # - Value or an empty string.
  #
  def integration_value(integration, column = false)
    return "" if column && @integrations[integration].nil?
    @integrations[integration]
  end
end
