#######################################################################
# Copyright (c) 2014 ENEO Tecnologia S.L.
# This file is part of redBorder.
# redBorder is free software: you can redistribute it and/or modify
# it under the terms of the GNU Affero General Public License as published by
# the Free Software Foundation, either version 3 of the License, or
# (at your option) any later version.
# redBorder is distributed in the hope that it will be useful,
# but WITHOUT ANY WARRANTY; without even the implied warranty of
# MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
# GNU Affero General Public License for more details.
# You should have received a copy of the GNU Affero General Public License
# along with redBorder. If not, see <http://www.gnu.org/licenses/>.
#######################################################################

module LicensesHelper
  def license_status(status)
    label_class = case status
                  when :expired
                    'danger'
                  when :warning
                    'warning'
                  else
                    'success'
                  end

    content_tag(:span, class: "label label-#{label_class}") do
      status.to_s.capitalize
    end
  end

  def sensor_limits(license)
    sensor_limits = []

    License.available_sensor_types.each do |k, v|
      next if license.send(v[:limit]).zero?
      li_content = "#{content_tag(:span, v[:name])} <strong>#{license.send(v[:in_use])}/#{license.send(v[:limit])}</strong>".html_safe
      sensor_limits << content_tag(:li, li_content)
    end

    content_tag :ul do
      sensor_limits.join.html_safe
    end
  end
end
