#######################################################################
# Copyright (c) 2014 ENEO Tecnologia S.L.
# This file is part of redBorder.
# redBorder is free software: you can redistribute it and/or modify
# it under the terms of the GNU Affero General Public License as published by
# the Free Software Foundation, either version 3 of the License, or
# (at your option) any later version.
# redBorder is distributed in the hope that it will be useful,
# but WITHOUT ANY WARRANTY; without even the implied warranty of
# MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
# GNU Affero General Public License for more details.
# You should have received a copy of the GNU Affero General Public License
# along with redBorder. If not, see <http://www.gnu.org/licenses/>.
#######################################################################

#
# => Display the notification menu on the top navigation bar
#
module NotificationsHelper
  def notification_widget
    notifications = current_user
                    .notifications.order('read_status, created_at DESC')
                    .limit(10)
                    .load
    list = ''

    if notifications.size == 0
      list += content_tag(:li,
        link_to(I18n.t 'no_notifications'))
    else
      notifications.each do |notification|
        list += content_tag(:li, class: (notification.read_status ? '' : 'is_new')) do
          link_to (content_tag :div do
            content_tag(
              :span,
              truncate(notification.comment, length: 40),
              class: 'span-as-table-xl no-bold') +
            content_tag(
              :span,
              format_time(notification.created_at, year: false),
              class: 'timestamp')
          end), notifications_path, class: 'notification_link'
        end
      end
    end

    # if notifications.where(read_status: false).present?
    #   unread_count = current_user
    #                  .notifications.where(read_status: false)
    #                  .count

    #   a_tag = link_to open_notifications_path, class: 'notifications dropdown-toggle bell-shake-delay', remote: true, method: :patch, 'data-toggle' => 'dropdown' do
    #     content_tag(:i, nil, class: 'fa fa-bell fa-lg')
    #   end
    # else
    #   a_tag = link_to '#', class: 'notifications dropdown-toggle', 'data-toggle' => 'dropdown', 'title' => '0 unread messages' do
    #     content_tag(:i, nil, class: 'fa fa-bell fa-lg')
    #   end
    # end

    content_tag(:ul, class: 'as-table') do
      list.html_safe
    end
  end
end
