#######################################################################
# Copyright (c) 2014 ENEO Tecnologia S.L.
# This file is part of redBorder.
# redBorder is free software: you can redistribute it and/or modify
# it under the terms of the GNU Affero General Public License as published by
# the Free Software Foundation, either version 3 of the License, or
# (at your option) any later version.
# redBorder is distributed in the hope that it will be useful,
# but WITHOUT ANY WARRANTY; without even the implied warranty of
# MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
# GNU Affero General Public License for more details.
# You should have received a copy of the GNU Affero General Public License
# along with redBorder. If not, see <http://www.gnu.org/licenses/>.
#######################################################################

module ProductsHelper

  def time_for_results(time)
    beginnig_of_day = Time.zone.now.beginning_of_day
    end_of_day = Time.zone.now.end_of_day

    if (beginnig_of_day..end_of_day).cover?(time)
      "Today"
    elsif (beginnig_of_day - 1.day..end_of_day - 1.day).cover?(time)
      "Yesterday"
    else
      time.strftime('%Y/%m/%d')
    end

  end

  def get_product_dimension result
    case result["product"]
    when "ips"
      Redborder::Rbdruid.search_event_dimension_name result["dimension"]
    when "flow"
      Redborder::Rbdruid.search_traffic_dimension_name result["dimension"]
    when 'social'
      Redborder::Rbdruid.search_social_dimension_name result["dimension"]
    end
  end

end