DittoCode::HoldFile.if 'ENTERPRISE'
#######################################################################
# Copyright (c) 2014 ENEO Tecnologia S.L.
# This file is part of redBorder.
# redBorder is free software: you can redistribute it and/or modify
# it under the terms of the GNU Affero General Public License as published by
# the Free Software Foundation, either version 3 of the License, or
# (at your option) any later version.
# redBorder is distributed in the hope that it will be useful,
# but WITHOUT ANY WARRANTY; without even the implied warranty of
# MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
# GNU Affero General Public License for more details.
# You should have received a copy of the GNU Affero General Public License
# along with redBorder. If not, see <http://www.gnu.org/licenses/>.
#######################################################################

#
# Methods to help the UI of Support center
#
module SupportHelper
  #
  # Return an array of priorities based on user status
  #
  def support_priorities
    priorities = if current_user.super_user?
                  #["#{t 'support_helper.low'}", "#{t 'support_helper.normal'}", "#{t 'support_helper.high'}", "#{t 'support_helper.urgent'}"]
                  %w(low normal high urgent)
                 else
                   #["#{t 'support_helper.low'}", "#{t 'support_helper.normal'}"]
                   %w(low normal)
                 end
    priorities.map { |p| [p.capitalize, p] }
  end

  #
  # Return an Array of types to display as a selector
  #
  def support_types
    #["#{t 'support_helper.incidents'}", "#{t 'support_helper.questions'}", "#{t 'support_helper.problems'}", "#{t 'support_helper.tasks'}"].map { |p| [p.capitalize, p] }
    %w(question incident problem task ).map { |p| [p.capitalize, p] }
  end

  #
  # Return an Array of types of deployment to display as a selector
  #
  def support_types_of_deployment
    ["#{t 'support_helper.testing'}", "#{t 'support_helper.production'}"].map { |p| [p.capitalize, p] }
  end

  #
  # Show the correct name based on status
  #
  def support_status(status)
    return 'solved' if status == 'closed'
    'open'
  end

  #
  # Set the email in the form
  #
  def support_email(email)
    return email if email
    current_user.super_admin? ? '' : current_user.email
  end

  #
  # Return default text for description
  #
  def support_default_description
    "#{t 'support_helper.description'}&#10;&#10;&#10;"\
    "#{t 'support_helper.version'}&#10;&#10;&#10;"\
    "#{t 'support_helper.how'}&#10;&#10;&#10;"\
    "#{t 'support_helper.steps'}&#10;&#10;&#10;"\
    "#{t 'support_helper.actual'}&#10;&#10;&#10;"\
    "#{t 'support_helper.expected'}&#10;&#10;&#10;"\
    "#{t 'support_helper.additional'}&#10;&#10;".html_safe
  end
end
