#######################################################################
# Copyright (c) 2014 ENEO Tecnologia S.L.
# This file is part of redBorder.
# redBorder is free software: you can redistribute it and/or modify
# it under the terms of the GNU Affero General Public License as published by
# the Free Software Foundation, either version 3 of the License, or
# (at your option) any later version.
# redBorder is distributed in the hope that it will be useful,
# but WITHOUT ANY WARRANTY; without even the implied warranty of
# MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
# GNU Affero General Public License for more details.
# You should have received a copy of the GNU Affero General Public License
# along with redBorder. If not, see <http://www.gnu.org/licenses/>.
#######################################################################
#
#
#
class AlignmentInput < SimpleForm::Inputs::Base
  def input(wrapper_options = nil)
    "#{@builder.hidden_field(attribute_name, input_html_options)}<div>#{button_align_left}#{button_align_center}#{button_align_right}#{button_align_justify}</div>#{javascript_code}".html_safe
  end

  def button_align_left 
    if object.text_alignment.to_i == 1
      css = "btn-success"
    end  
    "<a class='btn btn-mini #{css}' data-align='1'><i class='fa fa-align-left'></i></a>"
  end 

  def button_align_center
    if object.text_alignment.to_i == 2
      css = "btn-success"
    end 
    "<a class='btn btn-mini #{css}' data-align='2'><i class='fa fa-align-center'></i></a>"
  end

  def button_align_right
    if object.text_alignment.to_i == 3
      css = "btn-success"
    end 
    "<a class='btn btn-mini #{css}' data-align='3'><i class='fa fa-align-right'></i></a>"
  end

  def button_align_justify
    if object.text_alignment.to_i == 4
      css = "btn-success"
    end 

    "<a class='btn btn-mini #{css}' data-align='4'><i class='fa fa-align-justify'></i></a>"
  end

  def javascript_code
    "<script>$(document).on('click', '##{@builder.options[:html][:id]} .#{object_name}_#{attribute_name} a', function(event){ event.preventDefault(); var target = $(this); $('##{@builder.options[:html][:id]} ##{object_name}_#{attribute_name}').val(target.attr('data-align')); $('##{@builder.options[:html][:id]} .#{object_name}_#{attribute_name} a.btn-success').removeClass('btn-success'); target.addClass('btn-success');})</script>"
  end
end