#######################################################################
# Copyright (c) 2014 ENEO Tecnologia S.L.
# This file is part of redBorder.
# redBorder is free software: you can redistribute it and/or modify
# it under the terms of the GNU Affero General Public License as published by
# the Free Software Foundation, either version 3 of the License, or
# (at your option) any later version.
# redBorder is distributed in the hope that it will be useful,
# but WITHOUT ANY WARRANTY; without even the implied warranty of
# MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
# GNU Affero General Public License for more details.
# You should have received a copy of the GNU Affero General Public License
# along with redBorder. If not, see <http://www.gnu.org/licenses/>.
#######################################################################

class AdminMailer < Devise::Mailer
  helper :application # gives access to all helpers defined within `application_helper`.
  include Devise::Controllers::UrlHelpers # Optional. eg. `confirmation_url`
  extend MailerHelper
  default from: email_sender
  layout 'new_mailer'

  def admin_email(subject, body)
    emails = User.where(sensor_id: Sensor.root, admin: true).map(&:email).join(',')
    @body = body

    mail(bcc: emails, subject: "#{subject} (#{cluster_id})")
  end

  def super_user_email(subject, body)
    emails = User.where(sensor_id: Sensor.root).map(&:email).join(',')
    @body = body

    mail(bcc: emails, subject: "#{subject} (#{cluster_id})")
  end

  private

  def cluster_id
    cluster = Redborder::Databag.load('rBglobal', 'cluster', false, false)
    cluster['uuid'] || 'Unknown' rescue 'Unknown'
  end
end
