#######################################################################
# Copyright (c) 2014 ENEO Tecnologia S.L.
# This file is part of redBorder.
# redBorder is free software: you can redistribute it and/or modify
# it under the terms of the GNU Affero General Public License as published by
# the Free Software Foundation, either version 3 of the License, or
# (at your option) any later version.
# redBorder is distributed in the hope that it will be useful,
# but WITHOUT ANY WARRANTY; without even the implied warranty of
# MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
# GNU Affero General Public License for more details.
# You should have received a copy of the GNU Affero General Public License
# along with redBorder. If not, see <http://www.gnu.org/licenses/>.
#######################################################################

class AlarmMailer < ApplicationMailer
  helper MailerHelper
  extend MailerHelper
  default from: email_sender
  layout 'new_mailer'

  def alarm(alarm, result)
    @alarm = alarm
    @result = result

    if result[:where] == :upper
      @limit = alarm.upper_mul_limit
      @multiplier = :multiplier_upper
    else
      @limit = alarm.bottom_mul_limit
      @multiplier = :multiplier_bottom
    end

    # Get the list of notified users
    notified = []

    @alarm.email_list.split(',').each do |email|
      user = User.find_by_email(email)
      notified << (user.try('name') || email)
    end

    # Join the array
    @result[:notified] = notified.join(', ')

    mail(to: @alarm.email_list,
         subject: "[#{Setting.company}] Alarm #{alarm.name} fired!")
  end
end
