#######################################################################
# Copyright (c) 2014 ENEO Tecnologia S.L.
# This file is part of redBorder.
# redBorder is free software: you can redistribute it and/or modify
# it under the terms of the GNU Affero General Public License as published by
# the Free Software Foundation, either version 3 of the License, or
# (at your option) any later version.
# redBorder is distributed in the hope that it will be useful,
# but WITHOUT ANY WARRANTY; without even the implied warranty of
# MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
# GNU Affero General Public License for more details.
# You should have received a copy of the GNU Affero General Public License
# along with redBorder. If not, see <http://www.gnu.org/licenses/>.
#######################################################################

class LicenseMailer < ApplicationMailer
  def request_email(cluster_uuid, name, email, megabytes_limit, sensors, organization)
    @cluster_uuid = cluster_uuid
    @name = name
    @email = email
    @megabytes_limit = megabytes_limit
    @sensors = sensors
    @organization_uuid = organization.is_root? ? nil : organization.uuid

    subject = t('licenses.email.request.subject', name: @name)

    mail \
      to: RedBorder::LICENSE_MAIL,
      subject: subject,
      reply_to: @email
  end

  def renew_email(uuid, cluster_uuid, name, email, megabytes_limit, sensors, organization)
    @uuid = uuid
    @cluster_uuid = cluster_uuid
    @name = name
    @email = email
    @megabytes_limit = megabytes_limit
    @sensors = sensors
    @organization_uuid = organization.is_root? ? nil : organization.uuid

    subject = t('licenses.email.renew.subject', name: @name)

    mail \
      to: RedBorder::LICENSE_MAIL,
      subject: subject,
      reply_to: @email
  end
end
