#######################################################################
# Copyright (c) 2014 ENEO Tecnologia S.L.
# This file is part of redBorder.
# redBorder is free software: you can redistribute it and/or modify
# it under the terms of the GNU Affero General Public License as published by
# the Free Software Foundation, either version 3 of the License, or
# (at your option) any later version.
# redBorder is distributed in the hope that it will be useful,
# but WITHOUT ANY WARRANTY; without even the implied warranty of
# MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
# GNU Affero General Public License for more details.
# You should have received a copy of the GNU Affero General Public License
# along with redBorder. If not, see <http://www.gnu.org/licenses/>.
#######################################################################

class MyMailer < Devise::Mailer
  helper :application # gives access to all helpers defined within `application_helper`.
  include Devise::Controllers::UrlHelpers # Optional. eg. `confirmation_url`
  extend MailerHelper
  default from: email_sender
  layout 'new_mailer'

  def creation_instructions(resource, password)
    @resource = resource
    @password = password

    mail(to: @resource.email, subject: "[redBorder] Welcome to redBorder!")
  end

  ## Send email to admin when a user is blocked 
  def user_locked (mailer, user)
    @mailer = mailer
    @user = user
    mail(to: @mailer.email, subject: "The user #{@user.name} has been blocked")
  end

  #Send email when the expiration date of the password is passed
  def user_pwd_expired (resource)
    @resource = resource
    @token = @resource.reset_password_token
    mail(to: @resource.email, subject: "Reset password email")
  end

end
