DittoCode::HoldFile.if 'ENTERPRISE'
#######################################################################
# Copyright (c) 2014 ENEO Tecnologia S.L.
# This file is part of redBorder.
# redBorder is free software: you can redistribute it and/or modify
# it under the terms of the GNU Affero General Public License as published by
# the Free Software Foundation, either version 3 of the License, or
# (at your option) any later version.
# redBorder is distributed in the hope that it will be useful,
# but WITHOUT ANY WARRANTY; without even the implied warranty of
# MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
# GNU Affero General Public License for more details.
# You should have received a copy of the GNU Affero General Public License
# along with redBorder. If not, see <http://www.gnu.org/licenses/>.
#######################################################################

class Alert < ApplicationRecord

  belongs_to :user

  validates :message, presence: true

  before_save :default_values

  def self.active_alerts(dismissed_alerts_ids = [])
      @alerts = Alert.where(enabled: true)
          .where('(start_time <= ? AND end_time >= ?) OR (start_time IS NULL AND end_time IS NULL)', Time.now, Time.now)
          .where.not(id: dismissed_alerts_ids)
  end

  private

  def default_values
      self.enabled = true if self.enabled.nil?
      self.user = User.current_user if self.user.nil?
  end
end
