class CaptivePortalSession
    include Rails.application.routes.url_helpers
    
    include ActiveModel::Validations
    include ActiveModel::Conversion
    extend  ActiveModel::Naming

    

    attr_accessor :objectId, :username, :client_mac, :password, :switch_url, :sensor_id, :ap_mac
    

    # ================================================================
    # Validations
    # ================================================================

    validates_presence_of :username
    validates :username, format: { with: Devise.email_regexp, message: "Invalid email" } 

    @id = nil
    
    def initialize(attributes = {})
        attributes.each do |name, value|
        send("#{name}=", value)
        end
    end

    def sensor_id
        @sensor_id
    end
    def sensor_id=(sensor_id)
        @sensor_id = sensor_id
    end

    def username
        @username
    end

    def username=(username) 
        @username = username
    end

    def password
        @password
    end 
    def password=(password)
        @password = password
    end
    
    def client_mac
        @client_mac
    end
    def client_mac=(client_mac)
        @client_mac = client_mac
    end

    def ap_mac
        @ap_mac
    end
    def ap_mac=(ap_mac)
        @ap_mac = ap_mac
    end

    def switch_url
        @switch_url
    end
    def switch_url=(switch_url)
        @switch_url = switch_url
    end
    
    def save
        if username and password
            begin
            
                config = YAML.load_file("#{Rails.root}/config/database.yml")      
                
                conn = PGconn.open( 
                                    :host => config['radius']['host'],
                                    :port => config['radius']['port'],
                                    :dbname => config['radius']['database'],
                                    :user => config['radius']['username'],
                                    :password => config['radius']['password']                                   
                                   )

                result = conn.exec("SELECT * from radcheck where (username like '#{username}' and value like '#{password}');")

                if result.none?
                    query = "INSERT INTO radcheck (username, attribute, op, value) VALUES ('#{username}', 'Cleartext-Password', ':=', '#{password}');"
                    result = conn.exec(query)
                end

                conn.close
                return true
            rescue Exception => e 
                Rails.logger.info "\n ERROR on database connection!: \n"
                Rails.logger.info e
                conn.close if conn
            end
        else
            Rails.logger.info "\n ERROR @cp_session.username or password are nil!"
        end
        return false
    end

  
    def destroy

    end

    def id
    return self.objectId
    end

    def persisted?
    !(self.id.nil?)
    end
end