#######################################################################
# Copyright (c) 2014 ENEO Tecnologia S.L.
# This file is part of redBorder.
# redBorder is free software: you can redistribute it and/or modify
# it under the terms of the GNU Affero General Public License as published by
# the Free Software Foundation, either version 3 of the License, or
# (at your option) any later version.
# redBorder is distributed in the hope that it will be useful,
# but WITHOUT ANY WARRANTY; without even the implied warranty of
# MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
# GNU Affero General Public License for more details.
# You should have received a copy of the GNU Affero General Public License
# along with redBorder. If not, see <http://www.gnu.org/licenses/>.
#######################################################################

#
# Methods to update parameters in physical nodes.
#
module PhysicalSensor
  extend ActiveSupport::Concern

  #
  # Returns true, this sensor has a physical node
  #
  # UNCOMMENT THIS WHEN WE SET SENSORS BY INHERITANCE
  #
  # def physical?
  #   true
  # end

  #
  # Reregister current sensor and return new private key
  #
  # == Returns:
  # String with private key if it's ok, or nil
  #
  def reregister
    # When we change sensors to inheritance we can delete this line
    return nil unless physical?

    begin
      return Chef::ApiClient.reregister(chef_node_name).private_key
    rescue StandardError => e
      Rails.logger.error e
      Rails.logger.error e.backtrace.join("\n")
    end
    nil
  end
end
