#######################################################################
# Copyright (c) 2014 ENEO Tecnologia S.L.
# This file is part of redBorder.
# redBorder is free software: you can redistribute it and/or modify
# it under the terms of the GNU Affero General Public License as published by
# the Free Software Foundation, either version 3 of the License, or
# (at your option) any later version.
# redBorder is distributed in the hope that it will be useful,
# but WITHOUT ANY WARRANTY; without even the implied warranty of
# MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
# GNU Affero General Public License for more details.
# You should have received a copy of the GNU Affero General Public License
# along with redBorder. If not, see <http://www.gnu.org/licenses/>.
#######################################################################

class IncidentStatus < ApplicationRecord
  # ==========================================================
  # Constants
  # ==========================================================
  CLOSED = 'Closed'.freeze
  CONTAINMENT_ACHIEVED = 'Containment Achieved'.freeze
  INCIDENT_REPORTED = 'Incident Reported'.freeze
  NEW = 'New'.freeze
  OPEN = 'Open'.freeze
  REJECTED = 'Rejected'.freeze
  RESTORATION_ACHIEVED = 'Restoration Achieved'.freeze
  STALLED = 'Stalled'.freeze
  
  STATUSES = [CLOSED, CONTAINMENT_ACHIEVED, INCIDENT_REPORTED, NEW, OPEN, REJECTED, RESTORATION_ACHIEVED, STALLED].freeze

  # ==========================================================
  # Relations
  # ==========================================================
  has_many :incidents
end