#######################################################################
# Copyright (c) 2014 ENEO Tecnologia S.L.
# This file is part of redBorder.
# redBorder is free software: you can redistribute it and/or modify
# it under the terms of the GNU Affero General Public License as published by
# the Free Software Foundation, either version 3 of the License, or
# (at your option) any later version.
# redBorder is distributed in the hope that it will be useful,
# but WITHOUT ANY WARRANTY; without even the implied warranty of
# MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
# GNU Affero General Public License for more details.
# You should have received a copy of the GNU Affero General Public License
# along with redBorder. If not, see <http://www.gnu.org/licenses/>.
#######################################################################

class Lookup < ApplicationRecord
  PRIVATE_IPS = %r{
	  ^127\.0\.0\.1$                | # localhost
	  ^(10                          | # private IP 10.x.x.x
	    172\.(1[6-9]|2[0-9]|3[0-1]) | # private IP in the range 172.16.0.0 .. 172.31.255.255
	    192\.168                      # private IP 192.168.x.x
	   )\.
	}x

  URL_REGEXP = /\A(http|https):\/\/[a-z0-9]+([\-\.]{1}[a-z0-9]+)*\.[a-z]{2,5}(:[0-9]{1,5})?(\/.*)?\z/ix # Regular Expression for valid URLS
  # ================================================================
  # Validations
  # ================================================================

  validates :title, presence: true
  validates :value, presence: true, format: { with: URL_REGEXP, message: I18n.t('models.invalid_url') }
end
