#######################################################################
# Copyright (c) 2024 ENEO Tecnologia S.L.
# This file is part of redBorder.
# redBorder is free software: you can redistribute it and/or modify
# it under the terms of the GNU Affero General Public License as published by
# the Free Software Foundation, either version 3 of the License, or
# (at your option) any later version.
# redBorder is distributed in the hope that it will be useful,
# but WITHOUT ANY WARRANTY; without even the implied warranty of
# MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
# GNU Affero General Public License for more details.
# You should have received a copy of the GNU Affero General Public License
# along with redBorder. If not, see <http://www.gnu.org/licenses/>.
#######################################################################

class PlaybookAssignmentRule < ApplicationRecord
  belongs_to :user
  has_many :playbook_assignment_rules_conditions, dependent: :destroy
  accepts_nested_attributes_for :playbook_assignment_rules_conditions, allow_destroy: true

  validates :user, presence: true
  validates :condition_type, presence: true

  before_create :set_default_priority

  def set_default_priority
    if self.priority.nil?
      max_priority = PlaybookAssignmentRule.maximum(:priority) || 0
      self.priority = max_priority + 1
    end
  end

  def set_enabled
    self.enabled = !self.enabled
  end
end
