#######################################################################
# Copyright (c) 2014 ENEO Tecnologia S.L.
# This file is part of redBorder.
# redBorder is free software: you can redistribute it and/or modify
# it under the terms of the GNU Affero General Public License as published by
# the Free Software Foundation, either version 3 of the License, or
# (at your option) any later version.
# redBorder is distributed in the hope that it will be useful,
# but WITHOUT ANY WARRANTY; without even the implied warranty of
# MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
# GNU Affero General Public License for more details.
# You should have received a copy of the GNU Affero General Public License
# along with redBorder. If not, see <http://www.gnu.org/licenses/>.
#######################################################################

class Plugin < ApplicationRecord
    has_many :plugin_versions, dependent: :destroy

    def installed?
      plugin_versions.select{|p| p.installed }.count > 0
    end

    def installed
        installed? ? plugin_versions.select{|p| p.installed }.first : nil
    end

    def installed_version
      installed ? installed.version : nil
    end

    def version
      plugin_versions.count > 0 ? plugin.version.last.version : nil
    end

end
