#######################################################################
# Copyright (c) 2014 ENEO Tecnologia S.L.
# This file is part of redBorder.
# redBorder is free software: you can redistribute it and/or modify
# it under the terms of the GNU Affero General Public License as published by
# the Free Software Foundation, either version 3 of the License, or
# (at your option) any later version.
# redBorder is distributed in the hope that it will be useful,
# but WITHOUT ANY WARRANTY; without even the implied warranty of
# MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
# GNU Affero General Public License for more details.
# You should have received a copy of the GNU Affero General Public License
# along with redBorder. If not, see <http://www.gnu.org/licenses/>.
#######################################################################

#
# => Ball graph type. Define the validations, fields, defaults...
#
class WidgetGraph::Ball < WidgetGraph::Base
  display_name 'Ball'
  image 'ball.png'
  data [:total]
  order 7

  # ball_max: This field set the point at the bal turn red.
  #           If you set this field to 100 and the value returned
  #           of druid is 10, the ball will be green. If the value returned is 98,
  #           the ball will be red
  widget_fields [:ball_max, :always_show_quantity, :offset, :reference, :invert_colors]

  widget_after_initialize do
    self.ball_max ||= 100
    self.always_show_quantity ||= false
  end
end
