#######################################################################
# Copyright (c) 2014 ENEO Tecnologia S.L.
# This file is part of redBorder.
# redBorder is free software: you can redistribute it and/or modify
# it under the terms of the GNU Affero General Public License as published by
# the Free Software Foundation, either version 3 of the License, or
# (at your option) any later version.
# redBorder is distributed in the hope that it will be useful,
# but WITHOUT ANY WARRANTY; without even the implied warranty of
# MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
# GNU Affero General Public License for more details.
# You should have received a copy of the GNU Affero General Public License
# along with redBorder. If not, see <http://www.gnu.org/licenses/>.
#######################################################################

#
# => Performance index widget
#
class WidgetGraph::PerformanceIndex < WidgetGraph::Base
  display_name 'Performance Index'
  widget_fields [:low_limit, :medium_limit, :low_color, :medium_color, :high_color,
                 :low_tag, :medium_tag, :high_tag]
  data [:performance]
  image 'performance_index.png'

  widget_validates :low_limit, presence: true, numericality: { greater_than_or_equal_to: 0 }
  widget_validates :medium_limit, presence: true, numericality: { greater_than_or_equal_to: 0 }
  widget_validate :check_medium_limit do
    unless medium_limit.blank? || low_limit.blank?
      errors.add(:medium_limit, 'Can not be lower or equal than low limit') if
        medium_limit.to_f <= low_limit.to_f
    end
  end

  widget_after_initialize do
    self.low_tag ||= 'Low'
    self.medium_tag ||= 'Medium'
    self.high_tag ||= 'High'
  end
end
