#######################################################################
# Copyright (c) 2014 ENEO Tecnologia S.L.
# This file is part of redBorder.
# redBorder is free software: you can redistribute it and/or modify
# it under the terms of the GNU Affero General Public License as published by
# the Free Software Foundation, either version 3 of the License, or
# (at your option) any later version.
# redBorder is distributed in the hope that it will be useful,
# but WITHOUT ANY WARRANTY; without even the implied warranty of
# MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
# GNU Affero General Public License for more details.
# You should have received a copy of the GNU Affero General Public License
# along with redBorder. If not, see <http://www.gnu.org/licenses/>.
#######################################################################

#
# => Performance index widget
#
class WidgetGraph::Performance < WidgetType::Base
  graphs [:performance_index]
  widget_fields [:range, :aggregation, :skip_empty]

  widget_after_initialize do
    self.skip_empty ||= false
  end

  def performance(user = @widget.parent.owner, options = {})
    source = Redborder::DruidSource.get(source: @widget.product_type)
    intervals = {
      low: 0,
      medium: 0,
      high: 0,
      total: 0
    }

    data = source.timeserie(
      range: @widget.range,
      user: user,
      ignore_user_namespaces: options[:ignore_user_namespaces] || false,
      start_time: options[:start_time] || start_time,
      end_time: options[:end_time] || end_time,
      granularity: options[:granularity] || @widget.granularity,
      aggregation: @widget.aggregation,
      skip_empty: options[:skip_empty] || true,
      search: @widget.fetch_filters
    )
    intervals[:total] = data.length;
    data.each do |d|
      if d[:event][:events] < @widget.property['low_limit'].to_f
        intervals[:low] += 1
      elsif d[:event][:events] < @widget.property['medium_limit'].to_f
        intervals[:medium] += 1
      else
        intervals[:high] += 1
      end
    end
    intervals
  end
end
