#######################################################################
# Copyright (c) 2014 ENEO Tecnologia S.L.
# This file is part of redBorder.
# redBorder is free software: you can redistribute it and/or modify
# it under the terms of the GNU Affero General Public License as published by
# the Free Software Foundation, either version 3 of the License, or
# (at your option) any later version.
# redBorder is distributed in the hope that it will be useful,
# but WITHOUT ANY WARRANTY; without even the implied warranty of
# MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
# GNU Affero General Public License for more details.
# You should have received a copy of the GNU Affero General Public License
# along with redBorder. If not, see <http://www.gnu.org/licenses/>.
#######################################################################
class AddGlobalFilters
  def self.call(session, params)
    return unless params.is_a? Hash
    type_name = nil
    uuid = nil
    # Delete empty or incorrent params
    params.each do |k, v|
      case k.to_sym
      when :advanced
        v.each do |i, filter|
          params[k].delete(i) unless filter['column'].present? &&
                                     filter['value'].present?
        end
      when :sensor_uuid
        sensor = Sensor.find_by(uuid: params[k])
        if sensor
          type_name = Sensor::DOMAIN_TYPES[sensor.domain_type][:name] if sensor.type == Sensor::DOMAIN
          uuid = params[:sensor_uuid]
        else
          params.delete(:sensor_uuid)
          params.delete(:sensor_name)
        end
      when :sensor_name
        if params[k].blank?
          params.delete(:sensor_uuid)
          params.delete(:sensor_name)
        end
      else
        params.delete(k) unless params[k].present?
      end
    end

    # Can't add a new key into hash during iteration
    params["#{type_name.downcase}_uuid".to_sym] = uuid if type_name && uuid

    session[:global_filters] = params.symbolize_keys
  end
end
