# frozen_string_literal: true

# config/initializers/grover.rb
Grover.configure do |config|
  config.options = {
    format: 'A4',
    margin: {
      top: 0,
      bottom: 0,
      left: 0,
      right: 0
    },
    print_background: true,
    cache: false,
    emulate_media: 'screen',
    timezone: 'Atlantic/Canary',
    timeout: 30_000, # Timeout in ms. A value of `0` means 'no timeout'
    request_timeout: 30_000, # Timeout when fetching the content (overloads the `timeout` option)
    convert_timeout: 30_000, # Timeout when converting the content (overloads the `timeout` option, only applies to PDF conversion)
    wait_until: 'networkidle0',
    launch_args: ['--no-sandbox', '--disable-setuid-sandbox']
  }
end