#######################################################################
# Copyright (c) 2014 ENEO Tecnologia S.L.
# This file is part of redBorder.
# redBorder is free software: you can redistribute it and/or modify
# it under the terms of the GNU Affero General Public License as published by
# the Free Software Foundation, either version 3 of the License, or
# (at your option) any later version.
# redBorder is distributed in the hope that it will be useful,
# but WITHOUT ANY WARRANTY; without even the implied warranty of
# MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
# GNU Affero General Public License for more details.
# You should have received a copy of the GNU Affero General Public License
# along with redBorder. If not, see <http://www.gnu.org/licenses/>.
#######################################################################

#
# Set a custom log
#
RedBorder::Application.configure do
  # Enable custom logs
  config.lograge.enabled = true
  config.lograge.keep_original_rails_log = true

  # add time to lograge
  config.lograge.custom_options = lambda do |event|
    { time: event.time }
  end

  # Set the file
  config.lograge.logger =
    ActiveSupport::Logger.new(Rails.root.join("log/#{Rails.env}.log"))
  format = '%Y-%m-%dT%H:%M:%S.%L'
  config.lograge.formatter = lambda do |event|
    "[#{event[:time].strftime(format)}] "\
    "#{event.except(:time).map { |k, v| "#{k}=#{v.to_s.strip}" }.join(' ')}"
  end
end
