#######################################################################
# Copyright (c) 2014 ENEO Tecnologia S.L.
# This file is part of redBorder.
# redBorder is free software: you can redistribute it and/or modify
# it under the terms of the GNU Affero General Public License as published by
# the Free Software Foundation, either version 3 of the License, or
# (at your option) any later version.
# redBorder is distributed in the hope that it will be useful,
# but WITHOUT ANY WARRANTY; without even the implied warranty of
# MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
# GNU Affero General Public License for more details.
# You should have received a copy of the GNU Affero General Public License
# along with redBorder. If not, see <http://www.gnu.org/licenses/>.
#######################################################################

require "#{Rails.root}/lib/redborder/module.rb"
require 'redborder' # Default menu entries should be loaded before modules'

unless ENV['NO_MODULES']
  Rails.logger.info '[RB] Initializing modules...'
  # Loads the core plugins located in lib/plugins
  Dir.glob(File.join(Rails.root, 'lib/modules/*')).sort.each do |directory|
    next unless File.directory?(directory)

    module_name = directory.split('/').last
    # Check if the module is activated
    DittoCode::Exec.if 'ENTERPRISE' do
      if Redborder::Module.available?(module_name)
        initializer = File.join(directory, 'config/init.rb')
        if File.file?(initializer)
          eval(File.read(initializer), binding, initializer)
        end
      end
    end

    DittoCode::Exec.if 'COMMUNITY' do
      initializer = File.join(directory, 'config/init.rb')
      if File.file?(initializer)
        # config = RedmineApp::Application.config
        eval(File.read(initializer), binding, initializer)
      end
    end
  end
end
