#######################################################################
# Copyright (c) 2014 ENEO Tecnologia S.L.
# This file is part of redBorder.
# redBorder is free software: you can redistribute it and/or modify
# it under the terms of the GNU Affero General Public License as published by
# the Free Software Foundation, either version 3 of the License, or
# (at your option) any later version.
# redBorder is distributed in the hope that it will be useful,
# but WITHOUT ANY WARRANTY; without even the implied warranty of
# MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
# GNU Affero General Public License for more details.
# You should have received a copy of the GNU Affero General Public License
# along with redBorder. If not, see <http://www.gnu.org/licenses/>.
#######################################################################

class AddUuidToSensors < ActiveRecord::Migration
  def up
    add_column :sensors, :uuid, :string

    # Update sensors adding value to new column.
    Sensor.all.each do |sensor|
      rand_int = rand(1..9_223_372_036_854_775_807)
      sensor.update(uuid: rand_int)
    end

    # Update active_data_sources values from users
    User.all.each do |user|
      user.active_data_sources = user.data_sources_ids
      user.save
    end
  end

  def down
    remove_column :sensors, :uuid
  end
end
