class CreateIntegrations < ActiveRecord::Migration[5.0]
  def change
    create_table :integrations do |t|
      t.string :name, :limit => 255, :default => "", :null => false
      t.text :value
      t.datetime :created_at
      t.datetime :updated_at

      t.timestamps
    end

    add_index :integrations, :name, :unique => true, name: "index_integrations_on_name", using: :btree
  end
end
