#######################################################################
# Copyright (c) 2024 ENEO Tecnologia S.L.
# This file is part of redBorder.
# redBorder is free software: you can redistribute it and/or modify
# it under the terms of the GNU Affero General Public License as published by
# the Free Software Foundation, either version 3 of the License, or
# (at your option) any later version.
# redBorder is distributed in the hope that it will be useful,
# but WITHOUT ANY WARRANTY; without even the implied warranty of
# MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
# GNU Affero General Public License for more details.
# You should have received a copy of the GNU Affero General Public License
# along with redBorder. If not, see <http://www.gnu.org/licenses/>.
#######################################################################

class CreateIncidentReports < ActiveRecord::Migration[5.0]
  def change
    create_table :incident_reports do |t|
      t.references :incident, foreign_key: true
      t.text :executive_summary
      t.text :event_summary

      t.timestamps
    end

    # Associate existing incidents with new incident reports
    reversible do |dir|
      dir.up do
        Incident.find_each do |incident|
          IncidentReports.create(incident_id: incident.id)
        end
      end
    end
  end
end
