# This file is auto-generated from the current state of the database. Instead
# of editing this file, please use the migrations feature of Active Record to
# incrementally modify your database, and then regenerate this schema definition.
#
# Note that this schema.rb definition is the authoritative source for your
# database schema. If you need to create the application database on another
# system, you should be using db:schema:load, not running all the migrations
# from scratch. The latter is a flawed and unsustainable approach (the more migrations
# you'll amass, the slower it'll run and the greater likelihood for issues).
#
# It's strongly recommended that you check this file into your version control system.

ActiveRecord::Schema.define(version: 20240722133729) do

  # These are extensions that must be enabled in order to support this database
  enable_extension "plpgsql"

  create_table "access_points", force: :cascade do |t|
    t.string   "ip_address"
    t.string   "mac_address"
    t.string   "name"
    t.string   "switch_name"
    t.integer  "switch_id"
    t.float    "latitude"
    t.float    "longitude"
    t.float    "x"
    t.float    "y"
    t.integer  "sensor_id"
    t.datetime "created_at"
    t.datetime "updated_at"
    t.text     "description"
    t.integer  "status",        default: 0
    t.datetime "last_check_in"
    t.integer  "clients",       default: 0
    t.integer  "uptime",        default: 0
    t.text     "enrichment"
    t.integer  "next_status",   default: 0
    t.index ["next_status"], name: "index_access_points_on_next_status", using: :btree
    t.index ["sensor_id"], name: "index_access_points_on_sensor_id", using: :btree
    t.index ["switch_id"], name: "index_access_points_on_switch_id", using: :btree
  end

  create_table "access_points_zones", id: false, force: :cascade do |t|
    t.integer "zone_id"
    t.integer "access_point_id"
    t.index ["zone_id", "access_point_id"], name: "index_access_points_zones_on_zone_id_and_access_point_id", using: :btree
  end

  create_table "actions", force: :cascade do |t|
    t.string   "name"
    t.string   "description"
    t.datetime "created_at"
    t.datetime "updated_at"
    t.boolean  "selectable",  default: true
  end

  create_table "alarms", force: :cascade do |t|
    t.string   "name"
    t.text     "condition"
    t.boolean  "enabled"
    t.datetime "fired"
    t.integer  "interval"
    t.string   "product_type"
    t.integer  "upper_limit"
    t.integer  "bottom_limit"
    t.integer  "time_window"
    t.boolean  "upper_limit_enabled"
    t.boolean  "bottom_limit_enabled"
    t.integer  "user_id"
    t.string   "aggregation"
    t.boolean  "notify_to_syslog"
    t.boolean  "notify_to_email"
    t.string   "monitor_tab"
    t.string   "email_list"
    t.integer  "multiplier_upper"
    t.integer  "multiplier_bottom"
    t.integer  "severity_id"
    t.datetime "created_at"
    t.datetime "updated_at"
    t.boolean  "notify_to_mobile"
    t.datetime "last_fired"
    t.string   "timezone"
    t.boolean  "notify_to_slack"
    t.string   "slack_webhook"
    t.boolean  "outliers_enabled",     default: false
    t.string   "outliers_granularity", default: "all"
    t.index ["severity_id"], name: "index_alarms_on_severity_id", using: :btree
    t.index ["user_id"], name: "index_alarms_on_user_id", using: :btree
  end

  create_table "alerts", force: :cascade do |t|
    t.datetime "created_at"
    t.datetime "updated_at"
    t.text     "message"
    t.boolean  "enabled"
    t.string   "level"
    t.integer  "user_id"
    t.datetime "start_time"
    t.datetime "end_time"
    t.index ["user_id"], name: "index_alerts_on_user_id", using: :btree
  end

  create_table "application_objects", force: :cascade do |t|
    t.string   "name"
    t.string   "value"
    t.text     "description"
    t.datetime "created_at"
    t.datetime "updated_at"
  end

  create_table "audits", force: :cascade do |t|
    t.integer  "auditable_id"
    t.string   "auditable_type"
    t.integer  "associated_id"
    t.string   "associated_type"
    t.integer  "user_id"
    t.string   "user_type"
    t.string   "username"
    t.string   "action"
    t.text     "audited_changes"
    t.integer  "version",         default: 0
    t.text     "comment"
    t.string   "remote_address"
    t.datetime "created_at"
    t.string   "request_uuid"
    t.index ["associated_id", "associated_type"], name: "associated_index", using: :btree
    t.index ["auditable_id", "auditable_type"], name: "auditable_index", using: :btree
    t.index ["created_at"], name: "index_audits_on_created_at", using: :btree
    t.index ["request_uuid"], name: "index_audits_on_request_uuid", using: :btree
    t.index ["user_id", "user_type"], name: "user_index", using: :btree
  end

  create_table "categories", force: :cascade do |t|
    t.string   "name"
    t.string   "description"
    t.datetime "created_at"
    t.datetime "updated_at"
  end

  create_table "class_types", force: :cascade do |t|
    t.string   "name"
    t.string   "description"
    t.integer  "rule_db_version_id"
    t.datetime "created_at"
    t.datetime "updated_at"
    t.integer  "severity_id"
    t.index ["rule_db_version_id"], name: "index_class_types_on_rule_db_version_id", using: :btree
    t.index ["severity_id"], name: "index_class_types_on_severity_id", using: :btree
  end

  create_table "classifications", force: :cascade do |t|
    t.string   "name"
    t.text     "description"
    t.integer  "hotkey"
    t.boolean  "locked",       default: false
    t.integer  "events_count", default: 0
    t.datetime "created_at"
    t.datetime "updated_at"
  end

  create_table "correlation_engine_rules", force: :cascade do |t|
    t.string   "name"
    t.text     "input",          default: [],    array: true
    t.text     "execution_plan"
    t.boolean  "enabled",        default: true
    t.boolean  "applied",        default: false
    t.integer  "user_id"
    t.datetime "created_at"
    t.datetime "updated_at"
    t.json     "output",         default: {}
    t.index ["user_id"], name: "index_correlation_engine_rules_on_user_id", using: :btree
  end

  create_table "custom_tabs", force: :cascade do |t|
    t.string   "name"
    t.boolean  "enabled",    default: false
    t.boolean  "percentage", default: false
    t.string   "category"
    t.string   "units"
    t.datetime "created_at"
    t.datetime "updated_at"
  end

  create_table "dashboard_roles", force: :cascade do |t|
    t.integer  "dashboard_id"
    t.integer  "role_id"
    t.boolean  "can_edit"
    t.datetime "created_at"
    t.datetime "updated_at"
  end

  create_table "dashboard_sensors", force: :cascade do |t|
    t.integer  "dashboard_id"
    t.integer  "sensor_id"
    t.string   "can_edit",     limit: 255
    t.datetime "created_at"
    t.datetime "updated_at"
  end

  create_table "dashboard_users", force: :cascade do |t|
    t.integer  "dashboard_id"
    t.integer  "user_id"
    t.boolean  "can_edit"
    t.datetime "created_at"
    t.datetime "updated_at"
  end

  create_table "dashboards", force: :cascade do |t|
    t.integer  "user_id"
    t.string   "name"
    t.text     "description"
    t.string   "layout"
    t.string   "img_position"
    t.string   "content_type"
    t.boolean  "locked"
    t.string   "image_file_name"
    t.string   "image_content_type"
    t.bigint   "image_file_size"
    t.datetime "image_updated_at"
    t.datetime "created_at"
    t.datetime "updated_at"
    t.boolean  "default"
    t.string   "background_color"
    t.index ["user_id"], name: "index_dashboards_on_user_id", using: :btree
  end

  create_table "delayed_jobs", force: :cascade do |t|
    t.integer  "priority",   default: 0
    t.integer  "attempts",   default: 0
    t.text     "handler"
    t.text     "last_error"
    t.datetime "run_at"
    t.datetime "locked_at"
    t.datetime "failed_at"
    t.string   "locked_by"
    t.string   "queue"
    t.datetime "created_at"
    t.datetime "updated_at"
    t.index ["priority", "run_at"], name: "delayed_jobs_priority", using: :btree
  end

  create_table "event_filters", force: :cascade do |t|
    t.integer  "policy_id"
    t.integer  "user_id"
    t.integer  "rule_sid"
    t.integer  "rule_gid"
    t.string   "filter_type"
    t.integer  "count",          default: 1
    t.integer  "seconds",        default: 1
    t.integer  "tracked_type",   default: 1
    t.integer  "position"
    t.text     "comment"
    t.string   "source_ip"
    t.string   "destination_ip"
    t.datetime "created_at"
    t.datetime "updated_at"
    t.index ["policy_id"], name: "index_event_filters_on_policy_id", using: :btree
    t.index ["user_id"], name: "index_event_filters_on_user_id", using: :btree
  end

  create_table "factory_policies", force: :cascade do |t|
    t.string   "name"
    t.string   "description"
    t.datetime "created_at"
    t.datetime "updated_at"
  end

  create_table "factory_policy_rules", force: :cascade do |t|
    t.integer  "rule_id"
    t.integer  "factory_policy_id"
    t.integer  "action_id"
    t.datetime "created_at"
    t.datetime "updated_at"
    t.index ["action_id"], name: "index_factory_policy_rules_on_action_id", using: :btree
    t.index ["factory_policy_id"], name: "index_factory_policy_rules_on_factory_policy_id", using: :btree
    t.index ["rule_id"], name: "index_factory_policy_rules_on_rule_id", using: :btree
  end

  create_table "families", force: :cascade do |t|
    t.string   "name"
    t.string   "description"
    t.datetime "created_at"
    t.datetime "updated_at"
  end

  create_table "flowbit_groups", force: :cascade do |t|
    t.string   "name"
    t.string   "description"
    t.datetime "created_at"
    t.datetime "updated_at"
  end

  create_table "flowbit_rules", force: :cascade do |t|
    t.integer  "flowbit_state_id"
    t.integer  "flowbit_group_id"
    t.integer  "rule_id"
    t.integer  "flowbit_id"
    t.datetime "created_at"
    t.datetime "updated_at"
    t.index ["flowbit_group_id"], name: "index_flowbit_rules_on_flowbit_group_id", using: :btree
    t.index ["flowbit_id"], name: "index_flowbit_rules_on_flowbit_id", using: :btree
    t.index ["flowbit_state_id"], name: "index_flowbit_rules_on_flowbit_state_id", using: :btree
    t.index ["rule_id"], name: "index_flowbit_rules_on_rule_id", using: :btree
  end

  create_table "flowbit_states", force: :cascade do |t|
    t.string   "name"
    t.string   "description"
    t.datetime "created_at"
    t.datetime "updated_at"
  end

  create_table "flowbits", force: :cascade do |t|
    t.string   "name"
    t.string   "description"
    t.datetime "created_at"
    t.datetime "updated_at"
  end

  create_table "gps_markers", force: :cascade do |t|
    t.float    "x"
    t.float    "y"
    t.float    "latitude"
    t.float    "longitude"
    t.integer  "overlay_map_id"
    t.datetime "created_at"
    t.datetime "updated_at"
  end

  create_table "groups", force: :cascade do |t|
    t.string   "name"
    t.string   "description"
    t.datetime "created_at"
    t.datetime "updated_at"
  end

  create_table "impacts", force: :cascade do |t|
    t.string   "name"
    t.string   "description"
    t.datetime "created_at"
    t.datetime "updated_at"
  end

  create_table "impacts_rules", id: false, force: :cascade do |t|
    t.integer "impact_id"
    t.integer "rule_id"
  end

  create_table "incident_statuses", force: :cascade do |t|
    t.string   "name",       null: false
    t.datetime "created_at"
    t.datetime "updated_at"
  end

  create_table "incident_users", force: :cascade do |t|
    t.integer  "incident_id"
    t.integer  "user_id"
    t.datetime "created_at"
    t.datetime "updated_at"
    t.index ["incident_id", "user_id"], name: "index_incident_users_on_incident_id_and_user_id", unique: true, using: :btree
    t.index ["incident_id"], name: "index_incident_users_on_incident_id", using: :btree
    t.index ["user_id"], name: "index_incident_users_on_user_id", using: :btree
  end

  create_table "incidents", force: :cascade do |t|
    t.string   "uuid"
    t.string   "name"
    t.string   "source"
    t.string   "description"
    t.integer  "incident_status_id"
    t.integer  "priority_id"
    t.datetime "created_at"
    t.datetime "updated_at"
  end

  create_table "integrations", force: :cascade do |t|
    t.string   "name",       limit: 255, default: "", null: false
    t.text     "value"
    t.datetime "created_at",                          null: false
    t.datetime "updated_at",                          null: false
    t.index ["name"], name: "index_integrations_on_name", unique: true, using: :btree
  end

  create_table "licenses", force: :cascade do |t|
    t.text     "encoded_info"
    t.text     "signature"
    t.string   "uuid"
    t.bigint   "limit_bytes"
    t.string   "cluster_uuid"
    t.json     "sensors"
    t.datetime "expire_at"
    t.datetime "created_at"
    t.datetime "updated_at"
    t.integer  "sensor_id"
    t.index ["sensor_id"], name: "index_licenses_on_sensor_id", using: :btree
  end

  create_table "lookups", force: :cascade do |t|
    t.string   "title"
    t.text     "value"
    t.datetime "created_at"
    t.datetime "updated_at"
  end

  create_table "mitres", force: :cascade do |t|
    t.string   "mitre_tactic_id",                   null: false
    t.string   "name"
    t.text     "description"
    t.datetime "created_at",                        null: false
    t.datetime "updated_at",                        null: false
    t.integer  "rule_ids",          default: [],                 array: true
    t.boolean  "is_tactic",         default: false
    t.boolean  "is_technique",      default: false
    t.boolean  "is_subtechnique",   default: false
    t.string   "technique_name"
    t.string   "subtechnique_name"
    t.string   "technique_id"
    t.string   "subtechnique_id"
    t.string   "tactic_id"
  end

  create_table "monitor_categories", force: :cascade do |t|
    t.string   "name"
    t.text     "description"
    t.string   "technology"
    t.string   "category"
    t.string   "main_category"
    t.integer  "impact",                        default: 1
    t.text     "operation"
    t.string   "sensor_types"
    t.boolean  "default",                       default: false
    t.datetime "created_at"
    t.datetime "updated_at"
    t.string   "bulkstats_schema_file_name"
    t.string   "bulkstats_schema_content_type"
    t.integer  "bulkstats_schema_file_size"
    t.datetime "bulkstats_schema_updated_at"
  end

  create_table "monitor_categories_sensors", id: false, force: :cascade do |t|
    t.integer "monitor_category_id", null: false
    t.integer "sensor_id",           null: false
    t.index ["monitor_category_id", "sensor_id"], name: "monitor_categories_sensors_index", unique: true, using: :btree
  end

  create_table "notes", force: :cascade do |t|
    t.integer  "response_action_id"
    t.integer  "incident_id"
    t.integer  "user_id"
    t.text     "content"
    t.datetime "created_at"
    t.datetime "updated_at"
  end

  create_table "notifications", force: :cascade do |t|
    t.integer  "user_id"
    t.boolean  "read_status", default: false
    t.text     "comment"
    t.datetime "created_at"
    t.datetime "updated_at"
    t.index ["user_id"], name: "index_notifications_on_user_id", using: :btree
  end

  create_table "object_types", force: :cascade do |t|
    t.string   "name"
    t.text     "comment"
    t.datetime "created_at"
    t.datetime "updated_at"
  end

  create_table "overlay_maps", force: :cascade do |t|
    t.string   "ne"
    t.string   "sw"
    t.string   "image_file_name"
    t.string   "image_content_type"
    t.bigint   "image_file_size"
    t.datetime "image_updated_at"
    t.string   "name"
    t.boolean  "enabled",                     default: false
    t.datetime "created_at"
    t.datetime "updated_at"
    t.integer  "sensor_id"
    t.integer  "rotation"
    t.string   "original_image_file_name"
    t.string   "original_image_content_type"
    t.bigint   "original_image_file_size"
    t.datetime "original_image_updated_at"
    t.index ["sensor_id"], name: "index_overlay_maps_on_sensor_id", using: :btree
  end

  create_table "phase_templates", force: :cascade do |t|
    t.string   "name"
    t.integer  "playbook_template_id", null: false
    t.datetime "created_at"
    t.datetime "updated_at"
  end

  create_table "phases", force: :cascade do |t|
    t.string   "name"
    t.integer  "playbook_id",                 null: false
    t.datetime "created_at"
    t.datetime "updated_at"
    t.boolean  "current",     default: false
  end

  create_table "playbook_templates", force: :cascade do |t|
    t.string   "name"
    t.text     "description"
    t.boolean  "default"
    t.boolean  "read_only",   default: false
    t.integer  "user_id",                     null: false
    t.datetime "created_at"
    t.datetime "updated_at"
  end

  create_table "playbooks", force: :cascade do |t|
    t.string   "name"
    t.text     "description"
    t.integer  "incident_id", null: false
    t.datetime "created_at"
    t.datetime "updated_at"
  end

  create_table "plugin_versions", force: :cascade do |t|
    t.string   "version"
    t.boolean  "installed"
    t.integer  "plugin_id"
    t.datetime "created_at", null: false
    t.datetime "updated_at", null: false
    t.index ["plugin_id"], name: "index_plugin_versions_on_plugin_id", using: :btree
  end

  create_table "plugins", force: :cascade do |t|
    t.string   "name"
    t.datetime "created_at",  null: false
    t.datetime "updated_at",  null: false
    t.boolean  "is_applying"
  end

  create_table "policies", force: :cascade do |t|
    t.string   "name"
    t.string   "description"
    t.integer  "sensor_id"
    t.boolean  "default_enabled_rules"
    t.boolean  "updating",              default: false
    t.boolean  "auto_resolve_flowbits", default: false
    t.boolean  "is_deleted",            default: false
    t.boolean  "auto_add_new_rules",    default: false
    t.datetime "created_at"
    t.datetime "updated_at"
    t.boolean  "block_updates",         default: false
    t.integer  "default_action"
    t.index ["sensor_id"], name: "index_policies_on_sensor_id", using: :btree
  end

  create_table "policy_rule_db_versions", force: :cascade do |t|
    t.integer  "policy_id"
    t.integer  "rule_db_version_id"
    t.integer  "priority"
    t.datetime "created_at"
    t.datetime "updated_at"
    t.index ["policy_id"], name: "index_policy_rule_db_versions_on_policy_id", using: :btree
    t.index ["rule_db_version_id"], name: "index_policy_rule_db_versions_on_rule_db_version_id", using: :btree
  end

  create_table "policy_rules", force: :cascade do |t|
    t.integer  "rule_id"
    t.integer  "policy_id"
    t.integer  "action_id"
    t.integer  "user_id"
    t.integer  "dependency_rule_id"
    t.datetime "created_at"
    t.datetime "updated_at"
    t.index ["action_id"], name: "index_policy_rules_on_action_id", using: :btree
    t.index ["dependency_rule_id"], name: "index_policy_rules_on_dependency_rule_id", using: :btree
    t.index ["policy_id"], name: "index_policy_rules_on_policy_id", using: :btree
    t.index ["rule_id"], name: "index_policy_rules_on_rule_id", using: :btree
    t.index ["user_id"], name: "index_policy_rules_on_user_id", using: :btree
  end

  create_table "predefined_operations", force: :cascade do |t|
    t.string   "name"
    t.string   "technology"
    t.string   "operation"
    t.datetime "created_at"
    t.datetime "updated_at"
  end

  create_table "priorities", force: :cascade do |t|
    t.string   "name",       null: false
    t.string   "text_color"
    t.string   "bg_color"
    t.datetime "created_at"
    t.datetime "updated_at"
  end

  create_table "profiles", force: :cascade do |t|
    t.string   "name"
    t.text     "description"
    t.text     "target_port"
    t.text     "target_addr"
    t.integer  "sensor_id"
    t.boolean  "is_deleted",   default: false
    t.datetime "created_at"
    t.datetime "updated_at"
    t.integer  "periodicity"
    t.string   "time"
    t.datetime "run_at"
    t.integer  "profile_type", default: 0
    t.index ["sensor_id"], name: "index_profiles_on_sensor_id", using: :btree
  end

  create_table "rb_reference_rules", force: :cascade do |t|
    t.integer  "rule_id"
    t.integer  "rb_reference_id"
    t.string   "url"
    t.datetime "created_at"
    t.datetime "updated_at"
    t.index ["rb_reference_id"], name: "index_rb_reference_rules_on_rb_reference_id", using: :btree
    t.index ["rule_id"], name: "index_rb_reference_rules_on_rule_id", using: :btree
  end

  create_table "rb_references", force: :cascade do |t|
    t.string   "name"
    t.string   "description"
    t.string   "prefix"
    t.datetime "created_at"
    t.datetime "updated_at"
    t.string   "humanize"
  end

  create_table "redborder_objects", force: :cascade do |t|
    t.string   "name"
    t.string   "value"
    t.text     "comment"
    t.string   "type"
    t.datetime "created_at"
    t.datetime "updated_at"
    t.integer  "user_id"
    t.string   "object_type"
    t.index ["user_id"], name: "index_redborder_objects_on_user_id", using: :btree
  end

  create_table "report_blocks", force: :cascade do |t|
    t.string   "name"
    t.text     "description"
    t.text     "property"
    t.integer  "width"
    t.string   "image_file_name"
    t.string   "image_content_type"
    t.integer  "image_file_size"
    t.datetime "image_updated_at"
    t.datetime "created_at"
    t.datetime "updated_at"
    t.integer  "report_type"
    t.integer  "position"
    t.integer  "page"
    t.integer  "report_id"
  end

  create_table "report_roles", force: :cascade do |t|
    t.integer  "report_id"
    t.integer  "role_id"
    t.boolean  "can_edit"
    t.datetime "created_at"
    t.datetime "updated_at"
  end

  create_table "report_sensors", force: :cascade do |t|
    t.integer  "report_id"
    t.integer  "sensor_id"
    t.string   "can_edit",   limit: 255
    t.datetime "created_at"
    t.datetime "updated_at"
  end

  create_table "report_users", force: :cascade do |t|
    t.integer  "report_id"
    t.integer  "user_id"
    t.boolean  "can_edit"
    t.datetime "created_at"
    t.datetime "updated_at"
  end

  create_table "reports", force: :cascade do |t|
    t.integer  "user_id"
    t.string   "name"
    t.text     "description"
    t.integer  "orientation"
    t.integer  "number_pages",  default: 1
    t.datetime "created_at"
    t.datetime "updated_at"
    t.string   "schedule_type", default: "weekly"
    t.text     "schedule_days"
    t.string   "schedule_hour"
    t.string   "email_list"
    t.index ["user_id"], name: "index_reports_on_user_id", using: :btree
  end

  create_table "reports_historicals", force: :cascade do |t|
    t.integer  "report_id"
    t.string   "generated_by", limit: 45
    t.datetime "created_at",              null: false
  end

  create_table "reputation_policies", force: :cascade do |t|
    t.string   "name"
    t.string   "description"
    t.integer  "sensor_id"
    t.datetime "created_at"
    t.datetime "updated_at"
    t.index ["sensor_id"], name: "index_reputation_policies_on_sensor_id", using: :btree
  end

  create_table "reputations", force: :cascade do |t|
    t.integer  "reputation_policy_id"
    t.integer  "reputation_type"
    t.string   "value"
    t.integer  "action"
    t.integer  "position"
    t.datetime "created_at"
    t.datetime "updated_at"
    t.index ["reputation_policy_id"], name: "index_reputations_on_reputation_policy_id", using: :btree
  end

  create_table "response_actions", force: :cascade do |t|
    t.integer  "task_id"
    t.integer  "user_id",      null: false
    t.datetime "performed_at"
    t.datetime "created_at"
    t.datetime "updated_at"
  end

  create_table "roles", force: :cascade do |t|
    t.string   "name"
    t.string   "permission"
    t.datetime "created_at"
    t.datetime "updated_at"
  end

  create_table "roles_sensors", id: false, force: :cascade do |t|
    t.integer "role_id"
    t.integer "sensor_id"
    t.index ["role_id", "sensor_id"], name: "index_roles_sensors_on_role_id_and_sensor_id", using: :btree
  end

  create_table "roles_users", id: false, force: :cascade do |t|
    t.integer "role_id"
    t.integer "user_id"
    t.index ["role_id", "user_id"], name: "index_roles_users_on_role_id_and_user_id", using: :btree
  end

  create_table "rule_db_version_rule_sources", force: :cascade do |t|
    t.integer  "rule_db_version_id"
    t.integer  "rule_source_id"
    t.datetime "created_at"
    t.datetime "updated_at"
    t.index ["rule_db_version_id"], name: "index_rule_db_version_rule_sources_on_rule_db_version_id", using: :btree
    t.index ["rule_source_id"], name: "index_rule_db_version_rule_sources_on_rule_source_id", using: :btree
  end

  create_table "rule_db_versions", force: :cascade do |t|
    t.boolean  "completed",              default: false
    t.integer  "rules_count",            default: 0
    t.integer  "rules_new_count",        default: 0
    t.integer  "rules_modified_count",   default: 0
    t.integer  "rules_deprecated_count", default: 0
    t.text     "unicode_map"
    t.boolean  "is_deleted",             default: false
    t.string   "so_rules_file_name"
    t.string   "so_rules_content_type"
    t.bigint   "so_rules_file_size"
    t.datetime "so_rules_updated_at"
    t.datetime "created_at"
    t.datetime "updated_at"
    t.integer  "rule_source_id"
    t.string   "tag"
    t.boolean  "checked",                default: false
    t.index ["rule_source_id"], name: "index_rule_db_versions_on_rule_source_id", using: :btree
  end

  create_table "rule_notes", force: :cascade do |t|
    t.integer  "rule_id"
    t.integer  "user_id"
    t.text     "body"
    t.datetime "created_at"
    t.datetime "updated_at"
    t.index ["rule_id"], name: "index_rule_notes_on_rule_id", using: :btree
    t.index ["user_id"], name: "index_rule_notes_on_user_id", using: :btree
  end

  create_table "rule_sources", force: :cascade do |t|
    t.string   "name"
    t.string   "description"
    t.string   "md5"
    t.boolean  "protected",               default: false
    t.boolean  "enable",                  default: false
    t.boolean  "has_code",                default: false
    t.string   "code"
    t.string   "tgzurl"
    t.string   "md5url"
    t.string   "regexp_group_ignore"
    t.string   "regexp_classtype_ignore"
    t.string   "regexp_family_ignore"
    t.text     "search"
    t.text     "so_rules"
    t.string   "cached_tgz_file_name"
    t.string   "cached_tgz_content_type"
    t.bigint   "cached_tgz_file_size"
    t.datetime "cached_tgz_updated_at"
    t.datetime "created_at"
    t.datetime "updated_at"
    t.boolean  "is_custom",               default: false
    t.boolean  "is_deleted",              default: false
    t.boolean  "updating",                default: false
    t.integer  "sensor_id"
  end

  create_table "rules", force: :cascade do |t|
    t.integer  "rule_sid"
    t.integer  "rule_gid",           default: 1
    t.integer  "rule_rev",           default: 0
    t.string   "msg"
    t.string   "short_msg"
    t.string   "protocol"
    t.text     "source_addr"
    t.text     "source_port"
    t.text     "target_addr"
    t.text     "target_port"
    t.text     "text"
    t.boolean  "default_enabled",    default: true
    t.integer  "users_count",        default: 0
    t.boolean  "is_new",             default: false
    t.boolean  "is_deprecated",      default: false
    t.boolean  "is_modified",        default: false
    t.boolean  "has_threshold",      default: false
    t.text     "threshold_options"
    t.datetime "created_at"
    t.datetime "updated_at"
    t.integer  "rule_db_version_id"
    t.integer  "category_id"
    t.integer  "group_id"
    t.integer  "family_id"
    t.integer  "class_type_id"
    t.string   "mitre_tactic_id"
    t.string   "mitre_technique_id"
    t.index ["category_id"], name: "index_rules_on_category_id", using: :btree
    t.index ["class_type_id"], name: "index_rules_on_class_type_id", using: :btree
    t.index ["family_id"], name: "index_rules_on_family_id", using: :btree
    t.index ["group_id"], name: "index_rules_on_group_id", using: :btree
    t.index ["rule_db_version_id"], name: "index_rules_on_rule_db_version_id", using: :btree
  end

  create_table "rules_services", id: false, force: :cascade do |t|
    t.integer "rule_id"
    t.integer "service_id"
  end

  create_table "saved_filters", force: :cascade do |t|
    t.integer  "user_id"
    t.boolean  "public"
    t.string   "title"
    t.text     "filter"
    t.text     "checksum"
    t.datetime "created_at"
    t.datetime "updated_at"
    t.index ["user_id"], name: "index_saved_filters_on_user_id", using: :btree
  end

  create_table "scans", force: :cascade do |t|
    t.string   "status"
    t.integer  "profile_id"
    t.datetime "created_at"
    t.datetime "updated_at"
    t.datetime "run_at"
    t.index ["profile_id"], name: "index_scans_on_profile_id", using: :btree
  end

  create_table "sensors", force: :cascade do |t|
    t.string   "name"
    t.integer  "parent_id"
    t.string   "ip"
    t.string   "latitude"
    t.string   "longitude"
    t.boolean  "is_deleted",            default: false
    t.datetime "applied_at"
    t.integer  "type"
    t.integer  "real_parent_id"
    t.integer  "group_id"
    t.integer  "binding_id"
    t.boolean  "need_apply",            default: false
    t.datetime "created_at"
    t.datetime "updated_at"
    t.boolean  "applying",              default: false
    t.text     "property"
    t.integer  "domain_type"
    t.boolean  "unassigned",            default: false
    t.integer  "lft"
    t.integer  "rgt"
    t.integer  "depth"
    t.integer  "children_count"
    t.string   "uuid"
    t.boolean  "unclaimed",             default: false
    t.integer  "license_id"
    t.integer  "policy_id"
    t.integer  "reputation_policy_id"
    t.boolean  "need_reputation_apply", default: false
    t.integer  "profile_id"
    t.index ["license_id"], name: "index_sensors_on_license_id", using: :btree
    t.index ["parent_id"], name: "index_sensors_on_parent_id", using: :btree
    t.index ["policy_id"], name: "index_sensors_on_policy_id", using: :btree
    t.index ["profile_id"], name: "index_sensors_on_profile_id", using: :btree
    t.index ["real_parent_id"], name: "index_sensors_on_real_parent_id", using: :btree
    t.index ["reputation_policy_id"], name: "index_sensors_on_reputation_policy_id", using: :btree
    t.index ["rgt"], name: "index_sensors_on_rgt", using: :btree
  end

  create_table "services", force: :cascade do |t|
    t.string   "name"
    t.string   "description"
    t.datetime "created_at"
    t.datetime "updated_at"
  end

  create_table "settings", force: :cascade do |t|
    t.string   "name",       limit: 255, default: "", null: false
    t.text     "value"
    t.text     "text"
    t.datetime "created_at"
    t.datetime "updated_at"
    t.index ["name"], name: "index_settings_on_name", unique: true, using: :btree
  end

  create_table "severities", force: :cascade do |t|
    t.integer  "sig_id"
    t.string   "name"
    t.string   "text_color"
    t.string   "bg_color"
    t.integer  "events_count", default: 0
    t.datetime "created_at"
    t.datetime "updated_at"
    t.index ["sig_id"], name: "index_severities_on_sig_id", unique: true, using: :btree
  end

  create_table "stored_delayed_jobs", force: :cascade do |t|
    t.string   "job"
    t.text     "options"
    t.text     "content"
    t.integer  "user_id"
    t.datetime "created_at"
    t.datetime "updated_at"
    t.index ["user_id"], name: "index_stored_delayed_jobs_on_user_id", using: :btree
  end

  create_table "stored_policies", force: :cascade do |t|
    t.integer  "policy_id"
    t.integer  "rules"
    t.string   "stored_rules_file_name"
    t.string   "stored_rules_content_type"
    t.bigint   "stored_rules_file_size"
    t.datetime "stored_rules_updated_at"
    t.datetime "created_at"
    t.datetime "updated_at"
    t.string   "tag"
    t.integer  "user_id"
    t.index ["user_id"], name: "index_stored_policies_on_user_id", using: :btree
  end

  create_table "task_templates", force: :cascade do |t|
    t.string   "name"
    t.integer  "phase_template_id", null: false
    t.text     "summary"
    t.integer  "position"
    t.text     "description"
    t.datetime "created_at"
    t.datetime "updated_at"
  end

  create_table "tasks", force: :cascade do |t|
    t.string   "name"
    t.integer  "phase_id",    null: false
    t.integer  "user_id"
    t.integer  "position"
    t.text     "summary"
    t.text     "description"
    t.datetime "created_at"
    t.datetime "updated_at"
  end

  create_table "tiers", force: :cascade do |t|
    t.integer  "user_id"
    t.string   "name"
    t.boolean  "memory",     default: false
    t.datetime "created_at"
    t.datetime "updated_at"
    t.index ["user_id"], name: "index_tiers_on_user_id", using: :btree
  end

  create_table "users", force: :cascade do |t|
    t.string   "email",                  default: "",          null: false
    t.string   "encrypted_password",     default: "",          null: false
    t.string   "reset_password_token"
    t.datetime "reset_password_sent_at"
    t.datetime "remember_created_at"
    t.integer  "sign_in_count",          default: 0
    t.datetime "current_sign_in_at"
    t.datetime "last_sign_in_at"
    t.string   "current_sign_in_ip"
    t.string   "last_sign_in_ip"
    t.string   "login"
    t.boolean  "admin",                  default: false
    t.string   "name"
    t.string   "root_page",              default: "/overview"
    t.boolean  "enabled",                default: true
    t.datetime "created_at"
    t.datetime "updated_at"
    t.integer  "per_page_count",         default: 25
    t.boolean  "gravatar",               default: false
    t.integer  "notes_count",            default: 0
    t.string   "authentication_token"
    t.integer  "time_machine_now"
    t.text     "properties"
    t.string   "mobile_gcm_id"
    t.integer  "sensor_id"
    t.text     "tutorials"
    t.string   "letter_size"
    t.string   "preferred_locale"
    t.integer  "failed_attempts",        default: 0
    t.string   "unlock_token"
    t.datetime "locked_at"
    t.datetime "pwd_changed_at"
    t.boolean  "force_pwd_change",       default: false
    t.datetime "last_sign_out_at"
    t.index ["email"], name: "index_users_on_email", unique: true, using: :btree
    t.index ["pwd_changed_at"], name: "index_users_on_pwd_changed_at", using: :btree
    t.index ["reset_password_token"], name: "index_users_on_reset_password_token", unique: true, using: :btree
    t.index ["sensor_id"], name: "index_users_on_sensor_id", using: :btree
  end

  create_table "widgets", force: :cascade do |t|
    t.string   "name"
    t.text     "description"
    t.integer  "dashboard_id"
    t.text     "property"
    t.string   "media_file_name"
    t.string   "media_content_type"
    t.bigint   "media_file_size"
    t.datetime "media_updated_at"
    t.datetime "created_at"
    t.datetime "updated_at"
    t.integer  "parent_id"
    t.string   "parent_type"
    t.index ["parent_id"], name: "index_widgets_on_parent_id", using: :btree
  end

  create_table "zones", force: :cascade do |t|
    t.string  "name"
    t.integer "sensor_id"
    t.text    "description"
    t.index ["sensor_id"], name: "index_zones_on_sensor_id", using: :btree
  end

  add_foreign_key "incidents", "incident_statuses"
  add_foreign_key "incidents", "priorities"
  add_foreign_key "licenses", "sensors"
  add_foreign_key "notes", "incidents"
  add_foreign_key "notes", "response_actions"
  add_foreign_key "notes", "users"
  add_foreign_key "phase_templates", "playbook_templates"
  add_foreign_key "phases", "playbooks"
  add_foreign_key "playbook_templates", "users"
  add_foreign_key "playbooks", "incidents"
  add_foreign_key "plugin_versions", "plugins"
  add_foreign_key "reports_historicals", "reports"
  add_foreign_key "response_actions", "tasks"
  add_foreign_key "response_actions", "users"
  add_foreign_key "task_templates", "phase_templates"
  add_foreign_key "tasks", "phases"
  add_foreign_key "tasks", "users"
end
