#
# Devise module
#
module Devise
  #
  # This failure app extend functionality of Devise::FailureApp. FaiulreApp
  # is the class that manage warden auth failures (throw :warden clauses).
  # In our app, we need to redirect users to login when request data by AJAX.
  #
  class RedborderFailureApp < Devise::FailureApp
    #
    # Overrided this methdo to check if we come from a modal, JSON or JS query.
    #
    def respond
      if http_auth?
        http_auth
      elsif warden_options[:recall]
        recall
      elsif request.params['modal'] == 'true' || request.format.json? ||
            request.format.js?
        redirect_modal_or_js
      else
        redirect
      end
    end

    #
    # This method modify headers and status of response to advice application
    # that need to change url to /login/users.
    #
    # See application.js:62
    #
    def redirect_modal_or_js
      self.status = 401
      self.headers['X-logout'] = 'true'
      self.content_type = request.format.to_s
      self.response_body = ''
    end

    private

    # Custom URL and respond method
    def redirect_url
      new_user_session_url
    end
  end
end
