#######################################################################
# Copyright (c) 2014 ENEO Tecnologia S.L.
# This file is part of redBorder.
# redBorder is free software: you can redistribute it and/or modify
# it under the terms of the GNU Affero General Public License as published by
# the Free Software Foundation, either version 3 of the License, or
# (at your option) any later version.
# redBorder is distributed in the hope that it will be useful,
# but WITHOUT ANY WARRANTY; without even the implied warranty of
# MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
# GNU Affero General Public License for more details.
# You should have received a copy of the GNU Affero General Public License
# along with redBorder. If not, see <http://www.gnu.org/licenses/>.
#######################################################################

if Rails.env.development?
  class MailPreview < MailView
    def alarm
      alarm = Alarm.where.not(upper_limit: nil, email_list: nil).last
      result = { start_time: Time.now - 5.minutes, end_time: Time.now, where: :upper, value: 100, fired: true }
      AlarmMailer.alarm(alarm, result)
    end

    def report
      # Create a sample data
      user = User.new({name: RedBorder::USER_CONFIG['login'].capitalize,
                       email: RedBorder::USER_CONFIG['email']})
      report = Report.new({name: "Example report name", description: "This is the description of the report. This text may contains more than one line, so it's adapted to the email.", number_pages: 1})
      report.owner = user

      # Example pdf
      pdf_path = Rails.root.join('tmp', "example.pdf")

      # Call to report mailer
      ReportMailer.report(report, pdf_path)
    end

    def admin
      # Create the subject and the body
      subject = "This is the subject of the email"
      body = "This is the body of the email"

      # Call to admin mailer
      AdminMailer.admin_email(subject, body)
    end

    DittoCode::Exec.if 'ENTERPRISE' do
      def reach_bytes_limit
        organization = Sensor.find_by(type: Sensor::DOMAIN, domain_type: Sensor::ORGANIZATION)
        admins = User.where(admin: true, sensor: Sensor.root)
        OrganizationMailer.reach_bytes_limit(organization, admins)
      end
    end
  end
end
