/*!
 * Copyright (c) 2014 ENEO Tecnología S.L.
 * This file is part of redBorder.
 * redBorder is free software: you can redistribute it and/or modify
 * it under the terms of the GNU Affero General Public License as published by
 * the Free Software Foundation, either version 3 of the License, or
 * (at your option) any later version.
 * redBorder is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU Affero General Public License for more details.
 * You should have received a copy of the GNU Affero General Public License
 * along with redBorder. If not, see <http://www.gnu.org/licenses/>.
 */

function alarm_product_type_ap_state(element) {
    var show = element.val(),
        data = $('#alarm_condition').val(),
        filters;

    if (data !== "") {
        filters = JSON.stringify({
            match_all: true,
            items: JSON.parse(data)
        });
    }

    $('#search .rules').html("");
    $('#alarm_condition').val("");

    $('div[data-product]').hide();
    $('div[data-product] input').prop('disabled', true);
    $('div[data-product] select').prop('disabled', true);
    $('div[data-product=ap_state]').show();
    $('div[data-product=ap_state] input').prop('disabled', false);
    $('div[data-product=ap_state] select').prop('disabled', false);
    $('div[data-product=ap_state] #alarm_aggregation').trigger('change');
    sensors_html = Handlebars.templates['select']({
        name: "sensors-select",
        width: "100%",
        multiple: false,
        data: search_hash["ap_state_sensors"]
    });

    rule = new SearchAPState(search_hash);
    rule.searchUI({
        cssClass: "submit-search",
        buttonTitle: I18n.t('controllers.submit_filter')
    }, function () {
        if (filters === undefined) {
            rule.add();
            rule.add();
        } else {
            rule.build(filters);
            rule.add(); rule.add();
        }
    });
}
