#######################################################################
# Copyright (c) 2014 ENEO Tecnologia S.L.
# This file is part of redBorder.
# redBorder is free software: you can redistribute it and/or modify
# it under the terms of the GNU Affero General Public License as published by
# the Free Software Foundation, either version 3 of the License, or
# (at your option) any later version.
# redBorder is distributed in the hope that it will be useful,
# but WITHOUT ANY WARRANTY; without even the implied warranty of
# MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
# GNU Affero General Public License for more details.
# You should have received a copy of the GNU Affero General Public License
# along with redBorder. If not, see <http://www.gnu.org/licenses/>.
#######################################################################

class ApStatesController < Redborder::Commons::CommonController
  # Storage of the filters
  include Redborder::Filters::Storage::Session
  # Includes
  include Redborder::Rbdruid

  ## ======================================================================
  # => Before actions and filters
  ## ======================================================================

  # Init source. Load filters and apply them if params[:search] is defined.
  # This before action must be ALWAYS at top.
  before_action :set_source, :filters_from_url

  before_action :int_times, only: :get_serie

  ## ======================================================================
  # => Actions
  ## ======================================================================

  def get_serie
    serie = ApState.aps_serie(@filter, params)
    render json: (serie || [])
  end

  private

  #
  # Set the filters. Change current filters if params[:search] is defined.
  #
  def set_source
    @source = Redborder::DruidSource.get(source: 'ap_state')
    @filter = Redborder::Filter.new(@source, load_filters)
  end

end
