/*!
 * Copyright (c) 2014 ENEO Tecnología S.L.
 * This file is part of redBorder.
 * redBorder is free software: you can redistribute it and/or modify
 * it under the terms of the GNU Affero General Public License as published by
 * the Free Software Foundation, either version 3 of the License, or
 * (at your option) any later version.
 * redBorder is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU Affero General Public License for more details.
 * You should have received a copy of the GNU Affero General Public License
 * along with redBorder. If not, see <http://www.gnu.org/licenses/>.
 */

$(document).on('change', '#correlation_engine_rules .enabled input:checkbox', function () {
  var id = $(this).parent().data('correlation_engine_rule');
  var enabled = $(this).prop('checked');
  $.ajax({
    url: "/correlation_engine_rules/" + id,
    remote: true,
    type: 'PATCH',
    data: {
      correlation_engine_rule: {
        enabled: enabled
      }
    }
  });
});

var filters_1 = 0; //number of actual filters for topic1
var filters_2 = 0; //number of actual filters for topic2
var selects = 1; //number of actual selects

// For the first Topic
$(document).on("click", ".add-cep-filters", function(e){
  filters_1 = 1;
  if ($('.first_input').children("option:selected").val() == ""){
    alert(I18n.t('cep_select'));
    e.preventDefault();
  }
  else{
    //$('.first-filters').find('input, select, label').attr("disabled", false).removeClass("disabled");
    $('.btn-add-filters').css('display','none');
    $('.cep_filter').css('display','block');
    $('.not1, .operators1').find("input, select, label").attr("disabled", false).removeClass("disabled");
    $('.btn-add-more-filters').css('display', 'block');
    $('.inputs1').find("div:visible").find("input, select, label").attr("disabled", false).removeClass("disabled");
    e.preventDefault();
  }
});

// To add more filters in topic1
$(document).on("click", ".add-new-filter", function(e){
  filters_1++;
  var html = $('.first-filters').clone().removeClass("first-filters").addClass("first-filters" + (filters_1-1));
  html.find("input[name='correlation_engine_rule[topic1_not_filter0]']").attr('name', 'correlation_engine_rule[topic1_not_filter' + (filters_1-1) + ']');
  html.find("select[name='correlation_engine_rule[topic1_filter0]']").attr('name', 'correlation_engine_rule[topic1_filter' + (filters_1-1) + ']');
  html.find("select[name='correlation_engine_rule[topic1_filter_operator0]']").attr('name', 'correlation_engine_rule[topic1_filter_operator' + (filters_1-1) + ']');
  html.find("input").val("");
  html.find("input").attr("disabled", false);
  $('.cep_filter').append(html);
  $('.remove-filter').removeClass("disabled");
  e.preventDefault();
});

$(document).on("click", ".remove-filter", function(e){
  if (filters_1 == 1){
    $('.cep_filter').css('display', 'none');
  }
  else{
    $('.first-filters' + (filters_1-1)).remove();
  }
  filters_1--;
  // If we deleted all filters
  if (filters_1 == 0){
    $('.first-filters').find('input, select, label').attr("disabled", 'disabled').addClass("disabled");
    $('.btn-add-more-filters').css('display', 'none');
    $('.cep_filter').css('display', 'none');
    $('.btn-add-filters').css('display', 'block');
  }
  e.preventDefault();
});

// For the second Topic
$(document).on("click", ".add-cep-filters2", function(e){
  filters_2 = 1;
  if ($('.second_input').children("option:selected").val() == ""){
    alert(I18n.t('cep_select'));
    e.preventDefault();
  }
  else{
    $('.btn-add-filters2').css('display','none');
    $('.cep_filter2').css('display','block');
    $('.not2, .operators2').find("input, select, label").attr("disabled", false).removeClass("disabled");
    $('.btn-add-more-filters2').css('display', 'block');
    $('.inputs2').find("div:visible").find("input, select, label").attr("disabled", false).removeClass("disabled");
    e.preventDefault();
  }
});

// To add more filters in topic2
$(document).on("click", ".add-new-filter2", function(e){
  filters_2++;
  var html = $('.second-filters').clone().removeClass("second-filters").addClass("second-filters" + (filters_2-1));
  html.find("input[name='correlation_engine_rule[topic2_not_filter0]']").attr('name', 'correlation_engine_rule[topic2_not_filter' + (filters_2-1) + ']');
  html.find("select[name='correlation_engine_rule[topic2_filter0]']").attr('name', 'correlation_engine_rule[topic2_filter' + (filters_2-1) + ']');
  html.find("select[name='correlation_engine_rule[topic2_filter_operator0]']").attr('name', 'correlation_engine_rule[topic2_filter_operator' + (filters_2-1) + ']');
  html.find("input").val("");
  html.find("input").attr("disabled", false);
  $('.cep_filter2').append(html);
  $('.remove-filter2').removeClass("disabled");
  e.preventDefault();
});

$(document).on("click", ".remove-filter2", function(e){
  if (filters_2 == 1){
    $('.cep_filter2').css('display', 'none');
  }
  else{
    $('.second-filters' + (filters_2-1)).remove();
  }
  filters_2--;
  // If we deleted all filters
  if (filters_2 == 0){
    $('.second-filters').find('input, select, label').attr("disabled", 'disabled').removeClass("disabled");
    $('.btn-add-more-filters2').css('display', 'none');
    $('.cep_filter2').css('display', 'none');
    $('.btn-add-filters2').css('display', 'block');
  }
  e.preventDefault();
});

// For adding and removing select fields.
$(document).on("click", ".add-new-select", function(e){
  selects++;
  $('.remove-select').removeClass("disabled");
  var html = $('.select-to-be-cloned').clone().removeClass("select-to-be-cloned").addClass("select-to-be-cloned" + selects);

  html.find(".function0").css("display", "none").addClass("function" + (selects-1)).find("input, select, label").attr("disabled", "disabled").addClass("disabled");
  html.find(".rename0").css("display", "none").addClass("rename" + (selects-1)).find("input, select, label").attr("disabled", "disabled").addClass("disabled");
  html.find(".btn-apply0").addClass("btn-apply" + (selects-1)).css("display", "block").find("button").attr("onclick", "apply_function(" + (selects-1) + ")");
  html.find(".btn-rename0").addClass("btn-rename" + (selects-1)).css("display", "block").find("button").attr("onclick", "rename(" + (selects-1) + ")");

  html.find("select[name='correlation_engine_rule[select1]']").attr('name', 'correlation_engine_rule[select' + selects + ']');
  html.find("select[name='correlation_engine_rule[select_function1]']").attr('name', 'correlation_engine_rule[select_function' + selects + ']');
  html.find("input[name='correlation_engine_rule[select_name1]']").attr('name', 'correlation_engine_rule[select_name' + selects + ']');
  html.find(".function0, .rename0, .btn-apply0, .btn-rename0").removeClass("function0 rename0 btn-apply0 btn-rename0");
  $('.column-selection').append(html);
  e.preventDefault();
});

$(document).on("click", ".remove-select", function(e){
  if (selects == 2){
    $('.remove-select').addClass("disabled");
    $('.select-to-be-cloned' + selects).remove();
    selects--;
  }
  else{
    $('.select-to-be-cloned' + selects).remove();
    selects--;
  }
  e.preventDefault();
});

// Helpers so we only show dimensions for that specific input.
$(document).on("change", "select.first_input", function(e){

  var topic1 = $(this).children("option:selected").val();
  if ($('.second_input').children("option:selected").val() !== "undefined") {
    var topics = [$('.second_input').children("option:selected").val(), topic1];

    $('.first-join').find("input, label, select").attr("disabled", "disabled").addClass("disabled");
    $('.selections').find("input, label, select").attr("disabled", "disabled").addClass("disabled");

    // hide all fields, then show the one that we want (if we select traffic, show only traffic)
    $('.transact').css("display", "none");
    $('.joins').css("display", "none");

    if (topics.includes("rb_flow_post") && (topics.includes("rb_vault_post"))){
      $('.traffic-vault').css("display", "block").find("input, select, label").attr("disabled", false).removeClass("disabled");
    }
    else if(topics.includes("rb_flow_post") && (topics.includes("rb_monitor"))){
      $('.traffic-monitor').css("display", "block").find("input, select, label").attr("disabled", false).removeClass("disabled");
    }
    else if(topics.includes("rb_flow_post") && (topics.includes("rb_event_post"))){
      $('.traffic-intrusion').css("display", "block").find("input, select, label").attr("disabled", false).removeClass("disabled");
    }
    else if(topics.includes("rb_monitor") && (topics.includes("rb_event_post"))){
      $('.monitor-intrusion').css("display", "block").find("input, select, label").attr("disabled", false).removeClass("disabled");
    }
    else if(topics.includes("rb_monitor") && (topics.includes("rb_vault_post"))){
      $('.monitor-vault').css("display", "block").find("input, select, label").attr("disabled", false).removeClass("disabled");
    }
    else{
      $('.intrusion-vault').css("display", "block").find("input, select, label").attr("disabled", false).removeClass("disabled");
    }
  }
  var topics= [$('second_input').children("option:selected").val(), topic1];
  $('.inputs1').find("input, label, select").attr("disabled", "disabled").addClass("disabled");
  $('.filter1').css('display', 'none');

  // If the button to add filters is visible, is because we haven't added filters yet.
  if ($('.btn-add-filters').is(":visible")){
    // Make visible the corresponding input, but dont enable it , since this is not showing up till the users
    // click on "Add Filter"
    $('.' + topic1  + '1').css('display', 'block');
  }
  else{
    // If the button is not visible, it's because we already have a filter, so we enable the fields
    $('.' + topic1  + '1').css('display', 'block').find("input, select, label").attr("disabled", false).removeClass("disabled");
  }

  //Show corresponding input in join condition.
  $('.' + topic1  + '3').css('display', 'block').find("input, select, label").attr("disabled", false).removeClass("disabled");
  e.preventDefault();
});

$(document).on("change", "select.second_input", function(e){
  var topic2 =  $(this).children("option:selected").val();
  var topics = [$('.first_input').children("option:selected").val(), topic2];

  $('.second-join').find("input, label, select").attr("disabled", "disabled").addClass("disabled");
  $('.selections').find("input, label, select").attr("disabled", "disabled").addClass("disabled");

  // hide all fields, then show the one that we want (if we select traffic, show only traffic)
  $('.transact').css("display", "none");
  $('.joins2').css("display", "none");

  if (topics.includes("rb_flow_post") && (topics.includes("rb_vault_post"))){
    $('.traffic-vault').css("display", "block").find("input, select, label").attr("disabled", false).removeClass("disabled");
  }
  else if(topics.includes("rb_flow_post") && (topics.includes("rb_monitor"))){
    $('.traffic-monitor').css("display", "block").find("input, select, label").attr("disabled", false).removeClass("disabled");
  }
  else if(topics.includes("rb_flow_post") && (topics.includes("rb_event_post"))){
    $('.traffic-intrusion').css("display", "block").find("input, select, label").attr("disabled", false).removeClass("disabled");
  }
  else if(topics.includes("rb_monitor") && (topics.includes("rb_event_post"))){
    $('.monitor-intrusion').css("display", "block").find("input, select, label").attr("disabled", false).removeClass("disabled");
  }
  else if(topics.includes("rb_monitor") && (topics.includes("rb_vault_post"))){
    $('.monitor-vault').css("display", "block").find("input, select, label").attr("disabled", false).removeClass("disabled");
  }
  else{
    $('.intrusion-vault').css("display", "block").find("input, select, label").attr("disabled", false).removeClass("disabled");
  }
  $('.inputs2').find("input, label, select").attr("disabled", "disabled").addClass("disabled");
  $('.filter2').css('display', 'none');

  // Make visible the corresponding input, but dont make the field required, since this is not showing up till the users click on "Add Filter"
  $('.' + topic2 + '2').css('display', 'block');

  //Show corresponding input in join condition. This we make it required, since is already visible in the modal
  $('.' + topic2  + '4').css('display', 'block').find("input, select, label").attr("disabled", false).removeClass("disabled");
  e.preventDefault();
});

// Helpers for the user so he knows what to enter depending on the window type
$(document).on("change", "select.first_window", function(e){
  var first_window = $(this).children("option:selected").val();
  if (first_window.startsWith("window.time")){
    $('.first_window_value').val("").attr('placeholder', I18n.t('cep_window_value'));
  }
  else{
    $('.first_window_value').val("").attr('placeholder', 'X');
  }
  e.preventDefault();
});

$(document).on("change", "select.second_window", function(e){
  var second_window = $(this).children("option:selected").val();
  if (second_window.startsWith("window.time")){
    $('.second_window_value').val("").attr('placeholder', I18n.t('cep_window_value'));
  }
  else{
    $('.second_window_value').val("").attr('placeholder', 'X');
  }
  e.preventDefault();
});

// To remember the user to select the timestamp along with aggregations
$(document).on("change", "select.remember_timestamp", function(e){
  var opt = $(this).children("option:selected").html();
  if (opt == opt.toLowerCase()){
    alert(I18n.t('cep_remember'));
  }
  e.preventDefault();
});

function apply_function(num){
  $('.btn-apply' + num).css('display', 'none');
  $('.function' + num).css('display', 'block').find("input, select, label").attr('disabled', false).removeClass("disabled");
  //e.preventDefault();
};

function rename(num){
  $('.btn-rename' + num).css('display', 'none');
  $('.rename' +  num).css('display', 'block').find("input, select, label").attr("disabled", false).removeClass("disabled");
  //e.preventDefault();
};

$(document).on("change", "select.filter_operator", function(e){
  var opt = $(this).children("option:selected").val();
  if (opt == "=="){
    //$(this).parent().parent().next().find("input").val("").attr('placeholder', '\'your string\'');
    $(this).parent().parent().next().find("input").attr('disabled', false);
    $(this).parent().parent().next().find("input").val("");
  }
  else{
    if (opt == "isNull") {
      $(this).parent().parent().next().find("input").attr('disabled', true);
      $(this).parent().parent().next().find("input").val("null");
    } else {
      //$(this).parent().parent().next().find("input").attr('placeholder', '');
      $(this).parent().parent().next().find("input").attr('disabled', false);
      $(this).parent().parent().next().find("input").val("");
    }
  }ventDefault();
});

$(document).on("change", "select.filter_operator_topic_2", function(e){
  var opt = $(this).children("option:selected").val();
  if (opt == "=="){
    //$(this).parent().parent().next().find("input").val("").attr('placeholder', '\'your string\'');
    $(this).parent().parent().next().find("input").attr('disabled', false);
    $(this).parent().parent().next().find("input").val("");
  }
  else{
    if (opt == "isNull") {
      $(this).parent().parent().next().find("input").attr('disabled', true);
      $(this).parent().parent().next().find("input").val("null");
    } else {
      //$(this).parent().parent().next().find("input").attr('placeholder', '');
      $(this).parent().parent().next().find("input").attr('disabled', false);
      $(this).parent().parent().next().find("input").val("");
    }
  }
  e.preventDefault();
});

var step = 0;
$(document).on("click", ".next-step", function(e) {
  var valid = $('.step' + step).find("input, select").valid();

  //Valor alert por defecto
  var mensaje_alerta = I18n.t('cep_required');

  //Validacion del campo Window Value
  //Refactorizar ***************************
  if (step == 1){
    var windowValue = $("#correlation_engine_rule_window_value").val();
    var windowType = $("#correlation_engine_rule_window_type").val();
    if ((windowType == "window.time") || (windowType == "window.timeBatch")) {
      if ( (null == windowValue.match(/^[0-9]+\ssec$/)) && (null == windowValue.match(/^[0-9]+\smin$/)) ) {
        mensaje_alerta = I18n.t('cep_min_sec')
        valid = false;
      }
    } else {
      if (null == windowValue.match(/^[0-9]+$/)) {
        mensaje_alerta = I18n.t('cep_number');
        valid = false;
      }
    }
  }
  if (step == 2) {
    var windowValue = $("#correlation_engine_rule_window_value2").val();
    var windowType = $("#correlation_engine_rule_window_type2").val();
    if ((windowType == "window.time") || (windowType == "window.timeBatch")) {
      if ( (null == windowValue.match(/^[0-9]+\ssec$/)) && (null == windowValue.match(/^[0-9]+\smin$/)) ) {
        mensaje_alerta = I18n.t('cep_min_sec')
        valid = false;
      }
    } else {
      if (null == windowValue.match(/^[0-9]+$/)) {
        mensaje_alerta = I18n.t('cep_number');
        valid = false;
      }
    }
  }

  //Validacion del campo Value
  if (step == 1){
    var operators = $("select.filter_operator");
    operators.each(function() {
      var disabled =  $(this).attr('disabled');

      var operator = $(this).val();
      if ((operator != "isNull") && (disabled != "disabled")) {
        var value = $(this).parent().parent().next().find("input").val();
        if ((operator == "<") || (operator == "<=") || (operator == ">") || (operator == "=>")) {
          if (null == value.match(/^-?\d+\.?\d*$/)) {
              mensaje_alerta = I18n.t('cep_value');
              valid = false;
          }
        }
      }
    });
  }
  if (step == 2) {
    var operators = $("select.filter_operator_topic_2");
    operators.each(function() {
      var disabled =  $(this).attr('disabled');

      var operator = $(this).val();
      if ((operator != "isNull") && (disabled != "disabled")) {
        var value = $(this).parent().parent().next().find("input").val();
        if ((operator == "<") || (operator == "<=") || (operator == ">") || (operator == "=>")) {
          if (null == value.match(/^-?\d+\.?\d*$/)) {
              mensaje_alerta = I18n.t('cep_value');
              valid = false;
          }
        }
      }
    });
  }

  //********************************************* */

  if(valid == false){
    alert(mensaje_alerta);
    step--;
  }
  else if (step == 0){
    $('.prev-step').attr("disabled", false);
    $('.step1').css("display", "block");
  }
  else if (step == 3){
    $('.step'+ step).css("display", "none").next().css('display', 'block');
    $('.submit_form').css("display", "block");
    $(this).attr("disabled", "disabled");
  }
  else{
    $('.step' + step).css("display", "none").next().css('display', 'block');
  }
  step++;
  e.preventDefault();
});

$(document).on("click", ".prev-step", function(e) {
  if (step == 1){
    $('.step' + step).css("display", "none").prev().css("display", "block");
    $('.prev-step').attr("disabled", "disabled");
  }
  else{
    $('.step' + step).css("display", "none").prev().css("display", "block");
    if (step == 4){
      $('.next-step').attr("disabled", false);
    }
  }
  step--;
  e.preventDefault();
});

$(document).on("click", ".reset_step", function(e) {
  step = 0;
});

$(document).on("click", ".submit_rule", function(e) {
  $('#basic_rule_2_correlation_engine_rule_modal').modal('hide');
});
