#######################################################################
# Copyright (c) 2014 ENEO Tecnologia S.L.
# This file is part of redBorder.
# redBorder is free software: you can redistribute it and/or modify
# it under the terms of the GNU Affero General Public License as published by
# the Free Software Foundation, either version 3 of the License, or
# (at your option) any later version.
# redBorder is distributed in the hope that it will be useful,
# but WITHOUT ANY WARRANTY; without even the implied warranty of
# MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
# GNU Affero General Public License for more details.
# You should have received a copy of the GNU Affero General Public License
# along with redBorder. If not, see <http://www.gnu.org/licenses/>.
#######################################################################

module CorrelationEngineRulesHelper


  #
  # Allowed topics to be selected depending on active modules.
  #
  # == Parameters:
  # form::
  #   Form object
  # == Returns:
  # Safe string with HTML code representing checkbox inputs
  #
  def allowed_inputs_for_cep(form)
    Redborder::Module.registered_modules.map do |_k, v|
      next unless v[:cep_topic]

      content_tag :div, class: 'col-md-3' do
        form.label v[:cep_topic] do
          form.check_box(:input, { checked: form.object.try('input') && form.object.input.include?(v[:cep_topic].to_s),
                                   multiple: true }, v[:cep_topic], nil) +
            " #{if v[:name].to_s.start_with? "tr." then I18n.t v[:name].to_s[3..-1] else v[:name] end}"
        end
      end
    end.join.html_safe
  end
end
