DittoCode::HoldFile.if 'ENTERPRISE'

#######################################################################
# Copyright (c) 2014 ENEO Tecnologia S.L.
# This file is part of redBorder.
# redBorder is free software: you can redistribute it and/or modify
# it under the terms of the GNU Affero General Public License as published by
# the Free Software Foundation, either version 3 of the License, or
# (at your option) any later version.
# redBorder is distributed in the hope that it will be useful,
# but WITHOUT ANY WARRANTY; without even the implied warranty of
# MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
# GNU Affero General Public License for more details.
# You should have received a copy of the GNU Affero General Public License
# along with redBorder. If not, see <http://www.gnu.org/licenses/>.
#######################################################################

Rails.logger.info '[RB] Loading Policy Correlation Engine module'

Redborder::Module.register :correlation_engine_rule do

  name 'Correlation'
  path 'correlation_engine_rule'
  session_id 'correlation_engine_rule'

  # This module musn't appear in the UI
  interface_presence false

  DittoCode::Exec.if 'ENTERPRISE' do
    menu :tools_menu, :correlation_engine_rules,
         { controller: :correlation_engine_rules, action: :index },
         caption: "tr.correlation_engine_rules.correlation_engine_rule.correlation", after: :setting,
         html: { class: 'block-ui-but' },
         super_admin: true
  end
end

# Require controllers
require_dependency 'application_controller_correlation_engine_rule'

# Require models
require_dependency 'user_correlation_engine_rule'

to_prepare = proc do
  unless ApplicationController.include?(
    RedBorder::ApplicationControllerCorrelationEngineRule)
    ApplicationController
      .send(:include, RedBorder::ApplicationControllerCorrelationEngineRule)
  end
end

Rails.configuration.to_prepare(&to_prepare)
