#######################################################################
# Copyright (c) 2014 ENEO Tecnologia S.L.
# This file is part of redBorder.
# redBorder is free software: you can redistribute it and/or modify
# it under the terms of the GNU Affero General Public License as published by
# the Free Software Foundation, either version 3 of the License, or
# (at your option) any later version.
# redBorder is distributed in the hope that it will be useful,
# but WITHOUT ANY WARRANTY; without even the implied warranty of
# MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
# GNU Affero General Public License for more details.
# You should have received a copy of the GNU Affero General Public License
# along with redBorder. If not, see <http://www.gnu.org/licenses/>.
#######################################################################

class CreateCorrelationEngineRules < ActiveRecord::Migration
  def change
    unless ActiveRecord::Base.connection.table_exists? :correlation_engine_rules
      create_table :correlation_engine_rules do |t|
        t.string :name
        t.text :input, array: true, default: []
        t.text :execution_plan
        t.boolean :enabled, default: true
        t.boolean :applied, default: false
        t.references :user, index: true
        t.timestamps
      end
      add_column :correlation_engine_rules, :output, :json, default: {}
    end
  end
end
