/*!
 * Copyright (c) 2014 ENEO Tecnología S.L.
 * This file is part of redBorder.
 * redBorder is free software: you can redistribute it and/or modify
 * it under the terms of the GNU Affero General Public License as published by
 * the Free Software Foundation, either version 3 of the License, or
 * (at your option) any later version.
 * redBorder is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU Affero General Public License for more details.
 * You should have received a copy of the GNU Affero General Public License
 * along with redBorder. If not, see <http://www.gnu.org/licenses/>.
 */

function add_nodes_diagram_flow(g, nprobes, nodes) {

  for (i in nodes.rb_flow) {
    if (nodes.rb_flow.hasOwnProperty(i)) {
      if (nprobes.length != 0) {
        for (var j = 0; j < nprobes.length; j++) {
          if(g.hasNode("nprobe" + j) === false) {
            g.addNode("nprobe" + j, { label: "nprobe: " + nprobes[j] });
            g.addEdge(null, "netflow", "nprobe" + j);
          }

          g.addEdge(null, "nprobe" + j, "kafka");
        }
      } else {
        if (g.hasNode("nprobeNotPresent") === false) {
          g.addNode("nprobeNotPresent", { label: "no sensors present" });
        }

        g.addEdge(null, "nprobeNotPresent", "kafka");
      }
    }
  }
}

function add_node_flow(g, nprobes) {
  if (nprobes.length != 0) {
    g.addNode("netflow", { label: "Netflow"} );
  }
}
