redBorder.widgets.types.access_points = function (widget, data) {
  var product_type = widget.property.product_type;

  function queryTimeserie(opts) {
    if (data === undefined || data.timeserie === undefined) {
      return redBorder.widgets.util.query({
        widget: widget,
        url: '/flow/aps_serie',
        typeOpts: {
          aggregation: widget.property.aggregation,
          timezone: widget.property.timezone,
          granularity: widget.property.granularity,
          range: widget.property.range
        },
        graphOpts: opts
      }).then(function (data) {
        return data.aps;
      });
    } else {
      return $.Deferred().resolve(data.timeserie);
    }
  }

    // Gets the total data from that interval
  function queryTotal(opts) {
    if (data === undefined) {
      return redBorder.widgets.util.query({
        widget: widget,
        url: '/flow/aps_count',
        typeOpts: {
          aggregation: widget.property.aggregation,
          timezone: widget.property.timezone,
          granularity: 'all',
          range: widget.property.range
        },
        graphOpts: opts
      }).then(function (data) {
        if (data.aps.length === 0) return 0;
        return data.aps[0].event.events;
      });
    } else {
      if (data.total.length === 0){
        return $.Deferred().resolve(0);
      }

      return $.Deferred().resolve(data.total[0].event.events);
    }
  }

  return {
    queryTotal: queryTotal,
    queryTimeserie: queryTimeserie
  }
}
