redBorder.widgets.types.bandwidth = function (widget) {

  // Do the query to get the data
  // Return a deferred object
  function queryTimeserie(opts) {
    return redBorder.widgets.util.query({
      widget: widget,
      url: '/flow/tops/get_serie/raw',
      typeOpts: {
        aggregation: widget.property.aggregation,
        timezone: widget.property.timezone,
        granularity: widget.property.granularity
      },
      graphOpts: opts
    });
  }

  // Gets the total data from that interval
  function queryTotal(opts) {
    return redBorder.widgets.util.query({
      widget: widget,
      url: '/flow/tops/get_serie/raw',
      typeOpts: {
        aggregation: widget.property.aggregation,
        timezone: widget.property.timezone,
        granularity: 'all'
      },
      graphOpts: opts
    }).then(function (data) {
      if (data.length === 0) return 0;
      return data[0].event.events;
    });
  }

  return {
    queryTimeserie: queryTimeserie,
    queryTotal: queryTotal
  }
}