redBorder.widgets.types.channel_load = function (widget, data) {
  var product_type = widget.property.product_type;
  var titles = { '2_4': '2.4Ghz', '5': '5.0Ghz' };     // To prettify titles

  // Gets the total data from that interval
  function queryLoad(opts) {
    if (data === undefined) {
      return redBorder.widgets.util.query({
        widget: widget,
        url: '/flow/channels_load',
        type: 'GET',
        dataType: 'json',
        data: {
          end_time: widget.wtype.end_time_secs,
          start_time: widget.wtype.start_time_secs
        },
        typeOpts: {
          range: widget.property.range
        }
      }).then(function (data) {
        if (data.length === 0) return 0;

        var obj = {};

        Object.keys(data.channels_load).forEach(function (key) {
          var value = parseFloat(data.channels_load[key]);
          var color = value > 70 ? '#DE1E20' : '#44A658';
          obj[titles[key] || key] = {
            value: value,
            color: color
          };
        });

        return obj;
      });
    } else {
      return $.Deferred().resolve(data);
    }
  }

  function queryTimeserie(opts) {
    if (data === undefined || data.timeserie === undefined) {
      return redBorder.widgets.util.query({
        widget: widget,
        url: '/flow/channels_load_serie?channel=' + opts,
        typeOpts: {
          aggregation: widget.property.aggregation,
          timezone: widget.property.timezone,
          granularity: widget.property.granularity,
          range: widget.property.range
        }
      }).then(function (data) {
        return data.channels_load;
      });
    } else {
      return $.Deferred().resolve(data.timeserie[opts]);
    }
  }

  function queryList(opts) {
    var list = [];

    ['2_4', '5'].forEach(function (e) {
      list.push({
        name: titles[e],
        opts: e
      });
    });

    return $.Deferred().resolve(list);
  }

  return {
    queryLoad: queryLoad,
    queryTimeserie: queryTimeserie,
    queryList: queryList
  }
}