redBorder.widgets.types.user_experience = function (widget, data) {
  var product_type = widget.property.product_type;

  // Gets the total data from that interval
  function queryLoad(opts) {
    if (data === undefined || data.load === undefined) {
      return redBorder.widgets.util.query({
        widget: widget,
        url: '/flow/tops/get_tops/client_rssi',
        type: 'GET',
        dataType: 'json',
        data: {
          w: true,
          end_time: widget.wtype.end_time_secs,
          start_time: widget.wtype.start_time_secs
        }
      }).then(function (data) {
        if (!data || data.length === 0) return {};
        return buildLoad(data);
      });
    } else {
      if (data.load.length === 0){
        return $.Deferred().resolve({});
      }
      return $.Deferred().resolve(buildLoad(data.load));
    }
  }

  function buildLoad(data) {
    var total = 0;
    data.forEach(function (e) {
      if (e.client_rssi == null) return;
      total += e.bps;
    });

    var obj = {};
    data.forEach(function (e) {
      if (e.client_rssi == null) return;    // Skip if it does not have client_rssi

      var color = "#333";
      switch(e.client_rssi) {
        case "good":
          color = "#44A658";
          break;
        case "bad":
          color = "#DE5254";
          break;
        case "average":
          color = "#F26E57";
          break;
      };
      obj[e.client_rssi] = {
        value: parseFloat((e.bps / total * 100).toFixed(2)),
        color: color
      };
    });
    return obj;
  }

  return {
    queryLoad: queryLoad
  }
}
