/*!
 * Copyright (c) 2014 ENEO Tecnología S.L.
 * This file is part of redBorder.
 * redBorder is free software: you can redistribute it and/or modify
 * it under the terms of the GNU Affero General Public License as published by
 * the Free Software Foundation, either version 3 of the License, or
 * (at your option) any later version.
 * redBorder is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU Affero General Public License for more details.
 * You should have received a copy of the GNU Affero General Public License
 * along with redBorder. If not, see <http://www.gnu.org/licenses/>.
 */

$(document).on('click', 'form.home_network input.btn-success', function(e) {

  var errors = $('form.home_network').find('input:invalid').parent();
  if (errors.length > 0) {
    errors.addClass('error');
  } else {
    $('form.home_network').submit();
  };

    return false;
});

$(document).on('click', 'form.router_mac input.btn-success', function(e) {
  var errors = $('form.router_mac').find('input:invalid').parent();
  if (errors.length > 0) {
    errors.addClass('error');
  } else {
    $('form.router_mac').submit();
  };
  return false;
});

$(document).on('click', 'form.new_access_point input.btn-success', function(e) {

  var errors = $('form.new_access_point').find('input:invalid').parent();
  if (errors.length > 0) {
    errors.addClass('error');
  } else {
    $('form.new_access_point').submit();
  };

    return false;
});

$(document).on('click', 'form.simple_form.new_gps_marker input.btn-success', function(e) {
    var errors = $('body.sensors.view .modal').find('input:invalid').parent();
    if (errors.length > 0) {
     errors.addClass('error');
    } else {
      $('form.new_gps_marker').submit();
    };

    return false;
});

function apply_ap_filter(target){
  var filters = $(".access_points_status a.btn-success").length;
    var sensor_id = target.data('sensor-id');
    var url = "/sensors/" + sensor_id + '/search_aps';
    var search = target.val();
    var status = get_status_filters();

    if (redBorder.currentAPs !== undefined) {
      redBorder.currentAPs.highlight(search);
    }

    $('#access_points_status_offset').remove();

    if (search == '' && filters == 0 && $("#access_points table tbody .hidden").length > 0 ){
      // Show the saved table
      $("#access_points table tbody tr").each(function(index){
        if($(this).hasClass('hidden')){
          $(this).removeClass('hidden')
        } else {
          $(this).remove()
        }
      });
      $("#access_points_offset").css('display', 'block');

    } else {
      $("#access_points_offset").css('display', 'none');

      // Save the current table
      $("#access_points table tbody tr").each(function(index){
        if($(this).hasClass('ap_from_status')){
          $(this).remove();
        } else {
          $(this).addClass('hidden');
        }
      });

      show_loading();

      $.ajax({
        url: url,
        remote: true,
        type: 'GET',
        dataType: 'script',
        data: {
          search: search,
          status: status
        }
      }).done(function () {
        if ($("#access_points_location_map").is(":visible")){
          $('.center_map_on_marker').show();
        }
      });
    }

    return false;
}

$(document).on('keypress', "#access_points input#search", function(e){
  if(e.which == 13) {
    apply_ap_filter($(this));
  }

});

$(document).on('submit', "#search-zones", function(e){
  $(".zones-wrap").html("<div class='loading'><i class='fa fa-refresh fa-spin'></i> " + I18n.t('javascript.loading') + "</div>");
});

$(document).on('click', ".sensors.view a.export_objects", function(event){
  var url    = $(this).data("url"),
      search = $(this).data('search'),
      status = $(this).data('status');
  post_to_url(url, { search: search, status: status }, 'GET');
  return false;
});

$(document).on('click', ".access_points_status a", function(event){

  // Check the number of active filters
  var filters = $(".access_points_status a.btn-success").length;
  var filter_status = parseInt($(this).attr('data-status'));
  var sensor_id = $(this).attr('data-sensor');
  var status;
  var search = $("#access_points #search");
  var searchValue = search.val();

  $('#access_points_status_offset').remove();

  // Check the status of the button
  if($(this).hasClass('btn-success')){

    $(this).removeClass('btn-success');

    if (filters == 1){

      // Check if we have some search term
      if(searchValue.length > 0){
        // Search by the term
        if (filter_status === 3)
          var url = "/sensors/" + sensor_id + '/search_unallocated_aps';
        else
          var url = "/sensors/" + sensor_id + '/search_aps';

        $("#access_points_offset").css('display', 'none');

        // Save the current table
        $("#access_points table tbody tr").each(function(index){
          if($(this).hasClass('ap_from_status')){
            $(this).remove();
          } else {
            $(this).addClass('hidden');
          }
        });

        show_loading();

        $.ajax({
          url: url,
          remote: true,
          type: 'GET',
          dataType: 'script',
          data: {
            search: searchValue
          }
        });

      } else {
        // Show the saved table
        $("#access_points table tbody tr").each(function(index){
          if($(this).hasClass('hidden')){
            $(this).removeClass('hidden')
          } else {
            $(this).remove()
          }
        });

        $("#access_points_offset").css('display', 'block');
        if (redBorder.access_points_map !== undefined) {
          redBorder.access_points_map.showMarkers()
        }
      }

    } else {
      $("#access_points_status_offset").css('display', 'none');

      // Delete the rows with the status pulsed
      $("#access_points table tbody tr.ap_from_status").remove()

      // Get status filters
      status = get_status_filters();

      if (searchValue != undefined && searchValue != ''){
        $.getScript('/sensors/' + sensor_id + '/access_points/' + status + '/status?search=' + searchValue);
      } else {
        $.getScript('/sensors/' + sensor_id + '/access_points/' + status + '/status');
      }

      show_loading();
    }

  } else {

    $("#access_points_offset").css('display', 'none');

    $(this).addClass('btn-success')

    // Save the current table
    $("#access_points table tbody tr").each(function(index){
      if($(this).hasClass('ap_from_status')){
        $(this).remove();
      } else {
        $(this).addClass('hidden');
      }
    });

    // Get status filters
    status = get_status_filters();

    if (search != undefined && search.val() != ''){
      $.getScript('/sensors/' + sensor_id + '/access_points/' + status + '/status?search=' + search.val());
    } else {
      $.getScript('/sensors/' + sensor_id + '/access_points/' + status + '/status');
    }

    show_loading();

  }

  return false;

})

/*
* Get the current active filters
*/
function get_status_filters() {
  // Status
  var status = [];
  // Get active status
  $('.access_points_status a.btn-success').each(function(index){
    status.push($(this).attr('data-status'));
  });
  // Return status
  return status.join();
}

/*
* Show loading in the table
*/
function show_loading(){
  $("#access_points table tbody tr.loading").remove();
  $('div.access_points_status a').attr('disabled', true);
  $("#access_points table tbody").append("<tr class='loading'><td colspan='8'><i class='fa fa-refresh fa-spin'></i> " + I18n.t('javascript.') + "</td></tr>");
}

$(document).on('mouseenter', "#access_points tbody tr", function (e) {
  var id = $(this).data("access-point-id");

  if (redBorder.currentAPs !== undefined) {
    redBorder.currentAPs.highlight(id);
  }

});

$(document).on('mouseenter', "#access_points tbody tr td:not(.last)", function (e) {
  var id = $(this).parent().data("access-point-id");

  if (redBorder.access_points_map !== undefined) {
    redBorder.access_points_map.highlightMarker(id);
  }
});

$(document).on('mouseenter', "#gps_markers tbody tr", function (e) {
  var id = $(this).attr('data-gps-marker-id')

  if (redBorder.currentAPs !== undefined) {
    redBorder.currentAPs.highlight(id);
  }
});

$(document).on('mouseout', "div#access_points", function (e) {
  if (redBorder.currentAPs !== undefined) {
    redBorder.currentAPs.highlight_by_names_and_types('ap');
  }

  if (redBorder.access_points_map !== undefined) {
    redBorder.access_points_map.highlightMarker(null);
  }
});

$(document).on('click', "li#access_points a", function (e) {
  if (redBorder.currentAPs !== undefined) {
    redBorder.currentAPs.highlight_by_names_and_types('ap');
  }
});

$(document).on('mouseout', "div#gps_markers", function (e) {
  if (redBorder.currentAPs !== undefined) {
    redBorder.currentAPs.highlight_by_names_and_types('gps_markers');
  }
});

$(document).on('click', "li#gps_markers a", function (e) {
  if (redBorder.currentAPs !== undefined) {
    redBorder.currentAPs.highlight_by_names_and_types('gps_markers');
  }
});

$(document).on('click', "tr[data-access-point-id]", function (e) {
  if (e.shiftKey) {
    var selectedSerie = redBorder.lastSerieSelected;

    if (selectedSerie !== undefined) {
      var selectedSeriesIndex = selectedSerie.index();
      var myIndex = $(this).index();
      var firstElement, lastElement;

      if (selectedSeriesIndex < myIndex) {
        firstElement = selectedSerie;
        lastElement = $(this);
      } else if (selectedSeriesIndex > myIndex) {
        firstElement = $(this);
        lastElement = selectedSerie;
      }

      if (firstElement !== undefined) {
        var series = firstElement.nextUntil(lastElement);
        series.each(function() {
          selectRow($(this));
        });
      }
    }
  }
  selectRow($(this));
});

$(document).on('click', "div#gps_markers table tr", function (e) {
  if (e.shiftKey) {
    var selectedSerie = redBorder.lastSerieSelected;

    if (selectedSerie !== undefined) {
      var selectedSeriesIndex = selectedSerie.index();
      var myIndex = $(this).index();
      var firstElement, lastElement;

      if (selectedSeriesIndex < myIndex) {
        firstElement = selectedSerie;
        lastElement = $(this);
      } else if (selectedSeriesIndex > myIndex) {
        firstElement = $(this);
        lastElement = selectedSerie;
      }

      if (firstElement !== undefined) {
        var series = firstElement.nextUntil(lastElement);
        series.click();
      }
    }
  }
  var name = $(this).find('td[data-label="Name"]').html();
  $(this).toggleClass('selected');
  redBorder.lastSerieSelected = $(this);

  if (redBorder.currentAPs !== undefined) {
    redBorder.currentAPs.highlight_by_names_and_types('gps_marker');
  }
});

$(document).on('click', '#add-zones li a', function(event){

  event.preventDefault();

  var zone_id = $(this).attr('data-zone-id')
  var access_points = []

  $('#access_points table tbody tr.selected').each(function(index){
    access_points.push($(this).attr('data-access-point-id'));
  });

  // Send it to the controller
  var posting = $.post("/zones/" + zone_id + "/add_access_points" , { access_point_ids: access_points }, function(data) {

    if(data.status == 'ok'){
      // All ok, show the new zone!
      for(var i = 0; i < data.access_point_ids.length; i++){
        var zones = $("#access_points table tbody tr[data-access-point-id='" + data.access_point_ids[i] + "'] td[data-label='Zones']");
        if (zones.text().length > 0){
          zones.html(zones.text() + ', <span data-zone-id="'+ data.zone_id +'">' + data.zone_name + '</span>');
        } else {
          zones.html(data.zone_name);
        }
        // Highlight
        zones.addClass('new_zones')
          .delay(2000)
          .queue(function(n){
            $(this).removeClass('new_zones')
            n();
          })
      }
    } else if (data.status == 'warn') {
      // Some permission problems
    } else {
      // Show error
    }

  },"json");

  return false;

});

$(document).on('click', '#remove-zones li a', function(event){

  event.preventDefault();

  var zone_id = $(this).attr('data-zone-id')
  var access_points = []

  $('#access_points table tbody tr.selected').each(function(index){
    access_points.push($(this).attr('data-access-point-id'));
  });

  // Send it to the controller
  var posting = $.post("/zones/" + zone_id + "/remove_access_points" , { access_point_ids: access_points }, function(data) {

    if(data.status == 'ok'){
      // All ok, show the new zone!
      for(var i = 0; i < data.access_point_ids.length; i++){
        var zones = $("#access_points table tbody tr[data-access-point-id='" + data.access_point_ids[i] + "'] td[data-label='Zones']");
        if (zones.text().length > 0){
          zones.html(zones.html().replace(', <span data-zone-id="'+ data.zone_id +'">'+data.zone_name+'</span>', ""));
          zones.html(zones.html().replace('<span data-zone-id="'+ data.zone_id +'">'+data.zone_name+'</span>, ', ""));
          zones.html(zones.html().replace('<span data-zone-id="'+ data.zone_id +'">'+data.zone_name+'</span>', ""));
        } else {
          zones.html("");
        }
        // Highlight
        zones.addClass('deleted_zones')
          .delay(2000)
          .queue(function(n){
            $(this).removeClass('deleted_zones')
            n();
          })
      }
    } else if (data.status == 'warn') {
      // Some permission problems
    } else {
      // Show error
    }

  },"json");

  return false;

});

$(document).on('click', 'tr[data-access-point-id] a.btn, tr[data-access-point-id] a.btn', function(event){
  event.stopPropagation();
});

$(document).on('click', 'ul.nav.nav-tabs.sensor-view-tabs li', function(){
  var id = $(this).attr('id');

  $('div.tab-pane').removeClass('in active');
  $('div.tab-pane#' + id).addClass('in active');
});

$(document).on('click', 'body.sensors li[data-role="show_gps_markers"]', function (e) {
  var self = $(this),
      status = self.data('status');

  if (status === 'enabled') {
    self.data('status', 'disabled');
    $('a', self).text('Show GPS Markers');
    if (redBorder.currentAPs !== undefined) {
      redBorder.currentAPs.hide_gps_markers();
    }
    $('div#gps_markers div.alert.alert-info').removeClass('hidden');
    $('div#gps_markers div.alert.alert-info').show();
  } else {
    self.data('status', 'enabled');
    $('a', self).text(I18n.t('javascript.hide_gps'));
    if (redBorder.currentAPs !== undefined) {
      redBorder.currentAPs.show_gps_markers();
    }
    $('div#gps_markers div.alert.alert-info').hide();
  }

  return false;
});

$(document).on('click', ".center_map_on_marker", function (e) {
  var ap_id = $(this).parent().parent().data("access-point-id");
  redBorder.access_points_map.selectMarker(ap_id);
  if(!$(this).hasClass('btn-success')){
    $('.center_map_on_marker.btn-success').removeClass('btn-success');
    $('html, body').animate({
      scrollTop: $("#access_points_container").offset().top
    }, 400);
  }
  $(this).toggleClass("btn-success");
});

$(document).on('click', 'body.sensors li#gps_markers a', function (e) {
  var self = $('body.sensors li[data-role="show_gps_markers"]'),
      status = self.data('status');

  if (status === 'disabled') {
    self.data('status', 'enabled');
    $('a', self).text(I18n.t('javascript.hide_gps'));
    if (redBorder.currentAPs !== undefined) {
      redBorder.currentAPs.show_gps_markers();
    }
    $('div#gps_markers div.alert.alert-info').hide();
  }
});

$(document).on('click', '.view_access_points_floor_image', function (e) {
  $('li[data-role="show_gps_markers"]').show();
  $('li a .delete_image_button').show();
  $("#access_points_3d_container").hide();
  show_floor_image();
  return false;
});

$(document).on('click', '.view_access_points_floor_map', function (e) {
  $('li[data-role="show_gps_markers"]').hide();
  $('li a .delete_image_button').hide();
  $("#access_points_3d_container").hide();
  show_floor_map($("#access_points_from_sensor").data('draggable'));
  return false;
});

$(document).on('click', 'body.sensors li[data-role="show_wlc_floors"]', function (e) {
  $("#access_points_3d_container").hide();
  var self = $(this),
      status = self.data('status');
  if (status === "disabled"){
    self.data('status', 'enabled');
    self.find('i').hide();
    self.find('img').show();
    self.find('span').text(I18n.t('javascript.show_floors'));
    show_wlc_map($(this).data('draggable'));
    $(".view-sensor-wrap").hide();
    $(".center_map_on_marker").show();

  } else {
    self.data('status', 'disabled');
    self.find('i').show();
    self.find('img').hide();
    self.find('span').text(I18n.t('javascript.show_map'));
    $('#access_points_location_map').hide();
    $(".view-sensor-wrap").show();
    $(".center_map_on_marker").hide();
  }

  return false;
});

$(document).on('click', '.view_access_points_tiles', function (e) {
  $("#access_points_3d_container").hide();
  $("#access_points_from_sensor .offset-controls").show();
  $('#access_points_location_map').hide();
  $('#view_ap_status').hide();
  if ($(".dropzone .image-success").length > 0) {
    $('.dropzone').show();
  } else {
    $('#access_points_location_image').show();
  }
  $(".view-sensor-wrap").show();
  $(".center_map_on_marker").hide();
  return false;
});

$(document).on('click', '.view_3d_map', function (e) {
  var self = $(this);
  $('#access_points_location_map').hide();
  $('#access_points_location_image').hide();
  $("#access_points_from_sensor .offset-controls").hide();
  $('.dropzone').hide();
  $(".view-sensor-wrap").hide();
  $(".center_map_on_marker").hide();
  $('#access_points_location_map').hide();
  $('#view_ap_status').hide();
  if (self.data('status') === 'enabled'){
    $("#access_points_3d_container").show();
    return false;
  }
  self.data('status', 'enabled');
  $('#')
  var sensor = $("#access_points_from_sensor").data('sensor');
  var url = "/sensors/3d/" + sensor;
  blockWebUI();
  $.ajax({
    url: url,
    remote: false,
    type: 'GET',
    dataType: 'json'
  }).done(function(data){
    $("#access_points_3d_container").show();
    redBorder.threeDimensionsFloors("#map-container", data);
    $.unblockUI();
  });
  return false;
});

$(document).on('click', '.view_access_points_map', function (e) {
  $("#access_points_3d_container").hide();
  $('#access_points_location_image').hide();
  $("#access_points_from_sensor .offset-controls").hide();
  $('.dropzone').hide();
  $('#view_ap_status').hide();
  var self = $(this);
  self.data('status', 'enabled');
  self.find('span').text(I18n.t('javascript.show_tiles'));
  blockWebUI();
  $('.access_points_status a.btn-success').click();
  show_wlc_map($("#access_points_from_sensor").data('draggable'));
  $.unblockUI();
  $(".view-sensor-wrap").hide();
  $(".center_map_on_marker").show();
  redBorder.access_points_map.fitMapOnGpsMarkers();
  return false;
});

$(document).on('click', '.view_access_points_status', function (e) {
  $('#access_points_location_map').hide();
  $('#access_points_location_image').hide();
  $("#access_points_from_sensor .offset-controls").hide();
  $('.dropzone').hide();
  $(".view-sensor-wrap").hide();
  $(".center_map_on_marker").hide();
  $('#access_points_location_map').hide();
  $('#view_ap_status').show();
  initDateRange();
  return false;
});

function selectRow($row) {
  var name = $row.find('td[data-label="Name"]').html();
  $row.toggleClass('selected');
  redBorder.lastSerieSelected = $row;

  if (redBorder.currentAPs !== undefined) {
    redBorder.currentAPs.highlight_by_names_and_types('ap');
  }

  if($('#access_points table tbody tr.selected').length > 0){
    var current_zones = []
    var ids = [];

    // Load the selected zones to add to remove menu
    $('#access_points table tbody tr.selected').each(function(index){
      var items = [];
      $row.find('td[data-label="Zones"] span').each(function(index){
        var id = $row.attr('data-zone-id')
        if($.inArray(id, ids) == -1){
          ids.push(id)
          items.push({name: $row.text(), id: id});
        }
      });
      current_zones = current_zones.concat(items)
    });

    // Remove empty strings
    current_zones = current_zones.filter(Boolean)
    if(current_zones.length > 0){

      current_zones = sort_unique(current_zones);
      var list = "";
      for(var i = 0; i < current_zones.length; i++){
        list += "<li><a href='#' data-zone-id='"+ current_zones[i].id +"'>" + current_zones[i].name + "</a></li>";
      }

      $("#remove-zones").html(list)
    } else {
      $("#remove-zones").html("<li><a href='#' onclick='return false;' style='cursor: auto'>" + I18n.t('javascript.selected_ap') + "</a></li>")
    }
    // Show the button
    $(".edit-zone-selector").removeClass('hidden')
  } else {
    $(".edit-zone-selector").addClass('hidden')
  }
}

/*
* Show Floor info window for 3d floors map
*/
function initFloorInfoWindow(selector){
    $info = $(selector);
    $info.append('<div class="title-wrapper">' +
                      '<div class="title"></div>' +
                      '<div class="subtitle">' + I18n.t('javascript.ap_info') + '</div>' +
                  '</div>' +
                  '<div class="body">' +
                      '<p> <i class="fa fa-circle" style="color: green"></i><span>' + I18n.t('javascript.up') + ' </span><span data-holder="up"></span> </p>' +
                      '<p> <i class="fa fa-circle" style="color: red"></i><span>' + I18n.t('javascript.down') + ' </span><span data-holder="down"></span> </p>' +
                      '<p> <i class="fa fa-circle" style="color: orange"></i><span>' + I18n.t('javascript.unknown') + ' </span><span data-holder="unknown"></span> </p>' +
                      '<p> <i class="fa fa-question-circle"></i><span> ' + I18n.t('javascript.unallocated') + ' </span><span data-holder="unallocated"></span> </p>' +
                  '</div>');
}

/*
* Show AP info window for 3d floors map
*/
function initApInfoWindow(selector){
    $info = $(selector);
    $info.append('<div class="title-wrapper">' +
    '<div class="title"></div>' +
    '<div class="subtitle">' + I18n.t('javascript.ap_info2') + '</div>' +
    '</div>' +
    '<div class="body">' +
    '<p> <span><b>' + I18n.t('javascript.ip_address') + ' </b></span><span data-holder="ip-address"></span> </p>' +
    '<p> <span><b>' + I18n.t('javascript.mac_address') + ' </b></span><span data-holder="mac-address"></span> </p>' +
    '</div>');
}


function initRedBorderAPs(aps, gps_markers, show_gps_markers, parentDomains) {
  aps.concat(gps_markers).forEach(function (element) {
    element.lat = element.latitude;
    element.lng = element.longitude;
  });

  redBorder.aps_json = aps;
  redBorder.gps_markers_json = gps_markers;
  redBorder.show_gps_markers = show_gps_markers;
  redBorder.parent_domains = parentDomains;

  show_floor_image();
}

function show_floor_map(draggable) {
  if (draggable === undefined) draggable = false;
  var self = $('#access_points_location_map');
  $(".center_map_on_marker").show();
  $('.dropzone').hide();
  $('#access_points_location_map').show();
  $('#access_points_location_image').hide();

  if (self.data('loaded')) return;
  else self.data('loaded', true);

  try {
    redBorder.access_points_map = redBorder.map({
      container: 'access_points_location_map',
      draggableCursor: 'crosshair',
      clustered: true,
      contextMenu: true,
      scrollwheel: false
    });

    redBorder.aps_json.forEach(function (ap) {
      if(ap.longitude != undefined && ap.latitude != undefined){
        var color, tooltip;

        tooltip = "<b>" + I18n.t('javascript.name') + "</b> " + ap.name + "<br />" +
          "<b>" + I18n.t('javascript.mac_address') + "</b> " +  ap.mac_address + "<br />" +
          "<b>" + I18n.t('javascript.latitude') + "</b> " + Math.round(ap.latitude * 10000) / 10000 + "<br />" +
          "<b>" + I18n.t('javascript.longitude') + "</b> " + Math.round(ap.longitude * 10000) / 10000;

        if (ap.status === 1) color = 'green';
        else if (ap.status === 2) color = 'red';
        else color = 'orange';

        redBorder.access_points_map.addMarker(ap.latitude, ap.longitude, {
          content: tooltip,
          filterWhenClick: true,
          markerId: ap.id,
          draggable: draggable,
          dragEndCallback: function(marker, event){
            var url = "/sensors/access_point/" + ap.id
            $.ajax({
              url: url,
              remote: false,
              type: 'POST',
              dataType: 'json',
              data: {
                access_point: {
                  latitude: event.latLng.lat(),
                  longitude: event.latLng.lng()
                },
                relocate: true
              }
            }).done(function(relocated_ap){
              $('.rb-aps.zone-ap[data-rb-aps-id='+ relocated_ap.id +']').remove();
              if (redBorder.currentAPs !== undefined) {
                redBorder.currentAPs.add_aps([relocated_ap]);
              }
            });
          },
          icon: {
            path: google.maps.SymbolPath.CIRCLE,
            scale: 12,
            strokeWeight: 1.3,
            strokeColor: 'dark'+ color,
            fillColor: color,
            fillOpacity: .85
          }
        });
      }
    });
  } catch (err) {
    console.log('Floor map ' + err);
  }
}

function show_floor_image() {
  $(".center_map_on_marker").hide();
  var self = $('#access_points_location_image');

  $('#access_points_location_map').hide();

  // Check if the image of the floor exist
  if($('#access_points_location_image').html() == ''){
    $('.dropzone').show();
  } else {
    $('#access_points_location_image').show();

    if (self.data('loaded')) return;
    else self.data('loaded', true);

    redBorder.currentAPs = redBorder.aps({
      show_gps_markers: redBorder.show_gps_markers
    });

    if (redBorder.currentAPs !== undefined) {
      redBorder.currentAPs.add_aps(redBorder.aps_json);
      redBorder.currentAPs.add_gps_markers(redBorder.gps_markers_json);
      redBorder.currentAPs.add_parent_domains(redBorder.parent_domains);
    }
  }
}

function initRedBorderMapAPs(aps, draggable) {
  if (draggable === undefined) draggable = false;
  aps.forEach(function (element) {
    element.lat = element.latitude;
    element.lng = element.longitude;
  });

  redBorder.aps_json = aps;
}

function update_aps_by_status(status, aps, text) {
  $('.access_points_status a#status_' + status).data('count', aps);
  $('.access_points_status a#status_' + status)
    .find('span').text(text + " (" + aps + ")");
  if (aps > 0) {
    $('.access_points_status a#status_' + status).removeClass('hidden');
  } else {
    $('.access_points_status a#status_' + status).addClass('hidden');
  }
}

function show_wlc_map(draggable) {
  $("#access_points_3d_container").hide();
  if (draggable === undefined) draggable = false;
  var self = $('#access_points_location_map');

  $('#access_points_location_map').show();

  if (self.data('loaded')) return;
  else self.data('loaded', true);

  try {
    redBorder.access_points_map = redBorder.map({
      container: 'access_points_location_map',
      draggableCursor: 'crosshair',
      clustered: true,
      contextMenu: true,
      scrollwheel: false
    });

    show_aps_json(draggable);
  } catch (err) {
    console.log('Floor map ' + err);
  }
}

function show_aps_json(draggable) {
  redBorder.aps_json.forEach(function (ap) {
    if(ap.longitude != undefined && ap.latitude != undefined){
      var color, tooltip;

      tooltip = "<b>" + I18n.t('javascript.name') + "</b> " + ap.name + "<br />" +
        "<b>" + I18n.t('javascript.mac_address') + "</b> " +  ap.mac_address + "<br />" +
        "<b>" + I18n.t('javascript.latitude') + "</b> " + Math.round(ap.latitude * 10000) / 10000 + "<br />" +
        "<b>" + I18n.t('javascript.longitude') + "</b> " + Math.round(ap.longitude * 10000) / 10000 + "<br />"

      if (ap.status === 1) color = 'green';
      else if (ap.status === 2) color = 'red';
      else color = 'orange';

      redBorder.access_points_map.addMarker(ap.latitude, ap.longitude, {
        content: tooltip,
        filterWhenClick: true,
        markerId: ap.id,
        draggable: draggable,
        dragEndCallback: function(marker, event){
          var url = "/sensors/access_point/" + ap.id
          $.ajax({
            url: url,
            remote: false,
            type: 'POST',
            dataType: 'json',
            data: {
              access_point: {
                latitude: event.latLng.lat(),
                longitude: event.latLng.lng()
              },
              relocate: true
            }
          });
        },
        icon: {
          path: google.maps.SymbolPath.CIRCLE,
          scale: 12,
          strokeWeight: 1.3,
          strokeColor: 'dark'+ color,
          fillColor: color,
          fillOpacity: .85
        }
      });
    }
  });
}

// ======================================================
// ZONES JS
// ======================================================

$(document).on("click", '#access_points_container .zone-ap', function(event, element){

  if($('.zone-editing').length > 0){

    var zone_id = $('.zone-editing').attr('data-zone-id');
    var sensor_id = $('.zone-editing').attr('data-sensor-id');

    // The app is in this zone, we need to delete it from the zone
    if($(this)[0].classList.contains('rb-aps-big')){

      // Send it to the controller
      var posting = $.post("/zones/" + zone_id + "/remove_access_point" , { access_point_id: $(this).attr('data-rb-aps-id') }, function(data) {

        if(data.status == 'ok'){
          var item = $("svg[data-rb-aps-id='" + data.access_point_id + "'] circle");
          item[0].classList.remove('rb-aps-highlighted')
          item.parent()[0].classList.remove('rb-aps-big');

          // Change id of zones
          var id_zones = item.parent().attr('data-rb-aps-zones');
          id_zones = id_zones.replace(","+ data.zone_id +",", ",");
          var reg1 = new RegExp("^" + data.zone_id + ",")
          id_zones = id_zones.replace(reg1, "");
          var reg2 = new RegExp("^" + data.zone_id + "$")
          id_zones = id_zones.replace(reg2, "");
          item.parent().attr('data-rb-aps-zones', id_zones)

          // Update the number of items in the zone:
          var num_aps = $('.zone[data-zone-id="'+ data.zone_id +'"] .zone-num-aps');
          var num_aps_floor = $('.zone[data-zone-id="'+ data.zone_id +'"] .zone-num-aps-floor');
          var current = parseInt(num_aps.text());
          var current_floor = parseInt(num_aps_floor.text());

          // Check the zone status
          if(data.zone_has_problems){
            $('.zone[data-zone-id="'+ data.zone_id +'"]').addClass('down_aps')
          } else {
            $('.zone[data-zone-id="'+ data.zone_id +'"]').removeClass('down_aps')
          }

          num_aps
            .html((current - 1) + "<i class='fa fa-long-arrow-down' style='color: red; margin-left: 5px;'></i>")
            .delay(500)
            .queue(function(n){
              $(this).find('i').fadeOut(300);
              n();
            })

          num_aps_floor
            .html((current_floor - 1) + "<i class='fa fa-long-arrow-down' style='color: red; margin-left: 5px;'></i>")
            .delay(500)
            .queue(function(n){
              $(this).find('i').fadeOut(300);
              n();
            })

        } else {
          // Show error
        }

      },"json");

    } else {

      // Send it to the controller
      var posting = $.post("/zones/" + zone_id + "/add_access_point" , { access_point_id: $(this).attr('data-rb-aps-id') }, function(data) {

        if(data.status == 'ok'){
          var item = $("svg[data-rb-aps-id='" + data.access_point_id+ "'] circle");
          item[0].classList.add('rb-aps-highlighted');
          item.parent()[0].classList.add('rb-aps-big');

          // Change the ID of zones
          var id_zones = item.parent().attr('data-rb-aps-zones') + "," + data.zone_id
          item.parent().attr('data-rb-aps-zones', id_zones)

          // Update the number of items in the zone:
          var num_aps = $('.zone[data-zone-id="'+ data.zone_id +'"] .zone-num-aps');
          var current = parseInt(num_aps.text());
          var num_aps_floor = $('.zone[data-zone-id="'+ data.zone_id +'"] .zone-num-aps-floor');
          var current_floor = parseInt(num_aps_floor.text());

          // Check the zone status
          if(data.zone_has_problems){
            $('.zone[data-zone-id="'+ data.zone_id +'"]').addClass('down_aps')
          } else {
            $('.zone[data-zone-id="'+ data.zone_id +'"]').removeClass('down_aps')
          }

          num_aps
            .html((current + 1) + "<i class='fa fa-long-arrow-up' style='color: green; margin-left: 5px;'></i>")
            .delay(500)
            .queue(function(n){
              $(this).find('i').fadeOut(300);
              n();
            })

          num_aps_floor
            .html((current_floor + 1) + "<i class='fa fa-long-arrow-up' style='color: green; margin-left: 5px;'></i>")
            .delay(500)
            .queue(function(n){
              $(this).find('i').fadeOut(300);
              n();
            })

        } else {

        }

      },"json");

    }

  }

});

$(document).on("click", '.zones-wrap .zone, li#zones', function(event, element){

  // Check if we are on domain or floor
  if($("#access_points_location_image").length > 0){

    if($(this).hasClass('zone-editing')){
      $(this).removeClass("zone-editing");
    } else if ($('.zone-editing').length > 0) {
      $('.zone-editing').removeClass('zone-editing');
      $(this).addClass("zone-editing");
      if (redBorder.currentAPs !== undefined) {
        redBorder.currentAPs.highlight_by_zones($(this).attr('data-zone-id'))
      }
    } else {
      $(this).addClass("zone-editing");
      if (redBorder.currentAPs !== undefined) {
        redBorder.currentAPs.highlight_by_zones($(this).attr('data-zone-id'))
      }
    }

  } else {

    var zone_id = $(this).attr('data-zone-id');

    if($(this).hasClass('zone-editing')){
      $(this).removeClass("zone-editing");
    } else if ($('.zone-editing').length > 0) {
      $('.zone-editing').removeClass('zone-editing');
      $(this).addClass("zone-editing");
      $('.view-sensor').each(function(index){
        var ids = $(this).attr('data-zones')

        if(ids != undefined && $.inArray(zone_id, ids.split(',')) != -1){
          $(this).addClass('highlight')
        } else {
          $(this).removeClass('highlight')
        }
      })
    } else {
      $(this).addClass("zone-editing");

      $('.view-sensor').each(function(index){
        var ids = $(this).attr('data-zones')

        if(ids != undefined && $.inArray(zone_id, ids.split(',')) != -1){
          $(this).addClass('highlight')
        } else {
          $(this).removeClass('highlight')
        }
      })
    }
  }

});

$(document).on("mouseover", '.zones-wrap .zone', function(event){

  var zone_id = $(this).attr('data-zone-id');

  // Check if we are on domain or floor
  if($("#access_points_location_image").length > 0){
    // We are on floor

    // If there aren't any editing...
    if($('.zone-editing').length == 0){
      redBorder.currentAPs.highlight_by_zones(zone_id)
    }
  } else {
    // We are on domain

    // If there aren't any editing...
    if($('.zone-editing').length == 0){
      $('.view-sensor').each(function(index){
        var ids = $(this).attr('data-zones')

        if(ids != undefined && $.inArray(zone_id, ids.split(',')) != -1){
          $(this).addClass('highlight')
        } else {
          $(this).removeClass('highlight')
        }
      })
    }
  }

});

$(document).on("click", ".delete-selected-aps", function(event){
  event.preventDefault();
  var selectedAps = $(".selected"),
      sensorId = $(".access-points-table-container").data("sensor"),
      apsIds = []
      url = "/sensors/access_point/" + $(this).data("access-point-id"),
      msg = I18n.t('confirm');


  if (selectedAps.length > 1) {
    url = "/sensors/" + sensorId + "/access_points";
    apsIds =
      selectedAps.map(function() { return $(this).data("access-point-id") } )
        .get();
    msg = I18n.t('javascript.you_will') + msg;
    blockWebUI();
  }
  if (confirm(msg)){
    $.ajax({
      url: url,
      method: "DELETE",
      dataType: "script",
      data: {
        selected_aps: apsIds,
        sensor_id: sensorId
      }
    });
  }
});

$(document).on("click", '#assign_floor', function(){
  $(this).html("<i class='fa fa-spinner fa-pulse'></i>");
  var id = $(this).data('id'),
      url = "/sensors/"+ id +"/assign_floor_to_access_point",
      sensor_floor = $("#assignable_floors_id option:selected").val(),
      aps = $('.selected').map(function () {
        return $(this).data('access-point-id');
      });
  $.ajax({
    url: url,
    type: 'PATCH',
    remote: false,
    dataType: 'script',
      data: {
        access_points: aps.get(),
        sensor_floor: sensor_floor
      }
  });
});

$(document).on("mouseout", '.zones-wrap .zone', function(event){

  // Check if we are on domain or floor
  if($("#access_points_location_image").length > 0){
    // If there aren't any editing...
    if($('.zone-editing').length == 0){
      redBorder.currentAPs.highlight()
    }
  } else {
    if($('.zone-editing').length == 0){
      $('.view-sensor').each(function(index){
        $(this).removeClass('highlight')
      })
    } else {
      $(this).removeClass('highlight')
    }
  }

});
