#######################################################################
# Copyright (c) 2014 ENEO Tecnologia S.L.
# This file is part of redBorder.
# redBorder is free software: you can redistribute it and/or modify
# it under the terms of the GNU Affero General Public License as published by
# the Free Software Foundation, either version 3 of the License, or
# (at your option) any later version.
# redBorder is distributed in the hope that it will be useful,
# but WITHOUT ANY WARRANTY; without even the implied warranty of
# MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
# GNU Affero General Public License for more details.
# You should have received a copy of the GNU Affero General Public License
# along with redBorder. If not, see <http://www.gnu.org/licenses/>.
#######################################################################

#
# API endpoint for Cisco Meraki.
#
class Api::V1::MerakiController < Api::V1::BaseController
  # Skip authentication, meraki check his own secret.
  skip_before_action :authenticate_user_from_token!, :user_setup_api,
                     :force_format
  # Set meraki sensor
  before_action :set_meraki

  #
  # Return a devault Meraki value.
  #
  def index
    render text: @meraki.meraki_validator
  end

  private

  #
  # Set the sensor based on the secret. If the sensor doesn't existe, it will
  # return a 404
  #
  def set_meraki
    @meraki = Sensor
              .where(type: Sensor::MERAKI)
              .select { |s| s.meraki_secret == params[:secret] }
              .first
    return render nothing: true, status: 404 if @meraki.nil?
  end
end
