class GpsMarkersController < ApplicationController

  def new
    @gps_marker = GpsMarker.new
    @overlay_map_id = params[:overlay_map_id]
    render layout: false
  end

  def create
    overlay_map = OverlayMap.find(params[:gps_marker][:overlay_map_id])
    @gps_marker = overlay_map.gps_markers.build(gps_marker_params)
    @sensor = overlay_map.sensor

    respond_to do |format|
      if @gps_marker.save
        @gps_markers = overlay_map.gps_markers
        format.html { redirect_to view_sensor_path(@sensor), notice: "#{I18n.t('controllers.gps_created')}" }
        format.js { flash[:notice] = "#{I18n.t('controllers.gps_created')}" }
        format.json { head :no_content }
      else
        format.html { redirect_to view_sensor_path(@sensor), alert: @gps_marker.errors.full_messages.map { |msg| '<li>#{msg}</li>' }.join }
        format.js
        format.json { render json: @gps_marker.errors, status: :unprocessable_entity }
      end
    end
  end

  def update
    @gps_marker = GpsMarker.find(params[:id])
    @gps_marker.update(gps_marker_params)
  end

  def destroy
    @gps_marker_id = params[:id]
    GpsMarker.find(params[:id]).destroy
  end

  private

  def gps_marker_params
    params.require(:gps_marker)
      .permit(:latitude, :longitude, :overlay_map_id, :x, :y)
  end
end
