#######################################################################
# Copyright (c) 2014 ENEO Tecnologia S.L.
# This file is part of redBorder.
# redBorder is free software: you can redistribute it and/or modify
# it under the terms of the GNU Affero General Public License as published by
# the Free Software Foundation, either version 3 of the License, or
# (at your option) any later version.
# redBorder is distributed in the hope that it will be useful,
# but WITHOUT ANY WARRANTY; without even the implied warranty of
# MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
# GNU Affero General Public License for more details.
# You should have received a copy of the GNU Affero General Public License
# along with redBorder. If not, see <http://www.gnu.org/licenses/>.
#######################################################################

class GpsMarker < ApplicationRecord
  belongs_to :overlay_map
  validates :latitude, :longitude, presence: true

  after_create :calculate_matrix_position

  private

  def calculate_matrix_position
    return if overlay_map.gps_markers.count < 3
    
    sensor = overlay_map.sensor
    
    properties = sensor.property

    result = PrimeInfrastructure::Functions.overlay_data(
               [properties[:dimensions][:width], properties[:dimensions][:height]],
               overlay_map.gps_markers
             )

    properties[:coordinates] = result.except(:rotation)
    properties[:rotation] = result[:rotation]
    properties[:matrix_trans]  = result[:matrix_trans]
    properties[:matrix_offset] = result[:matrix_offset]
    
    sensor.update(property: properties)
  end
end
