#######################################################################
# Copyright (c) 2014 ENEO Tecnologia S.L.
# This file is part of redBorder.
# redBorder is free software: you can redistribute it and/or modify
# it under the terms of the GNU Affero General Public License as published by
# the Free Software Foundation, either version 3 of the License, or
# (at your option) any later version.
# redBorder is distributed in the hope that it will be useful,
# but WITHOUT ANY WARRANTY; without even the implied warranty of
# MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
# GNU Affero General Public License for more details.
# You should have received a copy of the GNU Affero General Public License
# along with redBorder. If not, see <http://www.gnu.org/licenses/>.
#######################################################################

#
# => Custom HTML widgets
#
class WidgetGraph::Bandwidth < WidgetGraph::Base
  widget_fields [:granularity, :serie_type]

  widget_before_save do
    self.granularity = WidgetGraph::Base::DEFAULT_GRANULARITY[range.to_sym]
  end

  widget_after_initialize do
    self.serie_type ||= 'line'
  end

  def as_json(opts = {})
    obj_opts = { methods: [:step, :tzoffset] }
    super(obj_opts.merge(opts))
  end

  def tzoffset
    return 0 if @widget.timezone.nil?

    if @widget.timezone.to_sym == :auto
      Time.zone.now.utc_offset * 1000
    else
      ActiveSupport::TimeZone[@widget.timezone].now.utc_offset * 1000
    end
  end

  def step
    if !@widget.granularity.nil?
      GRANULARITY_TYPE[@widget.granularity.to_sym][:step]
    else
      60_000
    end
  end
end
