#######################################################################
# Copyright (c) 2014 ENEO Tecnologia S.L.
# This file is part of redBorder.
# redBorder is free software: you can redistribute it and/or modify
# it under the terms of the GNU Affero General Public License as published by
# the Free Software Foundation, either version 3 of the License, or
# (at your option) any later version.
# redBorder is distributed in the hope that it will be useful,
# but WITHOUT ANY WARRANTY; without even the implied warranty of
# MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
# GNU Affero General Public License for more details.
# You should have received a copy of the GNU Affero General Public License
# along with redBorder. If not, see <http://www.gnu.org/licenses/>.
#######################################################################

#
# => Type for the channel load widget
#
class WidgetType::AccessPoints < WidgetType::Base
  graphs [:serie, :ball, :value, :box]
  filters true
  widget_fields [:range, :sensor_id]
  url '/sensors/view'

  widget_after_initialize do
    self.product_type = 'flow'
    self.aggregation = :wireless_stations
  end

  def total(user = @widget.parent.owner, options = {})
    filter = Redborder::Filter.new(ApState, {})
    options.merge!({
      start_time: start_time,
      end_time:   end_time,
      user:       user
    }) { |k, v1, v2| v1 }

    {
      total: ApState.aps_count(filter, options)
    }
  end

  def timeserie(user = @widget.parent.owner, options = {})
    filter = Redborder::Filter.new(ApState, {})
    options.merge!({
      start_time:  start_time,
      end_time:    end_time,
      granularity: @widget.granularity,
      user:        user,
      range:       @widget.range
    }) { |k, v1, v2| v1 }

    {
      timeserie: ApState.aps_serie(filter, options)
    }
  end
end