#######################################################################
# Copyright (c) 2014 ENEO Tecnologia S.L.
# This file is part of redBorder.
# redBorder is free software: you can redistribute it and/or modify
# it under the terms of the GNU Affero General Public License as published by
# the Free Software Foundation, either version 3 of the License, or
# (at your option) any later version.
# redBorder is distributed in the hope that it will be useful,
# but WITHOUT ANY WARRANTY; without even the implied warranty of
# MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
# GNU Affero General Public License for more details.
# You should have received a copy of the GNU Affero General Public License
# along with redBorder. If not, see <http://www.gnu.org/licenses/>.
#######################################################################

class WidgetType::Clients < WidgetType::Base
  graphs [:clients]
  create_default true

  widget_fields [:range, :aggregation]

  widget_validates :range, :aggregation, presence: true

  widget_after_initialize do
    # Only for clients
    self.range        ||= 'last_24'
    self.product_type   = 'flow'
    self.aggregation    = :clients
    self.filters      ||= "{\"0\":{\"column\":\"dot11_status\",\"operator\":\"is\",\"value\":\"ASSOCIATED\",\"enabled\":true}}"
  end
end
