#######################################################################
# Copyright (c) 2014 ENEO Tecnologia S.L.
# This file is part of redBorder.
# redBorder is free software: you can redistribute it and/or modify
# it under the terms of the GNU Affero General Public License as published by
# the Free Software Foundation, either version 3 of the License, or
# (at your option) any later version.
# redBorder is distributed in the hope that it will be useful,
# but WITHOUT ANY WARRANTY; without even the implied warranty of
# MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
# GNU Affero General Public License for more details.
# You should have received a copy of the GNU Affero General Public License
# along with redBorder. If not, see <http://www.gnu.org/licenses/>.
#######################################################################

class WidgetType::ClientsMap < WidgetType::Base
  graphs [:clients_map]

  widget_fields [:domain_id, :map_type, :cluster_aps, :aggregation, :force_max]

  widget_after_initialize do
    # Only for clients
    self.click_action   = 'none'
    self.range          = 'last_5_minute'
    self.product_type   = 'flow'
    self.domain_id    ||= 1
    self.map_type     ||= 'roads'
    self.aggregation  ||= 'bytes'
  end

  widget_before_save do
    user = User.find_by(id: self.parent.user_id)
    sensor = Sensor.find_by(id: self.domain_id)
    self.domain_id = user.sensor_id.to_s unless sensor && user.read_on?(sensor)
  end
end
