#######################################################################
# Copyright (c) 2014 ENEO Tecnologia S.L.
# This file is part of redBorder.
# redBorder is free software: you can redistribute it and/or modify
# it under the terms of the GNU Affero General Public License as published by
# the Free Software Foundation, either version 3 of the License, or
# (at your option) any later version.
# redBorder is distributed in the hope that it will be useful,
# but WITHOUT ANY WARRANTY; without even the implied warranty of
# MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
# GNU Affero General Public License for more details.
# You should have received a copy of the GNU Affero General Public License
# along with redBorder. If not, see <http://www.gnu.org/licenses/>.
#######################################################################

#
# => Type for the user experience widget
#
class WidgetType::UserExperience < WidgetType::Base
  graphs [:load]
  filters true
  widget_fields [:range]

  widget_after_initialize do
    self.product_type = 'flow'
    self.graph_type = 'load'
  end

  def load(user = @widget.parent.owner, options = {})
    serie = Traffic.where(
      query_type: :group_by,
      group_by: [:client_rssi],
      aggregation: :bps,
      user: user,
      range: @widget.range,
      start_time: options[:start_time] || start_time,
      end_time: options[:end_time] || end_time,
      granularity: :all,
      sort: :bps,
      search: @widget.fetch_filters
    )
    { load: serie.map{|s| { :client_rssi => s.client_rssi,
                            :bps => s.bps,
                            secondary_name: s.client_rssi }}}

  end
end