###############################################################################
# Copyright (c) 2014 ENEO Tecnologia S.L.
# This file is part of redBorder.
# redBorder is free software: you can redistribute it and/or modify
# it under the terms of the GNU Affero General Public License as published by
# the Free Software Foundation, either version 3 of the License, or
# (at your option) any later version.
# redBorder is distributed in the hope that it will be useful,
# but WITHOUT ANY WARRANTY; without even the implied warranty of
# MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
# GNU Affero General Public License for more details.
# You should have received a copy of the GNU Affero General Public License
# along with redBorder. If not, see <http://www.gnu.org/licenses/>.
###############################################################################

module RedBorder
  module ApplicationHelperFlow
    def self.included(base)
      
      base.send(:include, InstanceMethods)

      base.class_eval do
        unloadable
        alias_method_chain :more_options, :flow
        
      end
    end

    module InstanceMethods
      def more_options_with_flow(column, value)
        list = more_options_without_flow(column, value)
        
        if column.to_sym.eql?(:wireless_station)
          list += content_tag(:li) do
            link_to content_tag(:i, nil, class: 'fa fa-external-link') + 'Explore WS',
                    view_sensor_path(id: current_user.sensor_id, search: (value || 'N/A')),
                    method: :get
          end
        end

        list.html_safe
      end
    end
  end
end
