#######################################################################
# Copyright (c) 2014 ENEO Tecnologia S.L.
# This file is part of redBorder.
# redBorder is free software: you can redistribute it and/or modify
# it under the terms of the GNU Affero General Public License as published by
# the Free Software Foundation, either version 3 of the License, or
# (at your option) any later version.
# redBorder is distributed in the hope that it will be useful,
# but WITHOUT ANY WARRANTY; without even the implied warranty of
# MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
# GNU Affero General Public License for more details.
# You should have received a copy of the GNU Affero General Public License
# along with redBorder. If not, see <http://www.gnu.org/licenses/>.
#######################################################################

module RedBorder
  module DelayedJobFlow
    def self.included(base)
      base.extend(ClassMethods)
      base.send(:include, InstanceMethods)

      base.class_eval do
      end
    end

    module ClassMethods
      def mac_finder
        where('handler like ?',
              "%!ruby/struct:Redborder::Jobs::MacFinderJob%").first
      end

      def mac_finder?
        where('handler like ?',
              "%!ruby/struct:Redborder::Jobs::MacFinderJob%").present?
      end

      def assets_inventory
        where('handler like ?',
              "%!ruby/struct:Redborder::Jobs::AssetsInventoryJob%").first
      end

      def assets_inventory?
        where('handler like ?',
              "%!ruby/struct:Redborder::Jobs::AssetsInventoryJob%").present?
      end

      def zabbix_inventory_job
        where('handler like ?',
              "%!ruby/struct:Redborder::Jobs::ZabbixInventoryJob%").first
      end

      def zabbix_inventory_job?
        where('handler like ?',
              "%!ruby/struct:Redborder::Jobs::ZabbixInventoryJob%").present?
      end
    end

    module InstanceMethods
    end
  end
end

DelayedJob.send(:include, RedBorder::DelayedJobFlow)
