#######################################################################
# Copyright (c) 2014 ENEO Tecnologia S.L.
# This file is part of redBorder.
# redBorder is free software: you can redistribute it and/or modify
# it under the terms of the GNU Affero General Public License as published by
# the Free Software Foundation, either version 3 of the License, or
# (at your option) any later version.
# redBorder is distributed in the hope that it will be useful,
# but WITHOUT ANY WARRANTY; without even the implied warranty of
# MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
# GNU Affero General Public License for more details.
# You should have received a copy of the GNU Affero General Public License
# along with redBorder. If not, see <http://www.gnu.org/licenses/>.
#######################################################################

module RedBorder
  module JobsControllerFlow
    def self.included(base)
      base.class_eval do
        unloadable
      
        def start_mac_finder
          DelayedJob.mac_finder.destroy! if DelayedJob.mac_finder?
          Delayed::Job.enqueue(Redborder::Jobs::MacFinderJob.new(true), priority: 10, run_at: Time.now + 5.seconds)

          redirect_to jobs_path
        end

        def start_assets_inventory
          DelayedJob.assets_inventory.destroy! if DelayedJob.assets_inventory?
          Delayed::Job.enqueue(Redborder::Jobs::AssetsInventoryJob.new(true), priority: 10, run_at: Time.now + 5.seconds)

          redirect_to jobs_path
        end

        def start_zabbix_inventory_job
          DelayedJob.zabbix_inventory_job.destroy! if DelayedJob.zabbix_inventory_job?
          Delayed::Job.enqueue(Redborder::Jobs::ZabbixInventoryJob.new(true), priority: 10, run_at: Time.now + 5.seconds)

          redirect_to jobs_path
        end

      end
    end
  end
end
