#######################################################################
# Copyright (c) 2014 ENEO Tecnologia S.L.
# This file is part of redBorder.
# redBorder is free software: you can redistribute it and/or modify
# it under the terms of the GNU Affero General Public License as published by
# the Free Software Foundation, either version 3 of the License, or
# (at your option) any later version.
# redBorder is distributed in the hope that it will be useful,
# but WITHOUT ANY WARRANTY; without even the implied warranty of
# MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
# GNU Affero General Public License for more details.
# You should have received a copy of the GNU Affero General Public License
# along with redBorder. If not, see <http://www.gnu.org/licenses/>.
#######################################################################

namespace :redBorder do
  desc 'Pass uuid of flow sensors to its chef node'
  task :flow_uuids_to_chef => :environment do
    next unless Redborder::Module.registered_modules.include?(:flow)
    Sensor.where(type: [Sensor::FLOW, Sensor::MSE, Sensor::MERAKI, Sensor::ALE, Sensor::DEVICE]).each do |sensor|
      node = sensor.chef_node
      node.normal['redborder']['sensor_uuid'] = sensor.uuid
      node.save
    end

    puts 'All Flow sensor UUIDs has been syncronized with Chef.'

  end
end
