require 'test_helper'

class LicenseTest < ActiveSupport::TestCase
  context 'In Organization licensing mode' do
    setup do
      RedBorder.send(:remove_const, 'LICENSING_MODE')
      RedBorder::LICENSING_MODE = 'organization'
    end

    context 'an organization' do
      setup do
        @organization = sensors(:organization)
      end

      should 'return available flow licenses' do
        licenses = License.available_by_type('flow', @organization)
        assert_equal(licenses.count, 1)
      end
    end
  end

  context 'In Global licensing mode' do
    setup do
      RedBorder.send(:remove_const, 'LICENSING_MODE')
      RedBorder::LICENSING_MODE = 'global'
      @root = sensors(:root)
    end

    should 'return available flow licenses' do
      licenses = License.available_by_type('flow', @root)
      assert_equal(licenses.count, 1)
    end
  end
end
