require 'test_helper'

#
# Test Zone Model
#
class ZoneTest < ActiveSupport::TestCase
  context 'A Zone' do
    setup do
      @zone = zones(:zone1)
      @organization = sensors(:organization)
      @floor = sensors(:floor)
    end

    should 'have associated access_points' do
      assert_not @zone.access_points.empty?
    end

    should 'keep APs when changing parent domain to a current domain ancestor' do
      current_aps_ids = @zone.access_points.pluck(:id)
      @zone.update(sensor: @organization)
      assert current_aps_ids == @zone.access_points.pluck(:id)
    end

    should 'Release APs when changing parent domain to a current domain descendant' do
      @zone.update(sensor: @floor)
      assert @zone.access_points.empty?
    end
  end
end
