/*!    
 * Copyright (c) 2014 ENEO Tecnología S.L.
 * This file is part of redBorder.
 * redBorder is free software: you can redistribute it and/or modify
 * it under the terms of the GNU Affero General Public License as published by
 * the Free Software Foundation, either version 3 of the License, or
 * (at your option) any later version.
 * redBorder is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU Affero General Public License for more details.
 * You should have received a copy of the GNU Affero General Public License
 * along with redBorder. If not, see <http://www.gnu.org/licenses/>.
 */

var selected_rules = [];

function clear_selected_rules () {
  selected_rules = [];
  $('input#selected_rules').val('');
  return false;
}

function recheck_selected_rules () {
  $('input#selected_rules').val(selected_rules);
  $.each(selected_rules, function(index, value) {
    $('input.check_box_' + value).attr('checked', 'checked');
  });
}

$(document).on('change', '#event_filtering_modal input#rule_selector', function(){

  var rule_sid_gid = $(this).data('sid_gid');

  if ($(this).is(':checked')) {
          
    selected_rules.push(rule_sid_gid);
    $('input#selected_rules[type="hidden"]').val(selected_rules);
    
  } else {
    
    var removeItem = rule_sid_gid;
    selected_rules = jQuery.grep(selected_rules, function(value) {
      return value != removeItem;
    });
    
    $('input#selected_rules[type="hidden"]').val(selected_rules);

  };

});

$(document).on('shown', '#event_filtering_modal', function(){
  selected_rules = [];
})

$(document).on('keypress', "#new_event_filter input.search", function(e){
  
  if(e.which == 13){
    
    var policy_id = $(this).data('policy_id');
    var url = "/policies/"+ policy_id +"/event_filters/new";
    var msg = $(this).val();

    $.ajax({
      url: url,
      remote: true,
      type: 'GET',
      dataType: 'script',
      data: {
        msg: msg
      }
    });

    return false;

  }
});

$(document).bind('ajaxComplete', function(){
  
  $("input.source_autocomplete").autocomplete({
    appendTo: "#src_ul_autocomplete",
    source: function(request, response) {
      $.ajax({
        url: "/api/net_objects",
        dataType: "json",
        data: {
          featureClass: "P",
          style: "full",
          maxRows: 12,
          value: request.term,
        },
        success: function( data ) {
          response( $.map( data.objects, function( item ) {
            return {
              label: item.name + " (" + item.value + ")",
              value: item.value
            }
          }));
        }
      });
    },
    minLength: 2,
    open: function() {
      $( this ).removeClass( "ui-corner-all" ).addClass( "ui-corner-top" );
    },
    close: function() {
      $( this ).removeClass( "ui-corner-top" ).addClass( "ui-corner-all" );
    }
  });

  $("input.destination_autocomplete").autocomplete({
    appendTo: "#dst_ul_autocomplete",
    source: function(request, response) {
      $.ajax({
        url: "/api/net_objects",
        dataType: "json",
        data: {
          featureClass: "P",
          style: "full",
          maxRows: 12,
          value: request.term,
        },
        success: function( data ) {
          response( $.map( data.objects, function( item ) {
            return {
              label: item.name + " (" + item.value + ")",
              value: item.value
            }
          }));
        }
      });
    },
    minLength: 2,
    open: function() {
      $( this ).removeClass( "ui-corner-all" ).addClass( "ui-corner-top" );
    },
    close: function() {
      $( this ).removeClass( "ui-corner-top" ).addClass( "ui-corner-all" );
    }
  });

})