#######################################################################
# Copyright (c) 2014 ENEO Tecnologia S.L.
# This file is part of redBorder.
# redBorder is free software: you can redistribute it and/or modify
# it under the terms of the GNU Affero General Public License as published by
# the Free Software Foundation, either version 3 of the License, or
# (at your option) any later version.
# redBorder is distributed in the hope that it will be useful,
# but WITHOUT ANY WARRANTY; without even the implied warranty of
# MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
# GNU Affero General Public License for more details.
# You should have received a copy of the GNU Affero General Public License
# along with redBorder. If not, see <http://www.gnu.org/licenses/>.
#######################################################################

module PoliciesHelper

  def policy_options(policy, sensor=nil)
    content_tag :div, class: "btn-group" do

      list_1 = ""

      if policy.updating
        list_1 += link_to content_tag(:i, nil, class: "fa fa-spinner fa-spin"), "#", class: "btn disabled"
      else
        list_1 += link_to content_tag(:i, nil, class: "fa fa-list"), "#", class: "btn dropdown-toggle", "data-toggle" => "dropdown"
        list_1 += content_tag :ul, class: "dropdown-menu" do
          list_2 = ""

          if can? :manage, policy.owner
            list_2 += content_tag(:li, link_to("#{I18n.t('ips_helper.edit')}", edit_sensor_policy_path(policy.owner, policy), 'data-toggle' => "modal", 'data-target' => "#edit_policy_modal", "data-backdrop" => "static"))
          end

          if policy.update_available? and !policy.updating and can? :manage, policy.owner
            list_2 += content_tag(:li, link_to("#{I18n.t('ips_helper.update')}", update_rule_db_versions_policy_path(policy), method: :patch, data: { confirm: "#{I18n.t('ips_helper.confirm')}" }))
          end

          list_2 += if sensor
            content_tag(:li, content_tag(:a, "#{I18n.t('ips_helper.rules')}", href: sensor_policy_rules_path(sensor, policy)))
          else
            content_tag(:li, content_tag(:a, "#{I18n.t('ips_helper.rules')}", href: policy_rules_path(policy)))
          end

          if sensor and can? :manage, sensor
            list_2 += content_tag(:li, link_to("#{I18n.t('ips_helper.clone')}", clone_sensor_policy_path(sensor, policy), method: :post))
          end

          if sensor and current_user.can?(:manage, policy.owner) and policy.stored_policies.present?
            list_2 += content_tag(:li, link_to("#{I18n.t('ips_helper.snapshots')}", sensor_policy_snapshots_path(sensor, policy)))
          end

          list_2 += if sensor
            content_tag(:li, link_to("#{I18n.t('ips_helper.event_rules')}", sensor_policy_event_filters_path(sensor, policy)))
          else
            content_tag(:li, link_to("#{I18n.t('ips_helper.event_rules')}", policy_event_filters_path(policy)))
          end

          list_2.html_safe

        end
      end

      list_1.html_safe

    end
  end

end
