#######################################################################
# Copyright (c) 2014 ENEO Tecnologia S.L.
# This file is part of redBorder.
# redBorder is free software: you can redistribute it and/or modify
# it under the terms of the GNU Affero General Public License as published by
# the Free Software Foundation, either version 3 of the License, or
# (at your option) any later version.
# redBorder is distributed in the hope that it will be useful,
# but WITHOUT ANY WARRANTY; without even the implied warranty of
# MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
# GNU Affero General Public License for more details.
# You should have received a copy of the GNU Affero General Public License
# along with redBorder. If not, see <http://www.gnu.org/licenses/>.
#######################################################################

module RuleDbVersionsHelper

	def rule_db_version_options(rule_db_version_id)

		if RuleDbVersion.find(rule_db_version_id).is_deleted
			link_to image_tag("pager.gif"), "#", class: "btn disabled", onclick: "return false;"
		elsif !current_user.can?(:manage, RuleDbVersion.find(rule_db_version_id).rule_source.sensor) || !RuleDbVersion.find(rule_db_version_id).can_be_deleted?
			content_tag :a, content_tag(:i, nil, class: "fa fa-trash"), class: "btn disabled", href: "#", onclick: "return false;"
		else
			link_to content_tag(:i, nil, class: "fa fa-trash"), rule_db_version_path(rule_db_version_id), method: :delete, class: "btn", data: { confirm: "#{I18n.t('ips_helper.confirm2')}" }
		end

	end

end
