#######################################################################
# Copyright (c) 2014 ENEO Tecnologia S.L.
# This file is part of redBorder.
# redBorder is free software: you can redistribute it and/or modify
# it under the terms of the GNU Affero General Public License as published by
# the Free Software Foundation, either version 3 of the License, or
# (at your option) any later version.
# redBorder is distributed in the hope that it will be useful,
# but WITHOUT ANY WARRANTY; without even the implied warranty of
# MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
# GNU Affero General Public License for more details.
# You should have received a copy of the GNU Affero General Public License
# along with redBorder. If not, see <http://www.gnu.org/licenses/>.
#######################################################################

class PolicyRule < ApplicationRecord
  belongs_to :rule
  belongs_to :policy
  belongs_to :action
  belongs_to :user

  before_destroy :destroy_dependencies

  validates :policy_id, uniqueness: { scope: :rule_id }, presence: true

  protected

  def destroy_dependencies
    PolicyRule.where(dependency_rule_id: rule_id, policy_id: policy_id).destroy_all
  end
end
