#######################################################################
# Copyright (c) 2014 ENEO Tecnologia S.L.
# This file is part of redBorder.
# redBorder is free software: you can redistribute it and/or modify
# it under the terms of the GNU Affero General Public License as published by
# the Free Software Foundation, either version 3 of the License, or
# (at your option) any later version.
# redBorder is distributed in the hope that it will be useful,
# but WITHOUT ANY WARRANTY; without even the implied warranty of
# MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
# GNU Affero General Public License for more details.
# You should have received a copy of the GNU Affero General Public License
# along with redBorder. If not, see <http://www.gnu.org/licenses/>.
#######################################################################

class RuleNote < ApplicationRecord
  after_create :increment_note_count
  after_destroy :decrement_note_count

  belongs_to :user
  belongs_to :rule

  validates_presence_of :body

  private

  def increment_note_count
    user = User.find(user_id)
    user.increment(:notes_count)
    user.save
  end

  def decrement_note_count
    user = User.find(user_id)
    user.decrement(:notes_count)
    user.save
  end

end
