#######################################################################
# Copyright (c) 2014 ENEO Tecnologia S.L.
# This file is part of redBorder.
# redBorder is free software: you can redistribute it and/or modify
# it under the terms of the GNU Affero General Public License as published by
# the Free Software Foundation, either version 3 of the License, or
# (at your option) any later version.
# redBorder is distributed in the hope that it will be useful,
# but WITHOUT ANY WARRANTY; without even the implied warranty of
# MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
# GNU Affero General Public License for more details.
# You should have received a copy of the GNU Affero General Public License
# along with redBorder. If not, see <http://www.gnu.org/licenses/>.
#######################################################################

class AddSelectableToActions < ActiveRecord::Migration
  def up
    add_column :actions, :selectable, :boolean, default: true

    # Reset id sequence for actions
    result = execute('select id from actions order by id desc limit 1;')
    action_max_id = if result.first
                      result.first['id'].to_i
                    else
                      1
                    end
    execute("ALTER SEQUENCE actions_id_seq RESTART WITH #{action_max_id + 1}")
  end

  def down
    remove_column :actions, :selectable
  end
end
