#######################################################################
# Copyright (c) 2014 ENEO Tecnologia S.L.
# This file is part of redBorder.
# redBorder is free software: you can redistribute it and/or modify
# it under the terms of the GNU Affero General Public License as published by
# the Free Software Foundation, either version 3 of the License, or
# (at your option) any later version.
# redBorder is distributed in the hope that it will be useful,
# but WITHOUT ANY WARRANTY; without even the implied warranty of
# MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
# GNU Affero General Public License for more details.
# You should have received a copy of the GNU Affero General Public License
# along with redBorder. If not, see <http://www.gnu.org/licenses/>.
#######################################################################

module RedBorder
  module ApplicationControllerIPS
    def self.included(base)
      
      base.class_eval do
        unloadable        

        private

        def set_type_events
          :event
        end

        def default_chart_type_events
          session[:event][:chart_type][params[:action]] = if params[:action] == "index"
            params[:chart_type] or session[:event][:chart_type][params[:action]] or :streams
          elsif params[:action] == "tops"
            params[:chart_type] or session[:event][:chart_type][params[:action]] or :stacked
          else
            params[:chart_type] or session[:event][:chart_type][params[:action]] or :line
          end
        end

        def set_session_values_ips
          session[:event] ||= {filter: {}, active_tabs: (current_user.properties[:event][:tops] or []), active_cardinality_tabs: (current_user.properties[:event][:cardinality] or []), active_columns: (current_user.properties[:event][:index] or []), default_action: {controller: "events", action: "tops"}, chart_type: {}}
        end
      end
    end    
  end
end

