#######################################################################
# Copyright (c) 2014 ENEO Tecnologia S.L.
# This file is part of redBorder.
# redBorder is free software: you can redistribute it and/or modify
# it under the terms of the GNU Affero General Public License as published by
# the Free Software Foundation, either version 3 of the License, or
# (at your option) any later version.
# redBorder is distributed in the hope that it will be useful,
# but WITHOUT ANY WARRANTY; without even the implied warranty of
# MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
# GNU Affero General Public License for more details.
# You should have received a copy of the GNU Affero General Public License
# along with redBorder. If not, see <http://www.gnu.org/licenses/>.
#######################################################################

module RedBorder
  module DelayedJobIPS
    def self.included(base)
      base.extend(ClassMethods)
      base.send(:include, InstanceMethods)

      base.class_eval do
      end
    end

    module ClassMethods
      def rule_update
        self.where("handler like ?", "%!ruby/struct:Redborder::Jobs::RuleUpdatedbJob%").first
      end

      def apply_update
        self.where("handler like ?", "%!ruby/struct:Redborder::Jobs::ApplyUpdateJob%").first
      end
  
      def self.custom_rule_update
        self.where("handler like ?", "%!ruby/struct:Redborder::Jobs::CustomRuleUpdatedbJob%").first
      end

      def rule_update?
        self.where("handler like ?", "%!ruby/struct:Redborder::Jobs::RuleUpdatedbJob%").present?
      end

      def apply_update?
        self.where("handler like ?", "%!ruby/struct:Redborder::Jobs::ApplyUpdateJob%").present?
      end

      def self.custom_rule_update?
        self.where("handler like ?", "%!ruby/struct:Redborder::Jobs::CustomRuleUpdatedbJob%").present?
      end

      def force_rule_update
        if self.rule_update? and !self.rule_update.running?
          self.rule_update.destroy!
          RuleSource.where(is_custom: false, enable: true).update_all(updating: true)
          Delayed::Job.enqueue(Redborder::Jobs::RuleUpdatedbJob.new(User.current_user.id, true), priority: 10, run_at: Time.now + 5.seconds)
        elsif !self.rule_update?
          RuleSource.where(is_custom: false, enable: true).update_all(updating: true)
          Delayed::Job.enqueue(Redborder::Jobs::RuleUpdatedbJob.new(User.current_user.id, true), priority: 10, run_at: Time.now + 5.seconds)
        end
      end
    end

    module InstanceMethods
    end
  end
end

DelayedJob.send(:include, RedBorder::DelayedJobIPS)