#######################################################################
# Copyright (c) 2014 ENEO Tecnologia S.L.
# This file is part of redBorder.
# redBorder is free software: you can redistribute it and/or modify
# it under the terms of the GNU Affero General Public License as published by
# the Free Software Foundation, either version 3 of the License, or
# (at your option) any later version.
# redBorder is distributed in the hope that it will be useful,
# but WITHOUT ANY WARRANTY; without even the implied warranty of
# MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
# GNU Affero General Public License for more details.
# You should have received a copy of the GNU Affero General Public License
# along with redBorder. If not, see <http://www.gnu.org/licenses/>.
#######################################################################

module Redborder

  module Jobs

    class CustomRuleUpdatedbJob < Struct.new(:user_id, :source_id, :verbose)
      
      include Redborder::Jobs::JobHelper

      def perform
        source = RuleSource.find(source_id)
        content = Redborder::RulesUpdate.start(true, nil, source_id)
      rescue Exception => e
        logit "#{e}"
        content += "#{e}\n"
      ensure
        source.update(updating: false)
        source_name = source.clean_name
        stored_job = StoredDelayedJob.create(user_id: user_id, job: "CustomRuleUpdatedbJob", options: { humanize: source_name }, content: content)
      end

    end

  end

end