#######################################################################
# Copyright (c) 2014 ENEO Tecnologia S.L.
# This file is part of redBorder.
# redBorder is free software: you can redistribute it and/or modify
# it under the terms of the GNU Affero General Public License as published by
# the Free Software Foundation, either version 3 of the License, or
# (at your option) any later version.
# redBorder is distributed in the hope that it will be useful,
# but WITHOUT ANY WARRANTY; without even the implied warranty of
# MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
# GNU Affero General Public License for more details.
# You should have received a copy of the GNU Affero General Public License
# along with redBorder. If not, see <http://www.gnu.org/licenses/>.
#######################################################################

module Redborder

  module Jobs

    class SensorUpdateDbversionJob < Struct.new(:rule_db_version_id, :user_id, :verbose)

      include Redborder::Jobs::JobHelper

      def perform

        content = ""

        dbversion = RuleDbVersion.find(rule_db_version_id.to_i)

        content += "#{I18n.t 'jobs.updating_sensors'}\n"

        Sensor.update_all_dbversion(dbversion.id)

        dbversions = Sensor.current_dbversions

        if dbversions.size > 1 or (dbversions.size == 1 and dbversions.first != dbversion)
          content += "#{I18n.t 'jobs.not_all'}"
          DelayedJob.sensor_update_dbversion.destroy! if DelayedJob.sensor_update_dbversion?
          Delayed::Job.enqueue(Redborder::Jobs::SensorUpdateDbversionJob.new(rule_db_version_id, user_id, true), priority: 20, run_at: 5.seconds.from_now)
        else
          content += "#{I18n.t 'jobs.all_sensors'} #{rule_db_version_id}\n"
        end

      rescue Exception => e
        logit "#{e}"
        content += "#{e}\n"
      ensure
        StoredDelayedJob.create(job: "SensorUpdateDbversionJob", options: {rule_db_version_id: rule_db_version_id}, user_id: user_id, content: content)
      end

    end

  end

end
