#######################################################################
# Copyright (c) 2014 ENEO Tecnologia S.L.
# This file is part of redBorder.
# redBorder is free software: you can redistribute it and/or modify
# it under the terms of the GNU Affero General Public License as published by
# the Free Software Foundation, either version 3 of the License, or
# (at your option) any later version.
# redBorder is distributed in the hope that it will be useful,
# but WITHOUT ANY WARRANTY; without even the implied warranty of
# MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
# GNU Affero General Public License for more details.
# You should have received a copy of the GNU Affero General Public License
# along with redBorder. If not, see <http://www.gnu.org/licenses/>.
#######################################################################

namespace :redBorder do
  desc 'Pass uuid of IPS sensors to its chef role'
  task :ips_uuids_to_chef => :environment do
    next unless Redborder::Module.registered_modules.include?(:ips)
    Sensor.where(type: Sensor::IPS).each do |sensor|
      role = sensor.chef_role
      role.override_attributes['redborder']['sensor_uuid'] = sensor.uuid
      role.save
    end

    Sensor.where(type: Sensor::IPS_GROUP).each do |sensor|
      role = sensor.real_sensor_parent.chef_role
      role.override_attributes['redborder']['snort']['groups']["#{sensor.group_id}"]['group_uuid'] = sensor.uuid
      role.save
    end

    puts 'All IPS sensor UUIDs has been syncronized with Chef.'

  end

  task :create_file_capture_category => :environment do
    Category.find_or_create_by(name: 'file_capture', description: 'File Capture Rules')
  end
end
