#######################################################################
# Copyright (c) 2014 ENEO Tecnologia S.L.
# This file is part of redBorder.
# redBorder is free software: you can redistribute it and/or modify
# it under the terms of the GNU Affero General Public License as published by
# the Free Software Foundation, either version 3 of the License, or
# (at your option) any later version.
# redBorder is distributed in the hope that it will be useful,
# but WITHOUT ANY WARRANTY; without even the implied warranty of
# MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
# GNU Affero General Public License for more details.
# You should have received a copy of the GNU Affero General Public License
# along with redBorder. If not, see <http://www.gnu.org/licenses/>.
#######################################################################

module RedBorder
  module VlanObjectIPS
    
    def self.included(base)
      base.extend(ClassMethods)
      base.send(:include, InstanceMethods)

      base.class_eval do
        before_update :update_chef_values, if: (:name_changed? or :value_changed?)
      end
    end

    module ClassMethods
    end

    module InstanceMethods
      
      private

      def update_chef_values
        Sensor.where(type: Sensor::IPS).each do |sensor|
          role = sensor.chef_role
          sensor.all_children.select(&:is_sensor_binding?).each do |binding|
            if role.override_attributes["redborder"]["snort"]["groups"][binding.group_id.to_s]["bindings"][binding.binding_id.to_s]["vlan_objects"][self.id]
              role.override_attributes["redborder"]["snort"]["groups"][binding.group_id.to_s]["bindings"][binding.binding_id.to_s]["vlan_objects"][self.id] = {self.name => self.value}
            end
          end
          role.save
        end
      end
      
    end

  end
end

VlanObject.send(:include, RedBorder::VlanObjectIPS)