#######################################################################
# Copyright (c) 2014 ENEO Tecnologia S.L.
# This file is part of redBorder.
# redBorder is free software: you can redistribute it and/or modify
# it under the terms of the GNU Affero General Public License as published by
# the Free Software Foundation, either version 3 of the License, or
# (at your option) any later version.
# redBorder is distributed in the hope that it will be useful,
# but WITHOUT ANY WARRANTY; without even the implied warranty of
# MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
# GNU Affero General Public License for more details.
# You should have received a copy of the GNU Affero General Public License
# along with redBorder. If not, see <http://www.gnu.org/licenses/>.
#######################################################################

module RedBorder
  module WidgetIPS
    
    def self.included(base)
      base.extend(ClassMethods)
      base.send(:include, InstanceMethods)

      base.class_eval do
        validate :required_params_ips,
                 if: Proc.new { |w| w.product_type == 'ips' }
      end
    end

    module ClassMethods
    end

    module InstanceMethods
      private
        def print_filters_ips
          to_return = ''
          
          source = Redborder::DruidSource.get(source: 'ips')

          JSON.parse(filters).values.each do |v|
            to_return << "#{Event::COLUMN_NAMES[v['column'].to_sym]} \
                          #{v['operator']} \
                          #{source.data_column(v['column'], v['value'])}<br />"
          end

          to_return
        end

        def step_ips
          if granularity &&
             Redborder::Rbdruid.granularity_list(start_time: get_regular_start_time,
                                                 end_time: end_time).include?(granularity.to_sym)
            Redborder::Rbdruid::GRANULARITY_TYPE[granularity.to_sym][:step]
          else
            real_granularity =
              Redborder::Rbdruid.granularity_list(start_time: get_regular_start_time,
                                                  end_time: end_time).first
            Redborder::Rbdruid::GRANULARITY_TYPE[real_granularity.to_sym][:step]
          end
        end
    end
  end
end
