require 'test_helper'
require 'test/unit'
require 'mocha/test_unit'

#
# Check the sessions.
#
class ComparativeTest < ActionDispatch::IntegrationTest
  # To login users
  include Warden::Test::Helpers
  Warden.test_mode!

  context 'On IPS Comparative view' do
    # Get first user
    setup do
      @admin = users(:admin)
      # Login him
      login_as(@admin, scope: :user)
      # Mock
      client = DruidStub.new
      Druid::Client.stubs(:new).returns(client)
      Redborder::Statistics.stubs(:forecast).returns([])
    end

    should 'display it' do
      visit '/ips/comparative'
      code_200?
    end
  end
end
