require 'test_helper'

#
# Testing for RuleNote model. It should test validations, and basic operations
# like create and destroy.
#
class RuleNoteTest < ActiveSupport::TestCase
  should validate_presence_of(:body)
  should belong_to(:user)
  should belong_to(:rule)

  context 'a rule note' do
    setup do
      @rule_note = rule_notes(:note1)
      @rule = rules(:rule1)
      @super_admin = users(:admin)
      User.current_user = @super_admin
    end

    should 'increment note count after create' do
      assert_difference('@super_admin.reload.notes_count') do
        RuleNote.create(rule: @rule, user: @super_admin,
                        body: 'It is a wonderful text.')
      end
    end

    should 'decrement note count after destroy' do
      assert_difference('@super_admin.reload.notes_count', -1) do
        @rule_note.destroy
      end
    end
  end
end
