redBorder.widgets.graphs.movements = function (container, widget) {
  var $container = $('#' + container),
      wtype;

  // The widget manager calls this method when the graph should start
  function init(_wtype) {
    // Save wtype to use in reload
    wtype = _wtype;
  }

  function render(){
    wtype.getChord().then(draw);
  }

  // Draws the widget. This data comes directly from the widget
  // type selected. You should prepare the data to be used if needed.
  function draw(data) {
    $container.find("svg").remove();
    new RB.Chords({
      container: "#" + container,
      matrix: data.matrix,
      neighs: data.locations,
      size: Math.min($container.height(), $container.width())
    });
    $container.find("svg").css("margin", "0 auto");
    // Finish load
    redBorder.widgets.util.reloadDone($container.parents('.widget'));
  }

  function reload() {
    $container.find("svg").remove();
    render();
  }

  function resize() {
    var height = 0;
    if(widget.name.length !== 0){
      height += 43;
    }
    $container.css('height', ($container.parents('.widget').height() - height) + 'px');
    $container.css('width', ($container.parents('.widget').width()) + 'px');
    render();
  }

  // Hide the main element when resizing
  function hide() {
    var parent = $container.parent();
    parent.find('svg, .widget-secondary').fadeOut(100);
  }

  // Show the main element
  function show() {
    var parent = $container.parent();
    parent.find('svg, .widget-secondary').fadeIn(100);
  }

  // Returns the widget
  function getWidget() {
    return widget;
  }

  return {
    init: init,
    resize: resize,
    getWidget: getWidget,
    hide: hide,
    show: show,
    reload: reload,
    render: render
  };
};
