#######################################################################
# Copyright (c) 2014 ENEO Tecnologia S.L.
# This file is part of redBorder.
# redBorder is free software: you can redistribute it and/or modify
# it under the terms of the GNU Affero General Public License as published by
# the Free Software Foundation, either version 3 of the License, or
# (at your option) any later version.
# redBorder is distributed in the hope that it will be useful,
# but WITHOUT ANY WARRANTY; without even the implied warranty of
# MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
# GNU Affero General Public License for more details.
# You should have received a copy of the GNU Affero General Public License
# along with redBorder. If not, see <http://www.gnu.org/licenses/>.
#######################################################################

RedBorder::Application.routes.draw do
  resources :location, only: :index do
    member do
      get :load_tab
      get :load_tab_cardinality
      get :load_cardinality_table
    end
    collection do
      get :tops
      get :cardinality
      get :load_more_cardinality
      get :map
      get :movements_map
      get 'movements_map/get_client_latlong/:id', action: :get_client_latlong
      get :movements
      get :sessions
      get :weather
      get :comparative
      get :search
      post :store_tab
      post :store_chart_type
      post :store_status_tab
      post :store_client_profile
      get :load_more_comparative
      get :load_tab
      get :load_serie
      get 'tops/get_serie/:id', action: :get_serie
      get 'tops/get_tops/:id', action: :get_tops
      get :export_tops_to_csv 
      post "export_tops_to_file", action: :export_tops_to_file, as: :export_tops_to_file
      get :sort_aggregations
      patch 'tops/del_tab/:id',
            action: :del_tab, as: :del_traffics_top_tab
      get 'aggregations/reorder',
          to: 'location#reorder_aggregations', as: 'reorder_location_aggregations'
      get 'tops/add_tab/:id',
          action: :add_tab, as: :add_location_top_tab
      get 'cardinality/add_tab/:id',
          action: :add_cardinality_tab, as: :add_location_cardinality_tab
      get 'cardinality/get_serie/:id',
          action: :get_cardinality_serie, as: :get_location_cardinality_serie
      patch 'cardinality/del_tab/:id',
            action: :del_cardinality_tab, as: :del_location_cardinality_tab

    end
  end

  patch 'saved_location_filter/:id/add',
        to: 'saved_location_filters#add_saved_filter',
        as: 'add_saved_location_filter'
  post 'saved_location_filters/create',
       to: 'saved_location_filters#create'

  resources :saved_location_filters, path: '/saved/location_filters' do
    collection do
      post :title
    end

    member do
      get :view
      post :update
    end
  end
end
