#######################################################################
# Copyright (c) 2014 ENEO Tecnologia S.L.
# This file is part of redBorder.
# redBorder is free software: you can redistribute it and/or modify
# it under the terms of the GNU Affero General Public License as published by
# the Free Software Foundation, either version 3 of the License, or
# (at your option) any later version.
# redBorder is distributed in the hope that it will be useful,
# but WITHOUT ANY WARRANTY; without even the implied warranty of
# MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
# GNU Affero General Public License for more details.
# You should have received a copy of the GNU Affero General Public License
# along with redBorder. If not, see <http://www.gnu.org/licenses/>.
#######################################################################

module RedBorder
  module ApplicationControllerLocation
    def self.included(base)
      base.class_eval do

        private

        def set_type_location
          :location
        end

        def default_chart_type_location
          session[:location][:chart_type] =
            if params[:action] == 'index'
              params[:chart_type] || session[:location][:chart_type] || :streams
            elsif params[:action] == 'tops'
              params[:chart_type] || session[:location][:chart_type] || :area
            else
              params[:chart_type] || session[:location][:chart_type] || :line
            end
        end

        def set_session_values_location
          session[:location] ||= {
            filter: {},
            tab: :campus,
            active_tabs: [:campus_uuid, :building_uuid, :floor_uuid, :zone_uuid, :client_mac, :client_mac_vendor, :calendar_item_name, :dot11_status],
            active_cardinality_tabs: current_user.properties[:location][:cardinality] || [],
            active_columns: current_user.properties[:location][:index] || [],
            default_action: { controller: 'location', action: 'tops' },
            chart_type: :line,
            active_comparative_tabs: current_user.properties[:location][:comparative] || [:pt24h, :pt168h],
          }
        end

      end
    end
  end
end
