/*!
 * Copyright (c) 2014 ENEO Tecnología S.L.
 * This file is part of redBorder.
 * redBorder is free software: you can redistribute it and/or modify
 * it under the terms of the GNU Affero General Public License as published by
 * the Free Software Foundation, either version 3 of the License, or
 * (at your option) any later version.
 * redBorder is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU Affero General Public License for more details.
 * You should have received a copy of the GNU Affero General Public License
 * along with redBorder. If not, see <http://www.gnu.org/licenses/>.
 */

function alarm_product_type_monitor(element){
	var show = element.val(),
			data = $('#alarm_condition').val(),
			filters;

  if (data !== "") {
    filters = JSON.stringify({
      match_all: true,
      items: JSON.parse(data)
    });
  }

	$('#search .rules').html("");
	$('#alarm_condition').val("");

  // Monitor-specific inputs
  $('div[data-product]').hide();
  $('div[data-product] input').prop('disabled', true);
  $('div[data-product] select').prop('disabled', true);
  $('div[data-product=monitor]').show();
  $('div[data-product=monitor] input').prop('disabled', false);
  $('div[data-product=monitor] select').prop('disabled', false);

  $('div[data-product=monitor] #alarm_monitor_tab').trigger('change');

  sensors_html = Handlebars.templates['select']({
    name: "sensors-select",
    width: "100%",
    multiple: false,
    data: search_hash["monitor_sensors"]
  });

	rule = new SearchMonitor(search_hash);
  rule.searchUI({
    cssClass: "submit-search",
    buttonTitle: I18n.t('javascript.submit_filter')
  }, function() {
    if (filters === undefined) {
      rule.add();
      rule.add();
    } else {
      rule.build(filters);
      rule.add();rule.add();
    }
  });
}

$(document).on('change', '#alarm_monitor_tab', function () {
  var product_selected = $('#alarm-form-selector').val(),
      val = $(this).val(),
      unit = '';
  if (product_selected === "monitor") {
    if (redBorder.modules.monitor.tabs[val] !== undefined) {
      unit = redBorder.modules.monitor.tabs[val].units;
    } else {
      unit = '';
    }
  }
  updateUnitOptions(unit);
});
