redBorder.widgets.graphs.cluster_diagram = function (container, widget) {
  var $container = $('#' + container);

  // Entry point for the graph
  function init(wtype) {
  }

  function render(){
    getData();
  }

  function getData(){
    $.ajax({
      url: "/monitor/cluster_diagram/?w=true&container_id=" + $container.parents('.widget').data('widget-id'),
      type: 'GET',
      dataType: 'html'
    }).done(function (datos) {
      $container.html(datos);
    }).fail(function (datos) {
      // Forbidden!
      $container.html(datos.responseText);
      var margin = ($container.height()/2) - 20;
      $container.find('.manager-no-privileges').css('margin-top', margin + 'px');
    }).always(function () {
      redBorder.widgets.util.reloadDone($container.parents('.widget'));
    });
  }

  function reload() {
    getData();
  }

  function resize() {
    var height = (widget.name.length !== 0) ? 43 : 0;
    $container.css('height', ($container.parents('.widget').height() - height) + 'px');
  }

  // Hide the main element when resizing
  function hide() {

  }

  // Show the main element
  function show() {

  }

  // Returns the graph object for debug purposes
  function getGraph() {
    return undefined;
  }

  // Returns the widget
  function getWidget() {
    return widget;
  }

  return {
    init: init,
    resize: resize,
    getGraph: getGraph,
    getWidget: getWidget,
    hide: hide,
    show: show,
    reload: reload,
    render: render
  }
}
