#######################################################################
# Copyright (c) 2014 ENEO Tecnologia S.L.
# This file is part of redBorder.
# redBorder is free software: you can redistribute it and/or modify
# it under the terms of the GNU Affero General Public License as published by
# the Free Software Foundation, either version 3 of the License, or
# (at your option) any later version.
# redBorder is distributed in the hope that it will be useful,
# but WITHOUT ANY WARRANTY; without even the implied warranty of
# MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
# GNU Affero General Public License for more details.
# You should have received a copy of the GNU Affero General Public License
# along with redBorder. If not, see <http://www.gnu.org/licenses/>.
#######################################################################

class Api::V1::MonitorController < Api::V1::BaseController

    before_action :set_custom_tab, only: [:update]

    skip_before_action :authenticate_user!, only: [:get_bulkstats_columns], raise: false
    skip_before_action :authenticate_user_from_token!, only: [:get_bulkstats_columns]
    #before_action :validate_cert, only: :import

    #
    def index
    end

    def read_file(file_name)
      file = File.open(file_name, "r")
      data = file.read
      file.close
      return data
    end

    #
    def get_bulkstats_columns
        #compare the md5 with the one we have, if its different send
        file_path = "/share/bulkstats.tar.gz"

        # If file doesnt exists
        # we cannot send it
        return error_503("#{I18n.t 'file_serve'}") if !File.exist?(file_path)

        #Get the file
        send_file file_path
    end
end
