#######################################################################
# Copyright (c) 2014 ENEO Tecnologia S.L.
# This file is part of redBorder.
# redBorder is free software: you can redistribute it and/or modify
# it under the terms of the GNU Affero General Public License as published by
# the Free Software Foundation, either version 3 of the License, or
# (at your option) any later version.
# redBorder is distributed in the hope that it will be useful,
# but WITHOUT ANY WARRANTY; without even the implied warranty of
# MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
# GNU Affero General Public License for more details.
# You should have received a copy of the GNU Affero General Public License
# along with redBorder. If not, see <http://www.gnu.org/licenses/>.
#######################################################################

module MonitorCategoriesHelper
  def impact_bar(impact_percent)
    color, msg = if impact_percent <= 20
                   ['success', 'Very Low Impact']
                 elsif impact_percent <= 40
                   ['success', 'Low Impact']
                 elsif impact_percent <= 60
                   ['warning', 'Medium Impact']
                 elsif impact_percent <= 80
                   ['danger', 'High Impact']
                 else
                   ['danger', 'Very High Impact']
                 end

    content_tag :div, class: "progress margin-bm", 'data-toggle' => 'tooltip', title: msg do
      content_tag :div, nil, class: "bar progress-bar-#{color}", style: "width: #{impact_percent}%"
    end
  end
end
