###############################################################################
# Copyright (c) 2014 ENEO Tecnologia S.L.
# This file is part of redBorder.
# redBorder is free software: you can redistribute it and/or modify
# it under the terms of the GNU Affero General Public License as published by
# the Free Software Foundation, either version 3 of the License, or
# (at your option) any later version.
# redBorder is distributed in the hope that it will be useful,
# but WITHOUT ANY WARRANTY; without even the implied warranty of
# MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
# GNU Affero General Public License for more details.
# You should have received a copy of the GNU Affero General Public License
# along with redBorder. If not, see <http://www.gnu.org/licenses/>.
###############################################################################

module RedBorder
  module ApplicationControllerMonitor
    def self.included(base)
      
      base.class_eval do
        unloadable        

        private

        def set_type_monitor
          :monitor
        end

        def default_chart_type_monitor
          session[:monitor][:chart_type][params[:action]] = (params[:chart_type] or session[:monitor][:chart_type][params[:action]] or :line)
        end

        def set_session_values_monitor
          session[:monitor] ||= {filter: {}, active_tabs: (current_user.properties[:monitor][:tops] or []), chart_type: {}}
        end
      end
    end    
  end
end

