#######################################################################
# Copyright (c) 2014 ENEO Tecnologia S.L.
# This file is part of redBorder.
# redBorder is free software: you can redistribute it and/or modify
# it under the terms of the GNU Affero General Public License as published by
# the Free Software Foundation, either version 3 of the License, or
# (at your option) any later version.
# redBorder is distributed in the hope that it will be useful,
# but WITHOUT ANY WARRANTY; without even the implied warranty of
# MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
# GNU Affero General Public License for more details.
# You should have received a copy of the GNU Affero General Public License
# along with redBorder. If not, see <http://www.gnu.org/licenses/>.
#######################################################################

module RedBorder
    module DelayedJobMonitor
      def self.included(base)
        base.extend(ClassMethods)
        base.send(:include, InstanceMethods)
  
        base.class_eval do
        end
      end
  
      module ClassMethods
        def bulkstats_update
          self.where("handler like ?", "%!ruby/struct:Redborder::Jobs::BulkstatsUpdateJob%").first
        end

        def bulkstats_update?
          self.where("handler like ?", "%!ruby/struct:Redborder::Jobs::BulkstatsUpdateJob%").present?
        end
  
        def force_bulkstats_update
          if self.bulkstats_update? and !self.bulkstats_update.running?
            self.bulkstats_update.destroy!
            Delayed::Job.enqueue(Redborder::Jobs::BulkstatsUpdateJob.new(User.current_user.id, true), priority: 10, run_at: Time.now + 5.seconds)
          elsif !self.bulkstats_update?
            Delayed::Job.enqueue(Redborder::Jobs::BulkstatsUpdateJob.new(User.current_user.id, true), priority: 10, run_at: Time.now + 5.seconds)
          end
        end
      end
  
      module InstanceMethods
      end
    end
  end
  
  DelayedJob.send(:include, RedBorder::DelayedJobMonitor)