#######################################################################
# Copyright (c) 2014 ENEO Tecnologia S.L.
# This file is part of redBorder.
# redBorder is free software: you can redistribute it and/or modify
# it under the terms of the GNU Affero General Public License as published by
# the Free Software Foundation, either version 3 of the License, or
# (at your option) any later version.
# redBorder is distributed in the hope that it will be useful,
# but WITHOUT ANY WARRANTY; without even the implied warranty of
# MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
# GNU Affero General Public License for more details.
# You should have received a copy of the GNU Affero General Public License
# along with redBorder. If not, see <http://www.gnu.org/licenses/>.
#######################################################################

module Redborder

    module Jobs

      class BulkstatsUpdateJob < Struct.new(:user_id, :verbose)

        include Redborder::Jobs::JobHelper

        def wake_up_proxys
          proxys = Sensor.where(:type => Sensor::CLIENT_PROXY)
          proxys.each do | proxy |
            proxy.execute_rb_get_bulkstats_columns
          end
        end

        def perform

            content = ("#{I18n.t 'lib_monitor.node'}: " + `hostname`.chomp! + "\n\n")

            begin

              content += `sudo env BOOTUP=none /usr/lib/redborder/bin/rb_create_bulkstats_columns.sh -c`

            rescue Exception => e
              content += "#{e.class}: #{e.message}\n"
              e.backtrace.each do |line|
                content += "#{line}\n"
              end
              logit "#{e.class}: #{e.message}" if verbose
            ensure
              StoredDelayedJob.create(job: "BulkstatsUpdateJob", user_id: user_id, content: content)
              wake_up_proxys
            end

        end # end perform
    end # end class
  end # end module Jobs
end # module Redborder
