###############################################################################
# Copyright (c) 2014 ENEO Tecnologia S.L.
# This file is part of redBorder.
# redBorder is free software: you can redistribute it and/or modify
# it under the terms of the GNU Affero General Public License as published by
# the Free Software Foundation, either version 3 of the License, or
# (at your option) any later version.
# redBorder is distributed in the hope that it will be useful,
# but WITHOUT ANY WARRANTY; without even the implied warranty of
# MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
# GNU Affero General Public License for more details.
# You should have received a copy of the GNU Affero General Public License
# along with redBorder. If not, see <http://www.gnu.org/licenses/>.
###############################################################################

module RedBorder
  module SensorCategoryMonitor
    
    def self.included(base)
      base.extend(ClassMethods)
      base.send(:include, InstanceMethods)

      base.class_eval do
        has_and_belongs_to_many :monitor_categories
      end
    end

    module ClassMethods
    end

    module InstanceMethods
      def monitor_categories_to_chef
        #monitor_categories.flat_map(&:operation).as_json

        operation = []
        monitor_categories.each do |monitor | 
          monitor.operation = monitor.operation.is_a?(Hash) ? [monitor.operation] : monitor.operation
          monitor.operation.each do |oper|
            if oper["name"] == "bulkstats_schema"
              oper["bulkstats_schema"] = monitor.bulkstats_schema_path
              oper["bulkstats_schema_id"] = monitor.id
            end
            operation.push(oper)
          end
        end
        
        operation.as_json
      end

      def monitors_to_chef
        respond_to?("monitors_to_chef_#{type}") ? send("monitors_to_chef_#{type}") : nil
      end
    end
  end
end

Sensor.send(:include, RedBorder::SensorCategoryMonitor)
