require 'test_helper'
require 'test/unit'
require 'mocha/test_unit'

#
# Check the sessions.
#
class TopsTest < ActionDispatch::IntegrationTest
  # To login users
  include Warden::Test::Helpers
  Warden.test_mode!

  context 'On Scanner tops view' do
    # Get first user
    setup do
      @admin = users(:admin)
      # Login him
      login_as(@admin, scope: :user)
      # Mock
      client = DruidStub.new
      Druid::Client.stubs(:new).returns(client)
    end

    should 'display it' do
      visit '/scanner/tops'
      code_200?
    end

    should 'display general info table' do
      visit '/scanner/tops'
      code_200?
      # Check general info
      check_general_info_tops(page)
    end
  end
end
