#######################################################################
# Copyright (c) 2014 ENEO Tecnologia S.L.
# This file is part of redBorder.
# redBorder is free software: you can redistribute it and/or modify
# it under the terms of the GNU Affero General Public License as published by
# the Free Software Foundation, either version 3 of the License, or
# (at your option) any later version.
# redBorder is distributed in the hope that it will be useful,
# but WITHOUT ANY WARRANTY; without even the implied warranty of
# MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
# GNU Affero General Public License for more details.
# You should have received a copy of the GNU Affero General Public License
# along with redBorder. If not, see <http://www.gnu.org/licenses/>.
#######################################################################

not_activated = %w()

Redborder::Module.get(:vault, :columns).keys.each do |col|
  col = "vault_#{col}"
  value = not_activated.include?(col) ? '0' : '1'
  Setting.where(name: col).first_or_create(name: col, value: value)
end

# Default Alarms
user = User.find_by(login: 'admin', admin: true) or User.first
Alarm.find_or_create_by(name: "Security: New Machine on the Network detected by ArpWatch", condition: "{\"0\":{\"column\":\"app_name\",\"operator\":\"is\",\"value\":\"arpwatch\",\"enabled\":true},\"1\":{\"column\":\"message\",\"operator\":\"contains\",\"value\":\"new station\",\"enabled\":true}}", enabled: true, interval: 3600, product_type: "vault", upper_limit: 1, time_window: 600, upper_limit_enabled: true, user_id: user.id, timezone: "UTC", aggregation: "events", severity_id: 7, multiplier_upper: 0, notify_to_syslog: false, notify_to_email: true, notify_to_slack: false, email_list: user.email)
