require 'test_helper'
require 'test/unit'
require 'mocha/test_unit'

#
# Check the sessions.
#
class UniqueTest < ActionDispatch::IntegrationTest
  # To login users
  include Warden::Test::Helpers
  Warden.test_mode!

  context 'On Vault unique view' do
    # Get first user
    setup do
      @admin = users(:admin)
      # Login him
      login_as(@admin, scope: :user)
      # Mock
      client = DruidStub.new
      Druid::Client.stubs(:new).returns(client)
    end

    should 'display it' do
      visit '/vault/cardinality'
      code_200?
    end
  end
end
