#######################################################################
# Copyright (c) 2014 ENEO Tecnologia S.L.
# This file is part of redBorder.
# redBorder is free software: you can redistribute it and/or modify
# it under the terms of the GNU Affero General Public License as published by
# the Free Software Foundation, either version 3 of the License, or
# (at your option) any later version.
# redBorder is distributed in the hope that it will be useful,
# but WITHOUT ANY WARRANTY; without even the implied warranty of
# MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
# GNU Affero General Public License for more details.
# You should have received a copy of the GNU Affero General Public License
# along with redBorder. If not, see <http://www.gnu.org/licenses/>.
#######################################################################

module WirelessHelper
    def traffic_cast_num_with_span(count, aggregation_text)
      humanized_number, prefix =
        if count > 1e12
          [(count.to_f / 1e12).round(2), 'T']
        elsif count > 1e9
          [(count.to_f / 1e9).round(2), 'G']
        elsif count > 1e6
          [(count.to_f / 1e6).round(2), 'M']
        elsif count > 1e3
          [(count.to_f / 1e3).round(2), 'K']
        else
          [count, '']
        end
  
      content_html = content_tag :span do
        humanized_number.to_s + ' '
      end
  
      content_html + prefix + aggregation_text.to_s
    end
  
    def get_color_for_client_rssi(value)
      Rails.cache.fetch "rb-webui:client_rssi_color:#{value}" do
        client_rssi_num = YAML.load(File.read("#{Rails.root}/lib/modules/wireless/config/rssi_values.yml")).symbolize_keys
        client_rssi_num[value.to_sym]['color']
      end
    rescue
      '#4572A7'
    end
  end
  