#######################################################################
# Copyright (c) 2014 ENEO Tecnologia S.L.
# This file is part of redBorder.
# redBorder is free software: you can redistribute it and/or modify
# it under the terms of the GNU Affero General Public License as published by
# the Free Software Foundation, either version 3 of the License, or
# (at your option) any later version.
# redBorder is distributed in the hope that it will be useful,
# but WITHOUT ANY WARRANTY; without even the implied warranty of
# MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
# GNU Affero General Public License for more details.
# You should have received a copy of the GNU Affero General Public License
# along with redBorder. If not, see <http://www.gnu.org/licenses/>.
#######################################################################

module RedBorder
  module ApplicationControllerWireless
    def self.included(base)
      base.class_eval do
        unloadable

        private

        def set_type_wireless
          :wireless
        end

        def default_chart_type_wireless
          session[:wireless][:chart_type][params[:action]] = if params[:action] == 'index'
            params[:chart_type] || session[:wireless][:chart_type][params[:action]] || :streams
          elsif params[:action] == 'tops'
            params[:chart_type] || session[:wireless][:chart_type][params[:action]] || :area
          else
            params[:chart_type] || session[:wireless][:chart_type][params[:action]] || :line
          end
        end

        def set_session_values_wireless
          session[:wireless] ||= {
            filter: {},
            active_tabs: current_user.properties[:wireless][:tops] || [],
            active_cardinality_tabs: current_user.properties[:wireless][:cardinality] || [],
            active_columns: current_user.properties[:wireless][:index] || [],
            default_action: { controller: 'wireless', action: 'tops' },
            chart_type: {}
          }
        end
      end
    end
  end
end
