# #######################################################################
# # Copyright (c) 2014 ENEO Tecnologia S.L.
# # This file is part of redBorder.
# # redBorder is free software: you can redistribute it and/or modify
# # it under the terms of the GNU Affero General Public License as published by
# # the Free Software Foundation, either version 3 of the License, or
# # (at your option) any later version.
# # redBorder is distributed in the hope that it will be useful,
# # but WITHOUT ANY WARRANTY; without even the implied warranty of
# # MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
# # GNU Affero General Public License for more details.
# # You should have received a copy of the GNU Affero General Public License
# # along with redBorder. If not, see <http://www.gnu.org/licenses/>.
# #######################################################################

# module Redborder #:nodoc:
#   module As #:nodoc:
#     #
#     # Log aerospike queries
#     #
#     module Log
#       #
#       # Log an Aerospike query into the Rails logger
#       #
#       # == Parameters:
#       # query::
#       #   The query with the params to log
#       # type::
#       #   String with the name of the query
#       # start::
#       #   Time object with start time
#       # end_time::
#       #   Time object with end time
#       #
#       def log(query, type, start, finish)
#         info = log_color("Aerospike #{type} "\
#                          "(#{((finish - start) * 1000.0).round(2)}ms)")
#         Rails.logger.debug "#{info} #{query}"
#       end

#       #
#       # Log Aerospike put into Rails logger
#       #
#       # == Parameters:
#       # ns::
#       #   String with namespace
#       # set::
#       #   String with the set
#       # key::
#       #   String with the key
#       # bins::
#       #   Hash with stored values
#       #
#       def log_put(ns, set, key, bins)
#         info = log_color("Aerospike PUT [#{ns} - #{set}]")
#         Rails.logger.debug "#{info} #{key} -> #{bins}"
#       end

#       #
#       # Log Aerospike delete into Rails logger
#       #
#       # == Parameters:
#       # ns::
#       #   String with namespace
#       # set::
#       #   String with the set
#       # key::
#       #   String with the key
#       # bins::
#       #   Hash with stored values
#       #
#       def log_delete(ns, set, key)
#         info = log_color("Aerospike DELETE [#{ns} - #{set}]")
#         Rails.logger.debug "#{info} #{key}"
#       end

#       #
#       # Colorize the log :D
#       #
#       # == Parameters:
#       # str::
#       #   String to color
#       # 
#       # == Returns:
#       # Shell string with color
#       #
#       def log_color(str)
#         "\033[36m#{str}\033[0m"
#       end
#     end
#   end
# end
