# #######################################################################
# # Copyright (c) 2014 ENEO Tecnologia S.L.
# # This file is part of redBorder.
# # redBorder is free software: you can redistribute it and/or modify
# # it under the terms of the GNU Affero General Public License as published by
# # the Free Software Foundation, either version 3 of the License, or
# # (at your option) any later version.
# # redBorder is distributed in the hope that it will be useful,
# # but WITHOUT ANY WARRANTY; without even the implied warranty of
# # MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
# # GNU Affero General Public License for more details.
# # You should have received a copy of the GNU Affero General Public License
# # along with redBorder. If not, see <http://www.gnu.org/licenses/>.
# #######################################################################

# module Redborder #:nodoc:
#   module As #:nodoc:
#     #
#     # Perform queries to Aerospike usin Aerospike Gem
#     #
#     module Query
#       #
#       # Get the value associated into a key
#       #
#       # == Parameters:
#       # caller::
#       #   Class that has defined globals NAMESPACE, SET and ALLOWED_COLUMNS
#       # key::
#       #   The key identifies the row.
#       # to_close::
#       #   (optional) close the aerospike connection.
#       #
#       # == Returns:
#       # Self instance to return data with format
#       #
#       def get(caller, key, to_close = false)
#         ns, set, @allowed_columns = read_caller(caller)

#         # Get the key
#         real_key = Aerospike::Key.new(ns, set, key)
#         start = Time.now
#         @aero_result = connect.get(real_key).try(:bins)
#         close if to_close
#         log real_key, 'Get', start, Time.now
#         self
#       end

#       #
#       # Perform a Query to Aerospike and return the data as Array
#       #
#       # == Parameters:
#       # caller::
#       #   Class that has defined globals NAMESPACE, SET and ALLOWED_COLUMNS
#       # columns::
#       #   (optional) Array with the dimensions to return. If it's empty,
#       #   return all dimensions
#       # filters::
#       #   (optional) Array with Aerospike Filters
#       # to_close::
#       #   (optional) close the aerospike connection.
#       # cache::
#       #   (optional) Boolean indicates if cache the query
#       #
#       # == Return:
#       # Self instance to return data with format
#       #
#       def query(caller, columns = [], filters = [], to_close = false, cache = true)
#         ns, set, @allowed_columns = read_caller(caller)

#         # It will fail if there are a not allowed column
#         check_columns columns

#         stmt = Aerospike::Statement.new(ns, set, columns)
#         stmt.filters = filters unless filters.empty?

#         # Time before send the query
#         start = Time.now
#         @aero_result = cache_or_query(stmt, cache)
#         close if to_close
#         # Log it
#         log statement_id(stmt, false), 'Query', start, Time.now
#         self
#       end

#       #
#       # Store a new element in a set of Aerospike. We need to get the Key of
#       # this element.
#       #
#       # == Parameters:
#       # caller::
#       #   Class that has defined globals NAMESPACE, SET and ALLOWED_COLUMNS
#       # key::
#       #   String with the Key of the element
#       # bins::
#       #   Hash of Bins. For example:
#       #     bins = {
#       #                'bin1' => 'value1',
#       #                'bin2' => 2,
#       #                'bin4' => ['value4', {'map1' => 'map val'}],
#       #                'bin5' => {'value5' => [124, "string value"]},
#       #              }
#       #
#       def put(caller, key, bins)
#         ns, set, @allowed_columns = read_caller(caller)
#         # Get the key
#         as_key = Aerospike::Key.new(ns, set, key)
#         connect.put(as_key, bins)
#         # Log it
#         log_put ns, set, key, bins
#         self
#       end

#       #
#       # Check the existence of a key in Aerospike
#       #
#       # == Parameters:
#       # caller::
#       #   Class that has defined globals NAMESPACE, SET and ALLOWED_COLUMNS
#       # key::
#       #   String with the Key of the element
#       #
#       # == Returns:
#       # Boolean
#       #
#       def exists?(caller, key)
#         ns, set, @allowed_columns = read_caller(caller)
#         as_key = Aerospike::Key.new(ns, set, key)
#         connect.exists(as_key)
#       end

#       #
#       # Delete a key in Aerospike
#       #
#       # == Parameters:
#       # caller::
#       #   Class that has defined globals NAMESPACE, SET and ALLOWED_COLUMNS
#       # key::
#       #   String with the Key of the element
#       #
#       def delete(caller, key)
#         ns, set, @allowed_columns = read_caller(caller)
#         as_key = Aerospike::Key.new(ns, set, key)
#         connect.delete(as_key)
#         # Log it
#         log_delete ns, set, key
#         self
#       end
      
#       #
#       # Init base values from a caller class.
#       #
#       # == Parameters:
#       # caller::
#       #   Class that has defined globals NAMESPACE, SET and ALLOWED_COLUMNS
#       #
#       # == Returns:
#       # Array: [namespace, set, allowed_columns]
#       #
#       def read_caller(caller)
#         [caller.const_get('NAMESPACE'), caller.const_get('SET'),
#          caller.const_get('ALLOWED_COLUMNS')]
#       end

#       #
#       # Check if all columns is alled or fail
#       #
#       # == Parameters:
#       # columns::
#       #   Array of strings with columns
#       #
#       def check_columns(columns)
#         return unless (columns - @allowed_columns).size > 0
#         fail NameError, "There are a column in #{columns.join(', ')}; " \
#                         "that isn't allowd on #{@db} database. Allowed " \
#                         "columns are: #{@allowed_columns.join(', ')}"
#       end
#     end
#   end
# end
