module SamlAuthenticatable
  class SamlMappedAttributes
    def values_by_resource_key(key)
      str_key = String(key)

      # Find all of the SAML attributes that map to the resource key
      attribute_map_for_key = @attribute_map.select { |_, resource_key| String(resource_key) == str_key }

      saml_value = nil

      # Find the all non-nil value
      attribute_map_for_key.each_key do |saml_key|
        saml_value = values_by_saml_attribute_key(saml_key)

        break unless saml_value.nil?
      end

      saml_value
    end

    def values_by_saml_attribute_key(key)
      @attributes.attributes[String(key)]
    end
  end

  class SamlResponse
    def attribute_values_by_resource_key(key)
      attributes.values_by_resource_key(key)
    end
  end
end

module Devise
  module Strategies
    class SamlAuthenticatable
      def retrieve_resource
        @resource = mapping.to.authenticate_with_saml(@response, params[:RelayState])
        if @resource.nil?
          redirect!(Rails.application.routes.url_helpers.forbidden_path)
          # failed_auth("Resource could not be found") <-- The original code
        end
      end
    end
  end
end
