# #######################################################################
# # Copyright (c) 2014 ENEO Tecnologia S.L.
# # This file is part of redBorder.
# # redBorder is free software: you can redistribute it and/or modify
# # it under the terms of the GNU Affero General Public License as published by
# # the Free Software Foundation, either version 3 of the License, or
# # (at your option) any later version.
# # redBorder is distributed in the hope that it will be useful,
# # but WITHOUT ANY WARRANTY; without even the implied warranty of
# # MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
# # GNU Affero General Public License for more details.
# # You should have received a copy of the GNU Affero General Public License
# # along with redBorder. If not, see <http://www.gnu.org/licenses/>.
# #######################################################################
# module Redborder
#   #
#   # Drill class to connect Drill REST API
#   #
#   class Drill
#     # Exception when drill is not accesible
#     class DrillRequestError < StandardError; end

#     # Parameters for Aerospike connection
#     ALLOWED_COLUMNS = %w(hdfs_uuids hash)
#     SET = 'controlFiles'
#     NAMESPACE = 'malware'
#     MALWARE_MODE = Chef::Role.manager.override_attributes['redborder']['manager']["malware"]["mode"]
#     # Drill storage
#     STORAGE = MALWARE_MODE == 'logstash' ? 's3' : 'hdfs'
#     # Aerospike location column name
#     UUID = MALWARE_MODE == 'logstash' ? 's3_uuids' : 'hdfs_uuids'

#     # Initialize Drill
#     #
#     # @param aerospike [Redborder::As::Base] Aerospike connection object. It's
#     #   optional because some queries don't need to access aerospike
#     #
#     def initialize(aerospike = nil)
#       drill = YAML.load_file("#{Rails.root}/config/database.yml")['drill']
#       fail(DrillRequestError, 'No Drill Configuration') unless drill
#       begin
#         @uri =
#           URI.parse("http://#{drill['host']}:#{drill['port']}/#{drill['path']}")
#       rescue URI::InvalidURIError
#         raise DrillRequestError, 'Wrong Drill Configuration'
#       end
#       @http = Net::HTTP.new(@uri.host, @uri.port)
#       @aerospike = aerospike
#     end

#     # Query for the data of a Hash and loader. This get all data associated to
#     # this elements.
#     #
#     # @param hash [String] The Hash
#     # @param loader [String] The loader
#     # @return [Hash, nil] Data returned from HDFS
#     #
#     def query_hash(hash, loader)
#       # Build SQL query
#       sql_list = if loader
#                    build_loader_hash_query(hash, loader)
#                  else
#                    build_hash_query(hash)
#                  end
#       data = []
#       # Execute it
#       sql_list.each do |sql|
#         content = parse_hash_data(query(sql))
#         MALWARE_MODE == 'logstash' ? data << content : data << content.reject(&:blank?).present?
#       end
#       data
#     end

#     # Get data of an email
#     #
#     # @param email_id [String] Identifier of the email
#     # @return [Hash, nil] Data associated or nil
#     #
#     def query_email(email_id, time)
#       # TODO: Remove this tests
#       folder = folder_from_time(time)
#       sql = "SELECT * FROM #{STORAGE}.email.`#{folder}` WHERE "\
#             "email_id = '#{email_id}'"
#       # Execute query
#       result = query(sql)
#       result.present? ? JSON.parse(result) : nil
#     rescue JSON::ParserError
#       Rails.logger.error 'JSON Data malformed'
#       nil
#     end

#     # Get data of endpoint logs (bitacora)
#     #
#     # @param time [String] Identifier of the time
#     # @param uuid [String] Identifier of the endpoint
#     # @return [Hash, nil] Data associated or nil
#     #
#     def query_bitacora(uuid, datetime, selected_hour)
#       if selected_hour
#         folder = folder_from_time(datetime)
#         sql = "SELECT * FROM #{STORAGE}.log.`#{uuid}/hourly/#{folder}`"

#         # Execute query
#         query(sql)
#       else
#         hash = {}
#         0.upto(11) do |step|
#           folder = folder_from_time(datetime + step.hour)
#           sql = "SELECT * FROM #{STORAGE}.log.`#{uuid}/hourly/#{folder}`"
#           # Execute query per hour
#           content = query(sql)
#           hash[(datetime + step.hour).to_s] = JSON.parse(content) if content
#         end
#         hash.to_json
#       end
#     rescue JSON::ParserError
#       Rails.logger.error 'JSON Data malformed'
#       nil
#     end

#     #
#     # Queries Drill API Rest to obtain all data about a hash stored at HDFS
#     #
#     # @param sql [String] SQL to query DRILL
#     # @return [Hash, nil] Data returned from HDFS
#     #
#     def query(sql)
#       return if @uri.nil? || sql.nil?
#       # build request headers
#       request =
#         Net::HTTP::Post.new(@uri.path, 'Content-Type' => 'application/json')
#       # Logs SQL query
#       Rails.logger.debug('Drill SQL Query: ' + sql)
#       # build request body
#       request.body = {
#         queryType: 'SQL',
#         query: sql
#       }.to_json
#       # Send the data
#       result = send_request(request)
#       Rails.logger.debug('Drill ERROR: ' + result.body) if result &&
#                                                            result.code != '200'
#       (result.nil? || result.code != '200') ? nil : result.body
#     end

#     private

#     #
#     # Returns hash as parsed JSON data
#     #
#     # == Parameters:
#     # data::
#     #   JSON with all data info
#     #
#     # == Returns:
#     # Hash with all parsed data
#     #
#     def parse_hash_data(data)
#       return nil unless data
#       JSON.parse(data)['rows'].map do |el|
#         if MALWARE_MODE == 'logstash'
#           el.compact!                                                #Remove nil values
#           el.each do |key, value|
#             if value.instance_of? String and value.first =~ /[\[\{]/ #String starts with [ or {
#               value = JSON.parse(value)
#               el[key] = value
#             end
#           end
#         else
#           el['data'].nil? ? '' : JSON.parse(el['data'])
#         end
#         el
#       end
#     rescue JSON::ParserError
#       Rails.logger.error "JSON Data malformed: #{data}"
#       nil
#     end

#     # Get the folder of HDFS where the email headers will be stored
#     #
#     # @param time [Time] time of the event.
#     # @return [String] path of HDFS
#     #
#     def folder_from_time(time)
#       time.strftime('%Y/%m/%d/%H')
#     end

#     #
#     # Returns hash as parsed JSON data
#     #
#     # == Parameters:
#     # request::
#     #   request for Net HTTP
#     #
#     # == Returns:
#     # Response, nil if error
#     #
#     def send_request(request)
#       begin
#         @http.request(request)
#       rescue Timeout::Error, Errno::EINVAL, Errno::ECONNREFUSED,
#         Errno::ECONNRESET, EOFError, Net::HTTPBadResponse,
#         Net::HTTPHeaderSyntaxError, Net::ProtocolError, SocketError
#         return nil
#       end
#     end

#     # Queries Aerospike to get HDFS location with information of the hash
#     #
#     # @param [String] File hash
#     # @return [Array] Every path in HDFS containing hash data
#     #
#     def ask_aerospike(hash)
#       locations = @aerospike.get(self.class, hash).aero_result
#       return [] unless locations.try(:[], UUID).present? &&
#         locations[UUID].is_a?(Array)
#       locations[UUID].map { |loc| loc.delete(' ') }.uniq
#     end

#     # Builds SQL query for Drill REST API
#     #
#     # @param [String] File hash
#     # @return [String] full SQL query
#     #
#     def build_hash_query(hash)
#       return [] if (locations = ask_aerospike(hash)).empty?
#       Rails.logger.debug "#{MALWARE_MODE == 'logstash' ? "S3" : "HDFS"} location (By Aerospike): " + locations.join(', ')
#       query_list = []
#       locations.each do |loc|
#         query_list << "SELECT #{MALWARE_MODE == 'logstash' ? "* " : "data "}" \
#                       "FROM #{STORAGE}.#{table_name(loc)} WHERE sha256 = '#{hash}'"
#       end
#       query_list
#     end

#     # Builds SQL flatten query for Drill REST API
#     #
#     # == Parameters:
#     # hash::
#     #   Hash String
#     # loader::
#     #   Loader String to apply filter
#     #
#     # == Returns:
#     # String with full SQL query
#     #
#     def build_loader_hash_query(hash, loader)
#       return [] if (locations = ask_aerospike(hash)).empty?
#       Rails.logger.debug "#{MALWARE_MODE == 'logstash' ? "S3" : "HDFS"} location (By Aerospike): " + locations.join(', ')
#       query_list = []
#       locations.each do |loc|
#         if MALWARE_MODE == 'logstash'
#           query_list << "SELECT * from #{STORAGE}.#{table_name(loc)} WHERE loader = '#{loader}' and sha256 = '#{hash}'"
#         else
#           query_list << 'SELECT * from (select flatten(data) AS data FROM' \
#          " #{STORAGE}.#{table_name(loc)} WHERE sha256 = '#{hash}') t WHERE" \
#          " t.data.loader = '#{loader}' order by t.data.`timestamp` DESC"
#         end
#       end
#       query_list
#     end

#     # Obtain the name of a location for the SQL queries.
#     #
#     # == Parameters:
#     # location::
#     #   String
#     #
#     # == Returns:
#     # String with the folder name to SQL query (query by days, not hours)
#     #
#     def table_name(location)
#       if location.eql?('rt')
#         'realTime.`*`'
#       else
#         if folder = location.match(/(?<name>\d+\/\d+\/\d+\/)\d+/)
#           "historical.`#{folder[:name]}*`"
#         else
#           "historical.`#{location.delete(' ')}`"
#         end
#       end
#     end
#   end
# end
