#######################################################################
# Copyright (c) 2024 ENEO Tecnologia S.L.
# This file is part of redBorder.
# redBorder is free software: you can redistribute it and/or modify
# it under the terms of the GNU Affero General Public License as published by
# the Free Software Foundation, either version 3 of the License, or
# (at your option) any later version.
# redBorder is distributed in the hope that it will be useful,
# but WITHOUT ANY WARRANTY; without even the implied warranty of
# MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
# GNU Affero General Public License for more details.
# You should have received a copy of the GNU Affero General Public License
# along with redBorder. If not, see <http://www.gnu.org/licenses/>.
#######################################################################

module Redborder

    module Jobs
  
      class UpdateMitreJob < Struct.new(:verbose, :user_id)
  
        include Redborder::Jobs::JobHelper
  
        def perform
  
          content = ""
  
          begin
            matrix = JSON.parse `python /usr/lib/redborder/tools/mitre.py`
            Mitre.import_from_json matrix
            content += "Mitre matrix imported!"
          rescue Exception => e
            content += "#{e.class}: #{e.message}\n"
            e.backtrace.each do |line|
              content += "#{line}\n"
            end
            logit "#{e.class}: #{e.message}" if verbose
          ensure
            StoredDelayedJob.create(job: "UpdateMitreJob", user_id: user_id, content: content)
          
          end
  
        end
  
      end
  
    end
  
  end