#######################################################################
# Copyright (c) 2014 ENEO Tecnologia S.L.
# This file is part of redBorder.
# redBorder is free software: you can redistribute it and/or modify
# it under the terms of the GNU Affero General Public License as published by
# the Free Software Foundation, either version 3 of the License, or
# (at your option) any later version.
# redBorder is distributed in the hope that it will be useful,
# but WITHOUT ANY WARRANTY; without even the implied warranty of
# MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
# GNU Affero General Public License for more details.
# You should have received a copy of the GNU Affero General Public License
# along with redBorder. If not, see <http://www.gnu.org/licenses/>.
#######################################################################

module Redborder
  module ModulesHelper
    #
    # Return loaded modules
    #
    def loaded_modules(modules = [])
      # Iterate over registered modules
      Redborder::Module.registered_modules.each do |_, properties|
        modules << [properties[:name], properties[:path]]
      end

      modules
    end

    # Return the registered modules with alarms actives
    def loaded_modules_with_alarm(modules = [])
      # Get all the modules
      Redborder::Module.each_with_alarm do |id, properties|
        # Temporal, while implementing location alarms feature
        next if id == :location
        properties[:name] = (properties[:name].to_s.start_with? "tr.") ? (I18n.t properties[:name].to_s[3..-1]) : (properties[:name])
        modules << [properties[:name], properties[:path]]
      end
      #modules << ["HardwareInfo", "monitor"]
      modules
    end

    # Return the registered modules with UI like flow or ips.
    # For example, API hasn't interface. By default, interface_presence
    # are true.
    def loaded_modules_with_interface(modules = [])
      # Get all the modules
      Redborder::Module.each_with_interface do |id, properties|
        modules << [properties[:name], properties[:path]]
      end

      modules
    end
  end
end
