#######################################################################
# Copyright (c) 2014 ENEO Tecnologia S.L.
# This file is part of redBorder.
# redBorder is free software: you can redistribute it and/or modify
# it under the terms of the GNU Affero General Public License as published by
# the Free Software Foundation, either version 3 of the License, or
# (at your option) any later version.
# redBorder is distributed in the hope that it will be useful,
# but WITHOUT ANY WARRANTY; without even the implied warranty of
# MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
# GNU Affero General Public License for more details.
# You should have received a copy of the GNU Affero General Public License
# along with redBorder. If not, see <http://www.gnu.org/licenses/>.
#######################################################################

module Redborder
  #
  # Helper functions to work with namespaces
  #
  module Namespaces
    #
    # Get the name of the namespace based on the data source
    #
    # == Parameters:
    # data_source::
    #   String with the name of the data source
    #
    # == Returns:
    # Name of the namespace
    #
    def namespace_name(name)
      match = /rb_(.*_post|[^_]*)_(.*)/.match(name)
      return 'default' unless match && match[match.size - 1] != 'post'
      match[match.size - 1]
    end
  end
end
