#######################################################################
# Copyright (c) 2014 ENEO Tecnologia S.L.
# This file is part of redBorder.
# redBorder is free software: you can redistribute it and/or modify
# it under the terms of the GNU Affero General Public License as published by
# the Free Software Foundation, either version 3 of the License, or
# (at your option) any later version.
# redBorder is distributed in the hope that it will be useful,
# but WITHOUT ANY WARRANTY; without even the implied warranty of
# MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
# GNU Affero General Public License for more details.
# You should have received a copy of the GNU Affero General Public License
# along with redBorder. If not, see <http://www.gnu.org/licenses/>.
#######################################################################

module Redborder
  #
  # Contains multiple class methods of regex.
  #
  class Regex
    # IPV4 Regex
    IPV4 = %r{\A(#{Resolv::IPv4::Regex256})\.
                (#{Resolv::IPv4::Regex256})\.
                (#{Resolv::IPv4::Regex256})\.
                (#{Resolv::IPv4::Regex256})\z}x
    # HASH regex
    HASH = /^\w+$/

    #
    # Check if the given String is an IPV4
    #
    # == Parameters:
    # str::
    #   String to check if it's an IP
    #
    # == Returns:
    # Boolean
    def self.ipv4?(str)
      str.match(IPV4) != nil
    end

    #
    # Check if the given String is an Hash
    #
    # == Parameters:
    # str::
    #   String to check if it's a hash
    #
    # == Returns:
    # Boolean
    def self.hash?(str)
      str.match(HASH) != nil
    end
  end
end
