# #######################################################################
# # Copyright (c) 2014 ENEO Tecnologia S.L.
# # This file is part of redBorder.
# # redBorder is free software: you can redistribute it and/or modify
# # it under the terms of the GNU Affero General Public License as published by
# # the Free Software Foundation, either version 3 of the License, or
# # (at your option) any later version.
# # redBorder is distributed in the hope that it will be useful,
# # but WITHOUT ANY WARRANTY; without even the implied warranty of
# # MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
# # GNU Affero General Public License for more details.
# # You should have received a copy of the GNU Affero General Public License
# # along with redBorder. If not, see <http://www.gnu.org/licenses/>.
# #######################################################################

# require 'rinruby'

# module Redborder
#   class Statistics
#     # Pool of RinRuby instances
#     @instances = []
#     @mutex = Mutex.new

#     # How much data should it get from druid to predict
#     # end_predicted_time - start_predicted_time
#     def self.predict_from(time_diff)
#       if time_diff < 3600
#         Time.now - 72.hours
#       elsif time_diff < 86_400
#         Time.now - 168.hours
#       elsif time_diff < 604_800
#         Time.now - 336.hours
#       elsif time_diff < 2_592_000
#         Time.now - 504.hours
#       elsif time_diff < 7_776_000
#         Time.now - 2_160.hours
#       elsif time_diff < 31_104_000
#         Time.now - 8_640.hours
#       else
#         Time.now - 10_000.hours
#       end
#     end

#     def self.forecast_query(options = {})
#       # Select interval to query
#       predict_interval = options[:end_time] - options[:start_time]
#       start_time = predict_from predict_interval
#       end_time = Time.now

#       # Save those in options
#       options[:base_start_time] = start_time
#       options[:base_end_time] = end_time

#       data_source = RedBorder::DRUID_CONFIG[options[:controller]]['datasource']
#       query = Rbdruid.get_clients[options[:controller]].query data_source
#       query.interval(start_time, end_time)
#       Rbdruid.set_granularity(query, options[:granularity], options)
#       query.instance_eval{@properties}[:filter] = options[:filters]
#       query.query_type('timeseries')
#       if options[:monitor_tab].present?
#         query.instance_eval{@properties}[:postAggregations] = Rbdruid::AGGREGATIONS[:monitors][:post_aggregations]
#       end
#       query.instance_eval{@properties}[:context] = {}
#       query.instance_eval{@properties}[:context][:timeout] = 30_000

#       sum = Rbdruid.set_aggregation(options[:aggregation])
#       if options[:monitor_tab].present?
#         query.instance_eval{@properties }[:context]['skipEmptyBuckets'] = 'true'
#       end

#       if options[:cardinality_forecast].present?
#         query.instance_eval{@properties}[:aggregations] = [{type: 'cardinality', name: 'result', fieldNames: [options[:cardinality_column]]}]
#       elsif !sum.is_a?(Array) && Rbdruid::AGGREGATIONS[sum.to_sym][:aggregations].present?
#         query.instance_eval{@properties}[:aggregations] = (Rbdruid::AGGREGATIONS[sum.to_sym][:timeserie_aggregations] || Rbdruid::AGGREGATIONS[sum.to_sym][:aggregations])
#       end

#       query
#     end

#     def self.forecast_r(query, options = {})
#       r = instance_from_pool
#       period = query.instance_eval{@properties}[:granularity][:period]
#       broker = query.instance_eval{@client}.instance_eval{@zk}
#                 .instance_eval{@brokers}[0][:uri]

#       begin
#         r.query = query.to_json
#         r.period = period
#         r.t0toPredict = options[:start_time].to_i
#         r.tftoPredict = options[:end_time].to_i
#         r.start_time = options[:base_start_time].to_i
#         r.end_time = options[:base_end_time].to_i
#         r.percentage = options[:percentage].to_i
#         r.broker = broker
#         r.intervals = 0
#         r.column = 'average' if options[:monitor_tab].present?

#         r.eval 'forecast=forecasting(query,period,t0toPredict,' \
#                'tftoPredict,start_time,end_time,percentage,broker,intervals,column)'

#         forecast = r.pull 'forecast'
#       rescue StandardError => e
#         Rails.logger.error "ERROR RinRuby: #{e}"
#       ensure
#         r.eval 'rm(list = setdiff(ls(), lsf.str()))'
#         return_to_pool r
#       end

#       Rails.logger.info "  Forecast R args -> period: #{period}," \
#         " t0toPredict: #{options[:start_time]}" \
#         " (#{options[:start_time].try(:to_i)})," \
#         " tftoPredict: #{options[:end_time]}" \
#         " (#{options[:end_time].try(:to_i)})," \
#         " start_time: #{options[:base_start_time]}" \
#         " (#{options[:base_start_time].try(:to_i)})," \
#         " end_time: #{options[:base_end_time]}" \
#         " (#{options[:base_start_time].try(:to_i)}),"\
#         " percentage: #{options[:percentage]}," \
#         " broker: #{broker}, intervals: 0"

#       Rails.logger.info "  Forecast Druid Query #{query.to_json}"

#       forecast
#     end

#     def self.outlier_r(query, aggregation)
#       x = instance_from_pool
#       broker = query.instance_eval{@client}.instance_eval{@zk}
#           .instance_eval{@brokers}[0][:uri]

#       begin
#         x.query = query.to_json
#         x.broker = broker
#         x.aggregation_type = aggregation.to_s
#         x.eval 'outlier=outlierDetection(query,broker,aggregation_type)'
#         outlier = x.pull 'outlier'
#       rescue StandardError => e
#         outlier = "[]"
#         Rails.logger.error "ERROR RinRuby: #{e}"
#       ensure
#         x.eval 'rm(list = setdiff(ls(), lsf.str()))'
#         return_to_pool x
#       end

#       begin
#         Rails.logger.info "  Outlier Druid Query #{query.to_json}"
#         JSON.parse outlier
#       rescue StandardError => e
#         Rails.logger.error "ERROR RinRuby: #{outlier}"
#         outlier
#       end
#     end

#     def self.percentage(options = {})
#       monitor_tab = options[:monitor_tab]
#       is_monitor_present = monitor_tab.present?

#       if is_monitor_present
#         monitor_tab = SensorMonitor::TABS[monitor_tab.to_sym]
#         is_percentage_tab = monitor_tab.present? ? monitor_tab[:percentage] : false      
#         percentage = is_percentage_tab ? 1 : 0
#       else
#         percentage = 0
#       end

#       percentage
#     end

#     def self.forecast(options = {})
#       result_predicted = []

#       # Build the query and call R
#       query = forecast_query options

#       # Is a percentage?
#       options[:percentage] = percentage options

#       # Do the forecast with R
#       forecast = forecast_r query, options

#       begin
#         if !forecast || forecast == 0
#           result_predicted = []
#         else
#           result_predicted = JSON.parse forecast

#           if options[:cardinality_forecast].present?
#             result_predicted = result_predicted.map do |x|
#               {
#                 'result' => x['result']['events'].to_i,
#                 'timestamp' => x['timestamp']
#               }
#             end
#           elsif options[:aggregation].to_s == 'monitors'
#             result_predicted = result_predicted.map do |x|
#               {
#                 'average' => x['result']['events'].to_f,
#                 'timestamp' => x['timestamp']
#               }
#             end
#           else
#             result_predicted = result_predicted.map do |x|
#               {
#                 options[:aggregation].to_s => x['result']['events'].to_i,
#                 'timestamp' => x['timestamp']
#               }
#             end
#           end

#           result_predicted[1..-1]
#         end
#       rescue StandardError => e
#         Rails.logger.error "ERROR RinRuby: #{e}"
#         []
#       end
#     end

#     def self.instance_from_pool
#       @mutex.synchronize do
#         if @instances.empty?
#           Rails.logger.info 'RinRuby: New instance'
#           return RinRuby.new(false)
#         else
#           instance = @instances.pop
#           Rails.logger.info 'RinRuby: Got instance from the pool.' \
#                             " #{@instances.length} left."
#           instance
#         end
#       end
#     end

#     def self.return_to_pool(instance)
#       @mutex.synchronize do
#         @instances << instance
#         Rails.logger.info 'RinRuby: Instance returned to the pool.' \
#                           " #{@instances.length} instances in the pool."
#       end
#     end
#   end
# end
