require 'test_helper'

#
# Test alerts controller
#
class AlarmsControllerTest < ActionController::TestCase
  include Warden::Test::Helpers
  Warden.test_mode!

  context 'an user' do
    setup do
      @user = users(:admin_domain)
      sign_in @user

      @user_2 = users(:admin)
    end

    should 'delete his alarms' do
      assert_difference 'Alarm.count', -1 do
        delete :destroy, id: @user.alarms.first
      end
    end

    should 'not delete other user\'s alarms' do
      assert_no_difference 'Alarm.count' do
        delete :destroy, id: @user_2.alarms.first
      end
    end
  end

  context 'a super admin user' do
    setup do
      @user = users(:admin)
      sign_in @user

      @user_2 = users(:admin_domain)
    end

    should 'delete other user\'s alarms' do
      assert_difference 'Alarm.count', -1 do
        delete :destroy, id: @user_2.alarms.first
      end
    end
  end
end
