require 'test_helper'

class NotificationsControllerTest < ActionController::TestCase
  include Warden::Test::Helpers
  Warden.test_mode!
  include Devise::TestHelpers


  context 'An user' do
    setup do
      @user = users(:admin)
      sign_in @user
    end

    should 'delete its own notification' do
      notification = Notification.find_by(user: @user)

      assert_difference 'Notification.count', -1 do
        delete :destroy, id: notification.id
      end
    end

    should 'delete all his notifications' do
      notifications_difference = @user.notifications.count * -1

      assert_difference 'Notification.count', notifications_difference do
        delete :destroy, id: 'all'
      end
    end

    should 'not delete other\'s notification' do
      other_user = users(:admin_domain)
      notification = Notification.find_by(user: other_user)

      assert_no_difference 'Notification.count' do
        delete :destroy, id: notification.id
        assert_response :not_found
      end
    end
  end
end
