require 'test_helper'

#
# Check the sessions.
#
class FastSearchTest < ActionDispatch::IntegrationTest
  # To login users
  include Warden::Test::Helpers
  Warden.test_mode!

  context 'an user' do
    # Get first user
    setup do
      @admin = users(:admin)
      # Login him
      login_as(@admin, scope: :user)
      # Stub
      client = DruidStub.new
      Druid::Client.stubs(:new).returns(client)
      Redborder::Statistics.stubs(:forecast).returns([])
      chef = ChefStub.new
      Chef::Node.stubs(:load).returns(chef)
      Chef::Role.stubs(:load).returns(chef)
      Chef::Role.stubs(:from_hash).returns(chef)
    end

    should 'perform a fast search in sensors view' do
      visit '/sensors/tree'
      page.find('#top-navigation #nav-actions .nav-fast-search > a').click
      within('#fast_search_form') do
        fill_in 'fast_search', with: '10.0.0.0'
      end
      click_hidden_button('#nav-actions .nav-fast-search input[type="submit"]')
      wait_for_ajax(page)
      page.save_screenshot('shots/search.png')
      assert_equal(results_path, page.current_path,
                   'User must be redirected to result page.')
    end
  end
end
