require 'test_helper'

#
# This test check if the UI skin is correct applied to the branch.
# In this case, redBorder theme must be applied, so we check some changes.
#
class ThemesTest < ActionDispatch::IntegrationTest
  # To login users
  include Warden::Test::Helpers
  Warden.test_mode!

  context 'theme of redBorder' do
    # Login admin
    setup do
      @user = users(:admin)
      # Login him
      login_as(@user, scope: :user)
    end

    should 'have the correct footer' do
      visit '/users'
      footer = page.find('footer .container .hidden-phone').text
      # Check it
      assert_match(/redBorder/, footer,
                   'The footer must include redBorder on this theme')
    end
  end
end
