require 'test_helper'
require 'test/unit'
require 'mocha/test_unit'

class CheckAlarmsJobTest < ActiveSupport::TestCase
  include Warden::Test::Helpers
  Warden.test_mode!

  context 'CheckAlarmsJobs' do
    setup do
      client = DruidStub.new
      Druid::Client.stubs(:new).returns(client)
    end

    should 'check the alarms' do
      future = Redborder::Jobs::CheckAlarmsJob.new(true).perform
      # Assert that a new job has been enqueued for the future
      assert(future.is_a?(Delayed::Backend::ActiveRecord::Job), 'The return value is not a DelayedJob')
      assert(future.run_at > Time.now, 'The job is not enqueued for the future')
    end
  end
end
