require 'test_helper'

#
# As is a library to perform queries to Aerospike. We need to format results.
#
class Redborder::As::FormatTest < ActiveSupport::TestCase
  #
  # Order an Aerospike response
  #
  context 'An Aerospike response' do
    setup do
      # Main class
      @as = Redborder::As::Base.new
      # Stub data
      @data_mocked = [
        { 'test_column' => 0 },
        { 'test_column' => 2 },
        { 'test_column' => 3 },
        { 'test_column' => 1 }
      ]
      asmock = AerospikeClientStub.new(@data_mocked)
      # Aerospike stub
      Aerospike::Client.stubs(:new).returns(asmock)
    end

    should 'be formatted on raw' do
      # Apply the order
      res = @as.get(AerospikeTestQuery, 'test_key').raw
      assert_equal(@data_mocked, res,
                   'Expected The result will be formatted on RAW')
    end
  end
end
