require 'test_helper'

#
# As is a library to perform queries to Aerospike. We need to order results.
#
class Redborder::As::OrderTest < ActiveSupport::TestCase
  #
  # Order an Aerospike response
  #
  context 'An Aerospike response' do
    setup do
      # Main class
      @as = Redborder::As::Base.new
      # Stub data
      @result = [
        { 'test_column' => 0 },
        { 'test_column' => 2 },
        { 'test_column' => 3 },
        { 'test_column' => 1 }
      ]
      # Ordenations
      @asc = [*0..3]
      @desc = @asc.reverse
    end

    should 'Order by test_column ascendant' do
      # Apply the order
      @as.order('test_column', :asc)
      ordered = @as.perform_order(@result).map { |el| el['test_column'] }

      assert_equal(@asc, ordered,
                   "Expected ascendant order, we get: #{ordered}")
    end

    should 'Order by test_column descendant' do
      # Apply the order
      @as.order('test_column', :desc)
      ordered = @as.perform_order(@result).map { |el| el['test_column'] }

      assert_equal(@desc, ordered,
                   "Expected descendant order, we get: #{ordered}")
    end
  end
end
