#
# This class is a Stub of Chef. It's ignore all properties and return always
# 'chef_value'
#
class ChefStub
  # Mocked attributes
  attr_accessor :set, :normal, :override_attributes

  def initialize
    @set = {}
    @set['redborder'] = {}
    @normal = {}
    @normal['redborder'] = {}
    @override_attributes = {}
    @override_attributes['redborder'] = {}
    @override_attributes['redborder']['snort'] = {}
    @override_attributes['redborder']['snort']['default'] = {}
    @override_attributes['redborder']['snort']['default']['ipvars'] = {}
    @override_attributes['redborder']['snort']['default']['portvars'] = {}
    @override_attributes['redborder']['snort']['groups'] = {}
    @override_attributes['redborder']['snort']['groups']['0'] = {}
    @override_attributes['redborder']['snort']['groups']['0']['bindings'] = {}
    @override_attributes['redborder']['snort']['groups']['0']['bindings']['0'] = {}
    @override_attributes['redborder']['snort']['groups']['0']['bindings']['0']['network_objects'] = {}
    @override_attributes['redborder']['rsyslog'] = {}
    @override_attributes['redborder']['rsyslog']['servers'] = []
    @override_attributes['redborder']['proxy'] = {}
    @override_attributes['redborder']['manager'] = {}
    @override_attributes['redborder']['mailrelay'] ||= {}
    @override_attributes['redborder']['mailrelay']['mail_dissection_conf'] ||= {}
    @override_attributes['redborder']['mailrelay']['quarantine'] ||= {}
    @override_attributes['redborder']['mailrelay']['sync_cache'] ||= {}
  end

  #
  # Ignore al values and return always: value
  #
  def method_missing(_, _ = nil, _ = nil)
    @override_attributes['redborder']
  end

  #
  # Dig method! :D
  #
  def dig(*keys)
    override_value @override_attributes, *keys
  end

  #
  # Create a role
  #
  def create
    true
  end

  private

  def override_value(hash, *keys)
    if hash[keys.first] && keys.size == 1
      return hash[keys.first]
    elsif hash[keys.first] && hash[keys.first].is_a?(Hash)
      override_value(hash[keys.first], *keys[1..keys.size-1])
    else
      return nil
    end
  end
end
