require 'test_helper'

class ManagerTest < ActiveSupport::TestCase

  test "error when node doesnt exist" do
    Chef::Node.stubs(:load).raises(Net::HTTPServerException)
    manager = Manager.new("node-doesnt-exist")
    assert_nil manager.node, "Manager node should be nil"
    assert_nil manager.role, "Manager role should be nil"
  end

  test "returns the mode" do
    Chef::Node.stubs(:load).returns({
      'redborder' => {
        'mode' => 'master'
      }
    })

    # IMPROVE
    mock = mock('object')
    mock.stubs(:[]).returns(mock)
    mock.stubs(:override_attributes).returns(mock)

    Chef::Role.stubs(:load).returns(mock)

    manager = Manager.new("example-node")

    assert_equal manager.mode, 'master', "Manager should return its mode from Chef"
  end

end
