require 'test_helper'

class OverlayMapTest < ActiveSupport::TestCase
  context 'Basic operations' do
    setup do
      @overlay_map = overlay_maps(:admin_default)
      @overlay_map2 = overlay_maps(:admin_default2)
      @admin = users(:admin)
      User.current_user = @admin
    end

    should 'obtain lat ne' do
      coord = @overlay_map.lat_ne
      assert_equal(@overlay_map.ne.split(',')[0].to_f, coord)
    end

    should 'obtain lng ne' do
      coord = @overlay_map.lng_ne
      assert_equal(@overlay_map.ne.split(',')[1].to_f, coord)
    end

    should 'lat_sw' do
      coord = @overlay_map.lat_sw
      assert_equal(@overlay_map.sw.split(',')[0].to_f, coord)
    end

    should 'obtain lng sw' do
      coord = @overlay_map.lng_sw
      assert_equal(@overlay_map.sw.split(',')[1].to_f, coord)
    end

    should 'obtain image uri in several formats' do
      if StorageFile.s3_enabled?
        assert_instance_of(URI::HTTPS, @overlay_map.image_uri)
        assert_instance_of(URI::HTTPS, @overlay_map.original_image_uri)
        assert_instance_of(URI::HTTPS, @overlay_map.image_uri_small)
        assert_instance_of(URI::HTTPS, @overlay_map.original_image_uri_small)
      end

      assert_instance_of(String, @overlay_map.image_uri(controller: true))
      assert_instance_of(String, @overlay_map.original_image_uri(controller: true))
      assert_instance_of(String, @overlay_map.image_uri_small(controller: true))
      assert_instance_of(String, @overlay_map.original_image_uri_small(controller: true))
    end

    should 'set original image if nil' do
      @overlay_map2.save
      assert_instance_of(Paperclip::Attachment, @overlay_map2.original_image)
    end
  end
end
