require 'test_helper'

class ReportTest < ActiveSupport::TestCase
  should validate_presence_of(:name)
  should belong_to(:owner)
  should have_many(:widgets)

  context 'A report' do
    setup do
      @admin = users(:admin)
    end

    should 'be created with landscape orientation' do
      report = Report.new(name: 'Landscape report',
                          owner: @admin,
                          orientation: Report::ORIENTATION_LANDSCAPE)
      assert report.valid?
    end

    should 'be created with portrait orientation' do
      report = Report.new(name: 'Landscape report',
                          owner: @admin,
                          orientation: Report::ORIENTATION_PORTRAIT)
      assert report.valid?
    end
  end
end
