require 'test_helper'

class AddGlobalFiltersTest < ActiveSupport::TestCase
  context 'Global Filters' do
    setup do
      market = sensors(:market)
      @params = { sensor_uuid: market.uuid,
                  advanced: { '0' => { 'column' => 'application_id_name',
                                       'value' => 'http' } } }
    end

    should 'be added' do
      session = {}
      AddGlobalFilters.call(session, @params)

      assert session[:global_filters]
      assert_equal session[:global_filters][:sensor_uuid], @params[:sensor_uuid]
      assert_equal session[:global_filters][:market_uuid], @params[:sensor_uuid]
      assert session[:global_filters][:advanced]
      assert session[:global_filters][:advanced]['0']['column']
      assert_equal session[:global_filters][:advanced]['0']['column'], @params[:advanced]['0']['column']
    end
  end
end
