#
# Helper methods to check models
#
module ModelsSupport
  #
  # Check if the current model is not valid and validation error fields.
  #
  # == Parameter:
  # model::
  #   Initialized model
  # fields::
  #   Fields to check if are included in errors
  #
  # == Returns:
  # Perform multiple assets
  #
  def check_errors(model, fields)
    lfields = Array(fields)
    assert_not(model.valid?, "#{model.class} must validate basic fields")
    # Check fields
    lfields.each do |f|
      assert(model.errors.messages.keys.include?(f),
             "An error must be attached to #{f}")
    end
  end
end
